-- SEE ./doc/Manual.htm FOR MORE DETAILS --
-- SEE ./README FOR MORE CONCISE RELEASE NOTES --
-- SEE http://www.delegate.org/delegate/updates/ FOR THE LATEST CHANGES --

9.9.12 rel-140817n 9.9.12-pre1 release --------------
9.9.12 ref-140817m syncronized between 9.9.12-pre1 and 10.0.0-pre1
9.9.12 new-140817l ssi.c: intrdouced <!--#echo var=STACK_DEPTH -->
9.9.12 new-140817i filter.c: introduced -tee-y option like -t but with year prefix
9.9.12 fix-140815a cgi.c: stop inheritance of TMPFILE buffer for SHTML from CGI
9.9.12 fix-140814e url.c: corrected making #label be absolute with <BASE> tag (result of new-140727m)
9.9.12 fix-140814c httpx.c: coped with SSI loop in virtual URL (if loop in MOUNT with moved exists)(result of fix-140810e)
9.9.12 new-140813e ssi.c: include HTML text as plain-test by <!--#include virtual=URL#plaintext --> 
9.9.12 new-140813d ssi.c: include text asis by <!--#include virtual=URL#asis -->
9.9.12 fix-140813c ssi.c: fixed "#plainpre" to make it work
9.9.11 rel-140813b 9.9.11 release --------------
9.9.11 rel-140813a 9.9.11-pre3 release --------------
9.9.11 new-140812a {http,url}.c: automatic absolutization of "?query" without script name
9.9.11 new-140810f url.c: rewriting response URL based on VBASE
9.9.11 mod-140810e ssi.c: made SSI include use virtual URL by default
9.9.11 new-140810d {ssi,ddi}.c: push/pop VBASE before/after SSI
9.9.11 doc-140810b Manual.htm: modified to use ${SELF} and ${VBASE} to be able to rename
9.9.11 fix-140810a httpx.c: prevented possible stack overflow by deep SSI recursion
9.9.11 new-140809h url.c: introduced ${SELF} prefix for URL to be substituted with self url
9.9.11 new-140809f ssi.c: introduced <!--#config var=VBASE val=URL --> to be used in url.c
9.9.11 new-140809e url.c: introduced ${VBASE} prefix for URL to be substitued with defined VBASE
9.9.11 new-140809d ssi.c: made <PRE> for included plain test by the style "#plainpre"
9.9.11 new-140809c ssi.c: introduced ${QUERY_STRING} and ${QUERY_STRING?sring} in virtual url
9.9.11 fix-140808b ssi.c: convert URLs in included HTML to full-url to be reverse MOUNTed
9.9.11 mod-140807j httpd.c: link "[ALL]" to "base.html?.whole#label"
9.9.11 rel-140807i 9.9.11-pre2 release --------------
9.9.11 fix-140807b {bcounter,cache}.c: removed "VStr overflow" with COUNTER enabled
9.9.11 fix-140803i dgsign.c: fixed -Fimp to work (broken in v9.9.7-pre24)
9.9.11 fix-140731c {ssi,httphead}.c: SSI virtual url mapping as virtual host
9.9.11 new-140730d httpd.c: inherit <META> tag for each part
9.9.11 new-140728j httpd.c: introduced ".whole" part as Manual.htm?.whole
9.9.11 rel-140727r 9.9.11-pre1 release --------------
9.9.11 fix-140727f ssi.c: suppressed rewriting to full-url for local resouces included by SSI
9.9.11 fix-140727a httpd.c: fixed MOUNT="/vpath/* cgi:/rpath/*" for CGI with/without /extra/path like script.cgi/extra/path?query (broken in 8.6.0 030522)
9.9.11 fix-140726a {http,httphead}.c: partializing URL in HTML response included by SSI
9.9.11 fix-140725a httpd.c: added ".htm" to "executable" file, for SSI
9.9.11 new-140724i httpd.c: removing comment in part filter
9.9.11 new-140724h httpd.c: include <STYLE> in the HTTP part filter
9.9.11 fix-140724f http.c: fixed rewriting MOUNTed URL around the input buffer boundary
9.9.11 mod-140724e Manual.htm: made Manual more readable with CSS
9.9.11 new-140723d binary-distribution: added linux2.6_32-dgX_Y_Z
9.9.11 fix-140722c ftp.c: shown size of uploaded data to local-file larger than 4GB in response message and LOGFILE
9.9.11 fix-140722b ftp.c: putting PROTOLOG(xferlog) for upload (STOR) to local-file
9.9.10 rel-140721f 9.9.10 release --------------
9.9.10 fix-140721d httpx.c: really fixed fix-140720b
9.9.10 mod-140721a delegated.c: added thru-CONNECT for google.com, gogle.co.jp, and facebook.com
9.9.10 rel-140720e 9.9.10-pre3 release --------------
9.9.10 mod-140720d http.c: really included mod-140716d and mod-140716e
9.9.10 fix-140720b httpx.c: forwarding and logging original User-Agent (not DeleGate/SERVER_VER) for SHTML
9.9.10 rel-140716h 9.9.10-pre2 release --------------
9.9.10 mod-140716e http.c: longer HTPCONF=tout-pack-intvl:10.0 in SSLtunnel (<- 3.0)
9.9.10 mod-140716d http.c: disabled tentative "non half-duplex" detection & rejection over SSLtunnel (re-enabled by HTTPCONF=halfdup)
9.9.10 fix-140715c socks.c: SEGV with SERVER=socks plus FORWARD= with CONNECT=s
9.9.10 fix-140715b service.c: could not relay non-HTTP (HTTPS) by PROXY or FORWARD (9.9.8-pre21)
9.9.10 mod-140714a caps.c: changed the RSA key-pair for RSA-signed-CAPSKEY
9.9.10 fix-140704a dl.c: added DYLIB=cyg%s-0.9.8.dll for yysh client on Cygwin with STLS=fsv or -ys
9.9.10 rel-140701b 9.9.10-pre1 release --------------
9.9.10 mod-140630c dl.c: added lib{ssl,crypto}.so.10 for CentOS6.5
9.9.10 fix-140630a X.c: setting SHELL by /etc/passwd when invoked by cron (or inetd or so)
9.9.10 mod-140626i windows.c: set OWNER=curent-user-name for yysh on Windows
9.9.10 new-140626g {winmisc,netsh}.c: no-echo to get password on Windows
9.9.10 new-140626b X.c: yysh periodic sending of TTySize for keep-alive (-tiT option, T=60 bydefault)
9.9.10 fix-140626a netsh.c: a workaround to let HOME env. be inherited on Windows
9.9.10 mod-140625e netsh.c: inherit no opened resources (as socket) to shell
9.9.10 fix-140625d netsh.c: dgforkpty did not work on Windows (since 9.9.7-pre23)
9.9.10 fix-140625c Makefile,link-libs.sh: building on Cygwin (on D: drive)
9.9.9 rel-140616b 9.9.9 release --------------
9.9.9 fix-140615h mime.c: SEGV on NNTP POST without CHARCODE (140605c)
9.9.9 fix-140615e dgauth.c: don't FATAL error by AUTHORIZER="-dgauth{user:pass}" and don't erase CRYPT=pass:xxxx
9.9.9 new-140615b windows.c: version and SERVER info. into Windows service description
9.9.9 fix-140613b dgauth.c: fixed 2 bytes of buffer overflow by bcopy (9.8.2)
9.9.9 new-140613a {ssleay32,libeay32}.dll: bandled OpenSSL-0.9.8za into win32-dg.zip
9.9.9 fix-140610h windows.c: don't create new console on CYGWIN (if isatty(0)!=0)
9.9.9 rel-140609i 9.9.9-pre2 release
9.9.9 fix-140609d cfi.c: fixed duplicated ".CRLF" for pipelined responses
9.9.9 fix-140609c cfi.c: don't put generated header for BODY only filter
9.9.9 fix-140609b cfi.c: erased "VStr overflow" on NNTP BODY filtering by CFI
9.9.9 fix-140609a cksum.c: -Fcksum freezes with "-f srcfile" by nonexistent srcfile
9.9.9 new-140608c windows.c: introduced SERVCONF="name:xxxx" and "yesall"
9.9.9 fix-140607c svport.c: -Pxxx/tcp with SERVER=udprelay on Windows service
9.9.9 fix-140607b svport.c: distinguish -Pxxx[/udp] from -Pxxx/tcp as service name on Windows <Nacho>
9.9.9 new-140606k config.h: don't detect modification of config.h as spoofing
9.9.9 new-140606b mimehead.c: catenating e-words of the same charset in base64
9.9.9 fix-140606a mimehead.c: removed ISO-2022 space control code in non-ISO-2022-JP
9.9.9 fix-140605d mimehead.c: removed dust generated into MIMEencoded-word
9.9.9 mod-140605c mime.c: char. code conv. for multipart head. with CHARCODE=Chset:tosv
9.9.9 fix-140605b {cfi,rfc822}.c: coped with Output/Content-Type to make header larger
9.9.9 fix-140603b {cfi,rfc822}.c: enlarged acceptable MIME header (128K <- 64K)<t-okuda>
9.9.9 fix-140603a ftp.c: make relative path only if under cur. dir <Nagakura>
9.9.9 mod-140602f sslway.c: made SSLv2_* optional by OPT(0) (for OpenSSL/1.X) <Albert>
9.9.9 new-140602e dl.c: added lib*.so.1.0.0 for OpenSSL nowadays
9.9.12 fix-140530f ssi.c: guessing the Content-Type of <!--#include --> of local file
9.9.9 fix-140529c src/Makefile,embed.c: exluded "AppleDouble encoded Macintosh file" of which name begins with "._" from builtin-data
9.9.9 mod-140522a caps.c: longer CAPSKEY expiration (1 -> 4 weeks)
9.9.9 rel-140519- 9.9.9-pre1 release
9.9.9 new-140518m inets.c: auto. detect and exclude inactive NIS from RESOLV
9.9.9 mod-140518e http.c: introduced HTTPCONF=max-ssl-turns:100 (was 6+max-cka*2)
9.9.9 mod-140518d http.c: increased HTTPCONF=max-cka:20 to max-cka:50
9.9.9 mod-140518c http.c: HTTPCONF=max-pack-intvl from 0.3 to 3.0
9.9.9 new-140518b {http,nbio}.c: introduced -Esp to peek SSL packets over SSL-tunnel
9.9.9 mod-140518a {http,http}.c: disabled tentative non-SSL blocking over SSL-tunnel (enabled by -Esb)
9.9.9 fix-140515b httphead.c: returning Moved To "http://-.-/dir" as a proxy
9.9.9 new-140514a dgauth.c: error log of non-writable CRYPT file

9.9.8 mod-140512b arthead.dhtml: <FONT face="courier new"> for NNTP/HTTP gw. article
9.9.8 fix-140512a {unix,_-system,__system}.c: compilation on Solaris11 (gcc 4.8.2)
9.9.8 mod-140511c windows.c: seeing LANG env. val. for guessing isatty()
9.9.8 new-140511b windows.c: kind info. for starting as service under Administrator's right
9.9.8 mod-140511a windows.c: retrying 10 times to create service for DeleGate
9.9.8 fix-140509h windows.c: erased "FATAL accept" debug log on Win (9.9.7-pre26)
9.9.8 fix-140509f dgsign.c: keep the file modification time after -Fesign -w
9.9.8 mod-140509d delegated.c: suppressing PORT parameer for for non-daemom (-Fkill)
9.9.8 fix-140509c delegated.c: enabled DGPATH for +=paramsFile for -Ffunc (ex. -Fkill)
9.9.8 new-140509b conf.c: if ${STARTDIR}/DGROOT exists, use it as DGROOT
9.9.8 new-140509a delegated.c: immediate disconnection by SCREEN with -Eri
9.9.8 fix-140506d ftp.c: fixed one-time PASV error after PORT failure
9.9.8 mod-140506c {reshost,env}.c: introduced timeout in yp_match() for RESOLV=nis (TIMEOUT=nis:T)
9.9.8 fix-140506a ftp.c: fixed FTPxHTTP failure on the first command after CWD (by un-initialized var.)
9.9.8 new-140504j {smtp,nntpgw}.c: introduced SMTPCONF=mladmin:E-mail for Sendpass in "Forward" button
9.9.8 new-140504i {smtp,nntpgw}.c: introduced SMTPCONF=mlsolt:Solt for Sendmail password encodeing
9.9.8 new-140504h {smtp,nntpgw}.c: introduced SMTPCONF=mlhost:MlHostName
9.9.8 new-140504g httpd.c: returning ETag response header for builtin icons
9.9.8 mod-140504f {httpd,htmlgen,conf}.c: returning real Last-Modified time of builtin icons
9.9.8 fix-140504e builtin.c: getting modified date of builtin icons
9.9.8 new-140504c nntpgw.c: Pragma: no-cache for Sendmail/Sendpass
9.9.8 new-140504b nntpgw.c: introduced "Sendpass" to send password for Sendmail
9.9.8 new-140504a nntpgw.c: introduced "Sendmail" for forwarding article from NNTP/HTTP
9.9.8 new-140503a make-vs8ce_win8.bat: coped with makeing by VS8 on Win8
9.9.8 fix-140502h windows.c: isatty()=1 if environment SESSIONNAME=Console is set
9.9.8 fix-140502f rsasign: don't put debug info. (# RSASIGN #) into esign (9.9.8-pre2?)
9.9.8 mod-140502e wince.c: moved the default port of win32-dg.exe from -Q80/http to -Q2080/http
9.9.8 fix-140502d http.c: erased warning of casting in fPollIn() arg from double to int
9.9.8 new-140502c Makefile,make-vs8_win8.bat,link-win32_win8.sh: coped with making by Visual Studio 8 on Windows 8
9.9.8 fix-140502b srcsign: coped with sh+echo that interpret echo "\\n"

9.9.8 fix-130723a svport.c: fixed VStr overflow by receiving long host name in addres buffer
9.9.8 fix-130722a vaddr.h: coped with hostname longer than 70 characters (for Windows Azure)
9.9.8 fix-130629a Makefile: added "-lutil" after libsubst for forkpty (Ubuntu)
9.9.8 fix-120313a httphead.c: suppress Set-Cookie rewriting by URICONV <Nicholas>
9.9.8 fix-120202a master.c: SockMux in background (9.9.0-pre2) -> beDaemon() -> wait -> Finish
9.9.8 fix-120131a service.c: don't SOCKS by FORWARD by non-circuit-level proxy
9.9.8 new-111110a sslway.c: showing current cipher desc. with TLSCONF=-vd <Sieveking>
9.9.8 fix-110921a sftp.c: must skip multiple prompts for a mal-password with multiple auth. method
9.9.8 110521d new ftp.c: introduced CMAP="/:FTPWD:ftp:*:*" <k.sasaki>
9.9.8 110521c fix http.c: relaying POST body with fork(), without buffered in.
9.9.8 110513a fix http.c: relaying chunked body of POST <ishihara>
9.9.8 110318a fix credhy.c: detecting bad length of decrypted data
9.9.8 110115 new xflash.c: a geteway for X11-client to Flash as a X server
9.9.8 101227 fix http.c: suppressed VStr overflow for long "Accept-Encoding"
9.9.8 101226 fix mount.c: MOUNT for a HTTPS server with "nvserv" <kondo>
9.9.8 101111 fix sftp.c: introduced waitput=T MountOption for sftp/FTP gw.
9.9.8 101111 fix pop.c: coped with STLS=fcl + SERVER=pop (not SERVER=pop://serv)
9.9.8 101111 new env.c: connection cache shorten by TIMEOUT=cc:T
9.9.8 101111 fix sftp.c: termination on disconnection from SFTP server <vijay>
9.9.8 101107 fix stls.c: enabled STLS=fsv:"ftps" as well as STLS=fsv:"ftp"
9.9.8 101107 fix {sslway,filters}.c: fixed uploading with STLS=fsv,fcl <sf02>
9.9.8 101107 fix {sslway,filters}.c: fixed jamming of socket fd for FSV+FCL
9.9.8 101106 fix ftp.c: fixed slow upload (16sec.) by FTP/SSL with PORT
9.9.8 101106 new ftp.c: FTPCONF="waitssl" to wait SSL before 150 as origin FTP
9.9.8 101031 fix dget.c: waiting uploading complete (by STOR -Fdput ftp://sv)
9.9.8 101031 fix ftp.c: fixed SEGV on upload (STOR) with cached file (6.0.1)
9.9.8 101031 fix ftp.c: STOR as an origin FTP with client over SSL
9.9.8 101013 fix iotimeout.c: VStr-overflow by "Manual.htm?.parts" (pre15)
9.9.8 101011 new stls.c: SERVER=ftps + STLS=fcl:ftps and STLS=fsv:ftp
9.9.8 101004 new pds/regex/*: included "regex" library of H.Spenser
9.9.8 101002 new env.c: added DYCONF=conditions:configuration
9.9.8 100930 fix ntod.c: fixed SEGV with searching 255.255.255.255.in-addr.arpa
9.9.8 100930 fix http.c: dst=xxx MountOption for CONNECT (pre15)<suzuki_h>
9.9.8 100927 fix windows.c: recognition of isatty() on CYGWIN via yysh
9.9.8 100926 fix iotimeout.c: larger fgetsBB() buff. (5.5.0)(enbug by "-Bis")
9.9.8 100925 fix iotimeout.c: fixed slow text relay by pollIZ() (9.9.1-pre5)
9.9.8 100925 fix {nbio,_-select,_-poll}.c: faster IsAlive() without 1ms delay
9.9.8 100925 fix mount.c: multi-thread safer MOUNT
9.9.8 100925 fix String.c: multi-thread safer Strdup()
9.9.8 100925 fix http.c: leave Cont-Leng on slow resp. with "guess" (8.1.0)
9.9.8 100925 fix cgi.c: broken binary CGI resp. with CHARCODE=guess (9.5.0p12)
9.9.8 100924 fix X.c: increased LISTEN for -yf (from 1 to 15)
9.9.8 100921 fix Strftime.c: fixed SEGV on unexpected date format string
9.9.8 100920 fix ftp.c: FTPxHTTP STOR via HTTP-PROXY (POST without Cont-Leng)
9.9.8 100920 fix {ftp,ftpgw}.c: RETR,SIZE,MDTM from FTP server via FTPxHTTP
9.9.8 100918 fix {svport,http}.c: coped with multi-port/off (-Qxx/off,-Qyy/off)
9.9.8 100918 new delegated.c: mux. over YYMUX in a single process DeleGate
9.9.8 100915 new httpd.c: reusing YYMUX connection to servers from SSI #include
9.9.8 100911 fix hostlist.c: matching user in HOSTLIST="Name:user@ahost"(8.0.6)
9.9.8 100905 new http.c: enabled MOUNT="hpPattern = forbidden" for CONNECT
9.9.8 100905 fix resconf.c: scanning "search" list separated by "," <takamori>
9.9.8 100904 fix X.c: removed "YYMUX" log for FTP data-connection (9.9.7)
9.9.8 100904 mod ftp.c: reject FTP PORT bounce, FTPCONF=bounce:no <jacob>
9.9.8 100904 new ftp.c: force EPRT with serv. by FTPCONF=doeprt:sv
9.9.8 100823 new ftp.c: force EPSV with serv. by FTPCONF=doepsv:sv <jimbob>
9.9.8 100814 fix {http,delegated}.c: be StickyServer after CONNECT (9.8.2-p5)
9.9.8 100809 fix http.c: imm. exit of HTTP relay+cache if with "takeover:0"
9.9.8 100809 new delegated.c: SCREEN=reject,accept and ETCDIR/hosts.d/reject
9.9.8 100808 new {hostlist,inets}.c: "Name.mac.list.-" and "Name.ip4.list.-"
9.9.8 100807 fix http.c: don't apply default URL rewriting for MITM <takamori>
9.9.8 100801 new {resolv,dnsnode}.c: expiring DNS-RR cache on mem. by the TTL
9.9.8 100801 new inets.c: intrduced RES_EXPIRE=F/M/R to expire resolv. cache
9.9.8 100723 fix resolv.c: don't on mem. cache for response RR from SERVER=dns
9.9.8 100721 fix delegated.c: proxying DNS by UDPerlay with PERMIT <sarai>
9.9.8 100718 new smtpgate.c: loading SMTPGATE/admin/@common/conf if it exists
9.9.8 100714 fix smtp.c: don't repeat (reuse cached) EHLO after STLS <jdiego>
9.9.8 100707 add url.c: rewriting URL in (') escaped as "&#39;"
9.9.8 100704 fix X.c: fixed thread leak salvaging HTTP via YYMUX over HTTP/yysh
9.9.8 100703 fix httpx.c: SEGV by NULL ptr. on NNTP/HTTP Admin (pre2)
9.9.8 100627 fix udprelay.c: fixed SERVER=dns://host:port on BSD
9.9.8 100627 fix X.c: don't try waiting for startup of ending YYMUX
9.9.8 100627 fix X.c: mutual exclusion for YYMUX alloc/free
9.9.8 100626 fix X.c: mutual exclusion adding YYMUX
9.9.8 100620 fix _-fcloseFILE.c: multi-thread safe fcloseFILE on BSD (pre6)
9.9.8 100620 fix admin.c: scanning uptime with LANG except LANG=c <suzuki_h>
9.9.8 100613 mod nbio.c: don't shorten timeout for CONNECT in HTTP/yyshd
9.9.8 100612 new master.c: "-" prefix for exact protocol matching for SRCIF
9.9.8 100611 new resolv.c: binding DNS resolver port with SRCIF=H:P:dns <chris>
9.9.8 100609 fix X.c: salvaging YYMUX in a single process (as in HTTP/yyhsd)
9.9.8 100604 fix X.c: relaying YCNCT via YYMUX via YYMUX
9.9.8 100603 fix X.c: sweeping YYMUX in shutdown status (by HTTP/yysh server)
9.9.8 100603 fix sftp.c: failure in "Too many open files" <vijay>
9.9.8 100530 new delegated.c: LOGDIR/PORT.http for HTTP/yysh
9.9.8 100529 fix {Makefile,*.c}: making mimekit,resolvy,ntod,ccx,credhy,bdtee,.
9.9.8 100527 fix Makefile,dgctx.h: consistency checking for "Connection"
9.9.8 100527 fix filter.c: revival of FSV="sslway -cert file"(9.9.7-pre1)<rauh>
9.9.8 100526 add {ftp,httpd}.c: supported MLST and STAT via FTPxHTTP
9.9.8 100523 fix smtpgate.c: clear YYMUX on SMTP disconn. (to supp. SIGPIPE)
9.9.8 100523 fix smtp.c: fixed BCC via YYMUX (poll err. by EINTR/SIGPIPE)
9.9.8 100523 mod ddi.c: ignore death of server proc. with multi-session threads
9.9.8 100523 fix X.c: fixed conn. failure (fdopen err.) after SIGINT
9.9.8 100523 fix {delegated,windows}.c: enabled -Fkill for foreground/Win32
9.9.8 100522 fix log.c: fixed server pid in PIDFILE on Win32 (-xx)(9.0.6-pre3)
9.9.8 100521 mod delegated.c: stopped doing randfd() in AcceptByMain
9.9.8 100520 fix {file,delegated}.c: closing /dev/null on HUP <kusunoki>
9.9.8 100520 fix sftp.c: login failure (9.9.7-pre33)<harano>
9.9.8 100519 fix Strftime.c: don't inherit f.d. for localtime() on exec (HUP)
9.9.8 100519 fix X.c: HTTP/yysh HTTPCONF=bugs:thru-304 without <=+=304
9.9.8 100518 new {ftp,httpd}.c: FTPxHTTP: FTP STOR by HTTP POST
9.9.8 100517 mod filetype.c: coped with long content-type name (> 64)
9.9.8 100516 mod timer.c: disabled Timer() with multi-threads
9.9.8 100515 fix {X,http}.c: multi-thread safe HTTP over yysh
9.9.8 100515 fix {X,ddi}.c: HTTP-proxy over yysh in keep-alive <corley>
9.9.8 100511 new X.c: forwarding ftp-data (by YCNCT) over chained YYMUX
9.9.8 100509 new {ftp,ftpgw}.c: enabled SERVER=ftpxhttp MOUNT="/* ftp://serv/*"
9.9.8 100509 new {ftp,httpd,httpx}.c: forw. non-anonymous auth. via FTPxHTTP
9.9.8 100508 new {ftp,httpd}.c: FTPxHTTP by "ftpxhttp" protocol and MountOption
9.9.8 100508 fix fstat.c: space between mode and link count (for FTP LIST)
9.9.8 100502 fix spinach.c: imm. shut of CONNECT (no keep-alive)
9.9.8 100502 fix spinach.c: fixed SEGV on large request message with resolv
9.9.8 100501 new http.c: added HTTPCONF=bugs:thru-304 and "bugs:gen-304"
9.9.8 100501 fix spinach.c: fixed broken POST body (buffered without '\0')
9.9.8 100501 fix spinach.c: RELAY timeout after Content-Length:0 or 204 resp.
9.9.8 100501 fix spinach.c: fixed broken POST (or large GET) with slow resolv
9.9.8 100410 fix httphead.c: SEGV by HTTPCONF="methods:+,a,b" (9.0.3)<sengoku>
9.9.8 100408 new imap.c: redirecting to a IMAP server hinted in ALERT
9.9.8 100405 new url.c: detecting a URL in JavaScript as ({url:"..."
9.9.8 100404 new X.c: added MOUNT="/-/screen/* ..." on yysh server

9.9.7 100330 new smtp.c: supported "AUTH LOGIN" to serv. by MYAUTH <jdiego>
9.9.7 100329 new X.c: relaying to DNS resolver (dns://-.-) over YYMUX/YYSH
9.9.7 100329 fix *.c: printing 64bits pointer with "%X"
9.9.7 100328 new X.c: relaying POP,SMTP on YYMUX/YYSH (-yfd -yfp -yfm)
9.9.7 100327 new X.c: relaying UDP on YYMUX/YYSH (ex. -yf:53.udp:53.udp)
9.9.7 100327 new X.c: YYSH -yf[:port[/[host][/proto]]][:port[/[host][/proto]]]
9.9.7 100327 new X.c: HTTP proxy and SOCKS serv. by DeleGate (-yfh -yfs)
9.9.7 100326 new X.c: FTP serv. by DeleGate by default (-yf) w/o -yfServer
9.9.7 100325 new X.c: forwarding FTP over YYMUX/YYSH (-yf)
9.9.7 100324 fix X.c: fixed data truncation by yysh .get from Win32 (pre23)
9.9.7 100323 new dget.c: implemented "-Fdput ftp://user@host:port/path"
9.9.7 100322 fix X.c: fixed YYMUX server on WinCE (pre24)
9.9.7 100322 fix X.c: fixed disconn. with pending data with compression (-yz)
9.9.7 100321 fix ftpgw.c: don't make empty LIST cache "302 Moved" for dir.
9.9.7 100321 fix X.c: fixed suspended YYMUX/YYSH for VNC with Zlib (-yv -yz)
9.9.7 100320 fix X.c: fixed data truncation on Unix by -Fyysh .get
9.9.7 100320 mod ftpgw.c: mapping empty-resp. or 421 to 503 in FTP/HTTP g.w.
9.9.7 100319 mod nbio.c: relaxed "shorten timeout" with -d1+N (for SOCKS)
9.9.7 100318 new socks.c: connect to SOCKS via FORWARD=xxxx://host:port-_-socks
9.9.7 100318 fix smtp.c: refresh EHLO cache (AUTH) after STARTTLS <dai>
9.9.7 100317 fix thmain.c: too short timeout (5s) with -d1+N(WinCE)(9.9.7-pre1)
9.9.7 100316 fix X.c: fixed YYMUX flow control, excluding from select(in-fds)
9.9.7 100315 new X.c: simple YY proxy without Y-Connection
9.9.7 100314 new tcprelay.c: new SERVER=tcprelay2 (relaying by two threads)
9.9.7 100313 new X.c: relaying to VNC on the YYSH server (-yv)
9.9.7 100313 fix master.c: SEGV with SOCKSTAP or HTMUX=px or ICP (pre21)
9.9.7 100312 fix http.c: HTTP request MOUNT by -Pxxx/https/ssl without SERVER
9.9.7 100312 fix admin.c: acc. HTTPS by -Pxxx/https/ssl with non-HTTP SERVER
9.9.7 100312 fix dget.c: sending auth. by MYAUTH=u:p:https for a HTTPS server
9.9.7 100311 fix X.c: fixed loop in yysh ZCredhy (-yz) on RSM with YYMUX
9.9.7 100310 fix forkspawn.c: unset DYLIB_xxx environ. before forkpty(), SSI
9.9.7 100310 fix cgi.c: unset DYLIB_xxx environ. before CGI
9.9.7 100309 new X.c: slow YYSH disconn. with SSL (without STLS=fcl and -yX)
9.9.7 100309 fix {_-selet,_-poll}.c: don't regard conn. RESET as OOB
9.9.7 100309 fix nbio.c: fixed inf. loop in SSLtunnel on FreeBSD8 <imao>
9.9.7 100309 mod stls.c: longer timeout for SSL detection for -Qxxx/yymux/ssl
9.9.7 100308 new http.c: aded HTTPCONF=thru-type:+,application/microsoftpatch"
9.9.7 100308 new httpd.c: enebled adding HTTPCONF=thru-type:"+,"Type
9.9.7 100308 new X.c: introduced bi-directional auth. by YYKEY (based on RSA)
9.9.7 100307 fix X.c: fixed binary transmission by .get and .put on Win32
9.9.7 100307 fix X.c: sync. after interactive auth. (for -ys -yx -yy -yz)
9.9.7 100307 mod netsh.c: copy dgforkpty.exe to "C:/DeleGate/" and use it
9.9.7 100306 fix wince.c: win32-dg.exe invoking by non-ASCII exec. name (dir.)
9.9.7 100305 fix master.c: repaired auto. STLS for -Pxxxx/admin (since pre21)
9.9.7 100305 fix spinach.c: SEGV in FTP/HTTP g.w. by SERVER=http-sp (WinCE)
9.9.7 100304 new X.c: getting yysh auth. interactively from tty
9.9.7 100304 fix wince.c: invocation by click on Win32(without CLIENTNAME env.)
9.9.7 100304 fix X.c: yysh timeout in serv. disconn. with nested YYMUX over SSL
9.9.7 100304 fix gzip.c: re-loading DLL in child-process on CYGWIN
9.9.7 100303 fix __gethostbyname2.c: making on CYGWIN (1.7)
9.9.7 100303 fix X.c: re-enabled YYMUX (fcloseFILE() with fflush(), pre26)
9.9.7 100303 mod netsh.c: don't inherit descriptors except [0 1 2] to forkpty()
9.9.7 100302 fix netsh.c: relaying forkpty() without threads (for LinuxThreads)
9.9.7 100302 fix gzip.c: Zlib on OpenBSD (z_off_t in z_stream -> ver. error)
9.9.7 100302 fix cgi.c: removed VStr overflow with CFI
9.9.7 100301 new X.c: -yl to log display output to yysh.log (as "script")
9.9.7 100228 new sslway.c: new lib. for RSA encryption with simple interfaces
9.9.7 100227 fix gzip.c: suppressed repetitive loading and setup of Zlib
9.9.7 100227 fix netsh.c: fixed strange dup. echo in forkpty() + LinuxThreads
9.9.7 100227 fix gzip.c: fixed SEGV by yysh -yx when Zlib is not available
9.9.7 100227 fix netsh.c: doing "stty sane" before exec() for forkpty() on OSF1
9.9.7 100227 fix netsh.c: setegid() and seteuid() before exec() in dgforkpty
9.9.7 100226 new X.c: -yf and -yh to relay to client-side FTP and HTTP server
9.9.7 100225 fix X.c: mutex of fdopen()/fcloseFILE() to be multi-thread safe
9.9.7 100225 fix X.c: fixed broken Z-Credhy on partial fread()
9.9.7 100224 fix X.c: miss-detection of OOB by PRI reading from disconn. socket
9.9.7 100224 new X.c: -jX to apply JP CHARCODE conv. to "-Fyysh -jX command"
9.9.7 100223 new X.c: -yz to apply "deflate" by Zlib to YYSH
9.9.7 100222 new X.c: -yc to apply Credhy encryption to YYSH
9.9.7 100221 fix sslway.c: don't wirte 's' to fd[0] on SSL connect/accept error
9.9.7 100220 fix filter.c: fixed leak of terminated (SSLway) threads
9.9.7 100219 fix {X,service}.c: fixed coincident resumption of nested YYMUX
9.9.7 100218 fix filter.c: fixed jamming by parallel SSLway invocation
9.9.7 100218 fix X.c: resumption of nested YYMUX (yysh -yy via YYMUX) with STLS
9.9.7 100217 fix X.c: resumption of nested YYMUX (yysh -yy via YYMUX)
9.9.7 100216 fix X.c: yysh -yy resumption with STLS=fsv:yysh (not -ys)
9.9.7 100216 new X.c: YYSH .put and .get
9.9.7 100216 fix X.c: finishing YYMUX with thread-id with 32bits MSB (neg. int)
9.9.7 100215 fix X.c: breaking retrial of SockMux over YYMUX
9.9.7 100214 new {X,service}.c: -yyco and -yyac to apply YYMUX for any protocol
9.9.7 100214 new X.c: FTP PASV over YYMUX (as a sub-channel in YYMUX)
9.9.7 100214 mod X.c: removing duplicated dir. in PATH env.
9.9.7 100214 mod ftp.c: don't YYMUX data-conn. if cntrl-conn. is not via YYMUX
9.9.7 100214 fix ftp.c: coped with FTP ABOR (EINTR) via YYMUX
9.9.7 100213 fix X.c: fixed ftp-data conn. failure after YYMUX resumption
9.9.7 100213 fix X.c: fixed salvaging client-side list of active YYMUX sessions
9.9.7 100213 fix X.c: fixed resumption by a YYMUX client with YYMUX=host:port
9.9.7 100213 fix {conf,file}.c: finding full-path of executable (not directory)
9.9.7 100213 fix dgsign.c: loop in getting the MD5 of exec. (reading from dir.)
9.9.7 100213 new X.c: relaying OOB over YYMUX
9.9.7 100212 new X.c: X DISPLAY in AF_UNIX (-yxu) /tmp/.X11-unix/Xd DISPLAY=:d
9.9.7 100212 fix X.c: loop in SERVER=y11 + -Fy11 : xcom (pre24 DISPLAY, chain)
9.9.7 100212 new X.c: supported relaying FTP PORT connections on a YYMUX
9.9.7 100212 new inets.c: RESOLV="+" to detect auto. default even with -Fxxx
9.9.7 100211 mod inets.c: no resolver checking with WWW.DeleGate.ORG for -Fxxx
9.9.7 100211 mod inets.c: disabling RES_ORDER env. when RESOLV is specified
9.9.7 100211 new X.c: chaining X DISPLAY through chained yysh
9.9.7 100209 new X.c: enabled YYMUX resumption with auth. in Credhy
9.9.7 100209 fix X.c: resumption of YYMUX over YYSH with auth.
9.9.7 100209 fix X.c: fixed resumption of YYMUX for -Fyysh -yy or -yx
9.9.7 100209 new X.c: enabled STARTTLS (negotiated SSL) for YYSH (-ys)
9.9.7 100208 fix X.c: waiting YYMUX fin. over YYSH proxied by YYMUX
9.9.7 100208 fix X.c: don't start YYMUX serv. over YYSH in version mismatch
9.9.7 100207 fix X.c: terminating waiting YYMUX proxy on server-side disconn.
9.9.7 100206 new X.c: enabling Y11 over yysh (-yx) and YYMUX over yysh (-yy)
9.9.7 100206 fix X.c: coped with repetitive X connections more than 128th
9.9.7 100205 fix delegated.c: don't be Sticky with -Q6023/yysh SERVER=http
9.9.7 100204 fix {X,netsh}.c: freezing on SSL req. to non-SSL yysh serv./Win32
9.9.7 100204 fix spinach.c: fixed SEGV on accept() error by uninit. ptr.
9.9.7 100204 fix master.c: fixed SEGV in SockMux as a thread on OSF1/ALPHA
9.9.7 100204 fix X.c: applying SSL for YYMUX on a retrial in resumption
9.9.7 100203 new X.c: added Credhy key agreement + Authorization: Credhy-Basic
9.9.7 100203 new X.c: enabled YYCONF="SHELL:/bin/tcsh -l" "bash -l" or so
9.9.7 100203 fix {http,iotimeout}.c: TIMEOUT=io:0 caused unconditional timeout
9.9.7 100202 fix X.c: don't block disconn. of the YYSH conn. by b.g. proc.
9.9.7 100202 new X.c: smaller YYMUX buffer for yysh (Y-Max-Pending: nego.)
9.9.7 100202 new {_-select,_-poll}.c: PollIns immediate timeout by TIMEOUT_IMM
9.9.7 100202 fix X.c: fixed unfair YYMUX scheduling for input from FILE
9.9.7 100131 new passwd.c: trying getlogin() if getpwuid() is unavail.(MacOSX)
9.9.7 100130 fix *.{hc}: SEGV by 64bit data (as ptr.) with format spec as "%X"
9.9.7 100129 fix ystring.h: logging output (double float) on OSF/1 + ALPHA
9.9.7 100129 mod {dgforkpty,netsh}.c: minimum binary of dgforkpty.exe
9.9.7 100128 fix service.c: SEGV at start by fdopen() err. on unavail. mem.
9.9.7 100128 fix X.c: fixed SEGV by fd jamming with multi-threads (-d1+N)
9.9.7 100127 fix X.c: fixed the leak of memory and FILEs in SERVER=yymux
9.9.7 100127 fix netsh.c: exit on remote shutdown with dgforkpty
9.9.7 100126 new X.c: yysh with JP CHARCODE conv. (-je -ju -js -jj -jt)
9.9.7 100126 fix {netsh,windows}.c: no console win. for yysh win32-dg.exe
9.9.7 100126 fix netsh.c: dgforkpty.exe under dir. name including space
9.9.7 100126 new X.c: YYCONF=HOME:/home/user and YYCONF=SHELL:/bin/sh
9.9.7 100124 mod svconf.c: the default port# of yymux = 6060/TCP (<= 6011)
9.9.7 100124 fix netsh.c: terminating bash/CYGWIN on remote shutdown
9.9.7 100124 fix X.c: fixed YYMUX resumption error
9.9.7 100124 new X.c: introduced -Fyy yy:command together with SERVER=yy
9.9.7 100123 new X.c: internal yy commands {.lst .get .put .add} for yysh
9.9.7 100123 new X.c: serving as SERVER=yysh by SERVER=yymux
9.9.7 100123 new X.c: enabled YYMUX with -Fy11
9.9.7 100122 new X.c: supported YYMUX via SOCKS
9.9.7 100122 new netsh.c: key-input '~' followed by '.'
9.9.7 100121 new X.c: added AUTHORIZER SERVER=yysh and MYAUTH=user:pass:yysh
9.9.7 100121 fix {netsh,X}.c: sending window size change (in Telnet command)
9.9.7 100119 fix netsh.c: SEGV on OSF/1 and KuroBox (don't do syslog/daemonlog comsuming large stack in child thread)
9.9.7 100119 new netsh.c: pty/Win32 by dgforkpty/CYGWIN + DeleGate/Win32
9.9.7 100117 new dgforkpty.c: doing forkpty() in root privilege (for KuroBox)
9.9.7 100117 fix __forkpty.c: enabled forkpty() for NetBSD and OpenBSD
9.9.7 100117 new sgTTy.c: set/get tty mode and size (extracted from COSMOS)
9.9.7 100116 new X.c: yysh for Win32 (without tty control)
9.9.7 100115 new X.c: enabled -Fyysh host:port".ssl"
9.9.7 100115 fix X.c: YYMUX closing on YYCONNECT error
9.9.7 100114 new master.c: -Pxxxx in srcList of FORWARD=url-_-p:d:srcList
9.9.7 100114 new {inets,ftp}.c: relaying ftp-data conn. (PASV) via YYMUX
9.9.7 100114 fix {stls,service}.c: relaying ftp-data conn. as a MASTER over ssl
9.9.7 100114 fix {ftp,socks}.c: ftp-data conn. via upstream SOCKS over ssl
9.9.7 100114 new delegated.c: redirecting stdin in service to NUL (-Eni)
9.9.7 100113 fix delegated.c: stdout/stderr in service on Win32 (enbug -Bse)
9.9.7 100113 new delegated.c: added STDOUTLOG=file-pattern
9.9.7 100112 fix service.c: SERVER=Any with -Pxxx/delegate as SERVER=delegate
9.9.7 100112 new master.c: FORWARD=p://h:p/ssl and ROUTE=p://h:p/ssl
9.9.7 100112 new socks.c: enabled SOCKS=h:p/ssl or SOCKS=h:p/-5/-r/ssl
9.9.7 100112 new {X,master,service}.c: enabled YYMUX=h:p/ssl MASTER=h:p/ssl
9.9.7 100112 new {filter,stls,svport}.c: introduced -Pxx/ssl or -Pxx/proto/ssl
9.9.7 100111 new X.c: SERVER=yysh as a remote shell
9.9.7 100111 new {telnet,netsh}.c: SERVER=telnet://yytelnet.-
9.9.7 100110 new {ftp,ftpgw}.c: enabled HTTP MOUNT or -Fdget for ftps/STLS
9.9.7 100110 new service.c: enabled STLS=fsv:proto with MASTER
9.9.7 100109 fix stls.c: don't apply SSL for ftp-data with STLS=fsv:ftp
9.9.7 100109 fix delegate.h: multi-thread safe protocol conditional STLS
9.9.7 100109 fix filter.c: STLS=fsv:ftp,ftp-ddata matching (enbug "-Bsp")
9.9.7 100109 fix X.c: immediate shut on remote X command error
9.9.7 100109 new X.c: relaying stdin from local to remote X command (Unix)
9.9.7 100109 new X.c: relaying stdout from remote X command (on Unix only)
9.9.7 100109 fix X.c: 1st invocation freezes by an un-init. flag (pre20)
9.9.7 100108 fix X.c: waiting process with LinuxThreads (RedHat6,7,Vine4)
9.9.7 100108 new X.c: relaying stderr from remote X command (on Unix only)
9.9.7 100108 fix X.c: passing arguments to remote X command (pre19)
9.9.7 100107 new X.c: salvaging dangling processes at server-side
9.9.7 100107 new X.c: conditional/multiple YYMUX=host[:port[:proto:dst:src]]
9.9.7 100107 fix dget.c: enabled -Fdget STLS=fsv:proto with SOCKS
9.9.7 100107 fix socks.c: enabled SERVER=proto STLS=fsv:proto with SOCKS
9.9.7 100107 new X.c: enabled MYAUTH=user:pass:yymux (or y11)
9.9.7 100107 new X.c: enabled AUTHORIZER (Basic) for SERVER=yymux (or y11)
9.9.7 100107 fix X.c: breaking Sticky on SIGTERM with YYMUX
9.9.7 100106 fix {http,socks5,dget}.c: shutting YYMUX chan. normally on exit
9.9.7 100106 fix {ftp,nntp,pop,imap}.c: shutting YYMUX normally on SIGTERM
9.9.7 100106 fix nntp.c: SEGV in "ondemand" server (9.9.5)
9.9.7 100106 new X.c: supported STLS=fsv for YYMUX=server and -Fy11
9.9.7 100106 new X.c: supported STLS=fcl for SERVER=yymux and SERVER=y11
9.9.7 100106 new X.c: immediate rejection based on client's address
9.9.7 100105 new X.c: using DISPLAY env. as a local X server for Y11
9.9.7 100105 fix vsaddr.c: coped with =XXXX in .af-local (%3A0.launch-xxx...)
9.9.7 100105 fix X.c: yyMux trying relaying SHUT on SIGINT to YYproxy
9.9.7 100105 fix X.c: yyMux resuming via YYproxy
9.9.7 100103 fix X.c: yyMux start resuming after long idle with periodic ping
9.9.7 100102 fix X.c: yyMux coped with SIGPIPE for other thread with -d1+N
9.9.7 100102 fix X.c: yyMux resuming with non SERVER=yy (SERVER=http -Qxxx/yy)
9.9.7 100102 fix X.c: swift and normal exit on remote shutdown (on Win32)
9.9.7 100101 fix X.c: cleaning file and thread (for -d1+N multi-threads mode)
9.9.7 100101 fix X.c: swift but normal exit on local X process termination
9.9.7 091230 new X.c: YYMUX=host:port and CONNECT=y to connect via YYMUX serv.
9.9.7 091229 new X.c: -Fyy px//sv with SERVER=yymux to be used like -Fconnect
9.9.7 091229 new X.c: SERVER=yymux with resumption to replace SERVER=tcprelay
9.9.7 091227 new X.c: resending dropped data after resuming the Y11 connection
9.9.7 091226 new {yshell,wince}.c: HTTP based remote desktop controler for Win
9.9.7 091225 mod {http,master}.c: don't reject access to self by REMITTABLE=proto/port MountOption
9.9.7 091225 new wince.c: win32-dg.exe added -Q443/https on Win32
9.9.7 091225 new wince.c: win32-dg.exe enabled https://host/-/screen/ on Win32
9.9.7 091225 mod wince.c: win32-dg.exe force new console with -WC on Win32
9.9.7 091225 fix {windows,ystring}.c: coped with non-ASCII stat() and fopen()
9.9.7 091224 fix windows.c: broken environ. with non-ASCII value (dir. name)
9.9.7 091224 fix X.c: immediate exit and Y11 reset on X command error
9.9.7 091223 new wince.c: making process list on Win32
9.9.7 091223 new windows.c: X clients in b.g. without console and sockets
9.9.7 091222 new wince.c: "-WW" to force to be windows app.
9.9.7 091222 new wince.c: "-WC" to have console and "-WCA" for console app.
9.9.7 091222 new wince.c: assigning a console to win32-dg.exe
9.9.7 091222 new wince.c: win32-dg.exe with "SERVER=" as a console app.
9.9.7 091222 new wince.c: win32-dg.exe with "-F", "-f" as a f.g. console app.
9.9.7 091222 fix delegated.c: returning exit(code) from -Ffunc
9.9.7 091222 new X.c: -Fy11 {-ys|-yc} for Y11 coupler (Y11CQ)
9.9.7 091221 new X.c: rejecting command not begin with "x" nor include "X11"
9.9.7 091220 new X.c: interpretive Y11 proxy to detect non-Y11 protocol
9.9.7 091220 new X.c: proxying by -Fy11 "proxy//server"
9.9.7 091220 new X.c: local X client on the remote X server (-Fy11 : command)
9.9.7 091220 fix X.c: trial to close X for bash/xterm on CYGWIN
9.9.7 091218 mod X.c: STREAM buffered input from the multiplexed connection
9.9.7 091218 new X.c: version negotiation header "Y-Version:Y11R1"
9.9.7 091218 fix X.c: loop on EOS from X client (unsigned int)
9.9.7 091217 fix svport.c: enabled -Q1234/off in common.conf[.txt]
9.9.7 091217 new X.c: added a protocol to exchange the amount of pending data
9.9.7 091217 fix X.c: fixed getting broken packet on partial header recept
9.9.7 091217 fix X.c: SEGV on trial of reading huge data (invalid packet)
9.9.7 091217 fix X.c: fixed removing additional windows (relaying reset)
9.9.7 091217 fix X.c: fixed broken Y11 after an additional window connection
9.9.7 091217 fix {__pthread_create,__pthread_kill}.c: for AIX with -DQSC
9.9.7 091217 fix {___beginthread,__lwp_create,___lwp_create}.c: disabled
9.9.7 091217 fix pop.c: fixed POP proxy with AUTHORIZER=-man (9.9.6-pre7)
9.9.7 091216 fix _-strcasestr.c: a fix for AIX with -DQSC <Antonio>
9.9.7 091216 new X.c: made RELAY=y11 mandatory to work as a Y11 proxy
9.9.7 091216 fix {_-strcasestr,yp_match}.c: building with -DQSC on CYGWIN
9.9.7 091216 fix X.c: fixed freezing on a fast initial packt from X client
9.9.7 091216 new X.c: proxying Y11 by "Y11 y11://host:port/xcommand HTTP/1.1"
9.9.7 091215 fix *.c,file.h.c: huge empty file with -DSTAT64 -DQSC <suzuki_h>
9.9.7 091214 fix X.c: fixed SERVER=x://-.- and added SERVER=x://x.-
9.9.7 091214 fix file.h: coped with -DSTAT64 without C++ on Linux <suzuki_h>
9.9.7 091213 new X.c: enabled multiplexing a Y11 connection
9.9.7 091213 new X.c: SERVER=x://-.- to export the local X server
9.9.7 091212 new X.c: introduced "Y11" protocol, SERVER=y11 and -Fy11
9.9.7 091212 fix filter.c: fixed waiting filter command on Win32 
9.9.7 091212 new vsaddr.c: =XX in .af-local (X://X0.=2EX11-unix.tmp.af-local) 
9.9.7 091210 fix cgi.c: added unsetenv() declaration for HP-UX
9.9.7 091210 fix builtin.c: added allow_unaligned_data_access() for HP-UX cc
9.9.7 091210 fix spinach.c: fixed undef. ptr ref. on accept() err. in "http-sp"
9.9.7 091209 fix *.c: send_file() to Send_file() for AIX with -DQSC (9.0.5)
9.9.7 091209 fix ystring.h: enlarged CriticalSec & heapLock (32*(void*) <- 16*)
9.9.7 091209 fix {http,gethostbyname2,_-sysconf}.c: -DQSC on HP-UX (__hpux)
9.9.7 091207 fix spinach.c: binary POST over "http-sp"
9.9.7 091207 mod win32-dg.res: embedded icon of DeleGate
9.9.7 091205 fix windows.c: fixed waiting thread with timeout on Win32
9.9.7 091204 new wince.c: ported WinCE-version to Win32
9.9.7 091203 fix nbio.c: inf. "OOB?" on WinCE for CONNECT on -Q80 (9.9.6-pre2)
9.9.7 091203 fix mkmake.c: adding "-lm" in the detection of CC cap. on NetBSD
9.9.7 091202 fix _-strcasestr.c: for make with -DQSC on HP-UX
9.9.7 091202 new thmain.c: doing accept() by a single thread with -d1+N (WinCE)
9.9.7 091202 fix sslway.c: fixed host name for TLSxSNI to MOUNTed server <rauh>

9.9.6 091201 fix spinach.c: SEGV or broken logging on KuroBox "http-sp" (VARGS)
9.9.6 091129 fix sftp.c: coped with ABOR in LIST over sftp/FTP
9.9.6 091127 fix sftp.c: coped with slow resp. for LIST over sftp/FTP <vijay>
9.9.6 091127 fix Makefiile: don't use "-MT" option for CC on Unix
9.9.6 091126 new http.c: "-Ess" to reject non-HTTPS/SSL client via SSLtunnel
9.9.6 091126 fix delegated.c: clean-up X/Telnet sess. at Telnet fin.(9.9.5 -Xi)
9.9.6 091125 new pop.c: enabled AUTHORIZER for POP with "-map"
9.9.6 091125 new access.c: introduced AUTHORIZER=-map{inPat}{localPat}{fwdPat}
9.9.6 091123 fix mkmake.c: getting -DQSC in DELEGATE_CONF
9.9.6 091123 fix strcasestr.c: with -DQSC on Solaris
9.9.6 091123 fix file.h: -DQSC with -DSTAT64 on Linux <suzuki_h>
9.9.6 091122 new Makefile.QSC: a makefile to comple DeleGate without C++
9.9.6 091122 fix mkmake.c: fixed detection of avail. of ##,__VA_ARGS__
9.9.6 091122 fix mkmake.c: seeing LDFLAGS (as -MD) to detecting avail. lib.
9.9.6 091121 fix snprintf.c: for OSF/1 without snprintf()/vsnprintf()
9.9.6 091121 new ystring.h: making without C++ (with -DQSC)
9.9.6 091120 fix *.c: for compilation on OSF/1 (with -DNONCPLUS)
9.9.6 091120 fix inets.c: fixed SEGV in http-sp and -Ecc on Win32 (pre3)
9.9.6 091119 mod http.c: encoding the 405 response in quoted-printable
9.9.6 091119 new yshell.c: matching by AUTHORIZER="authServ:ysh:-:-Qxxxx"
9.9.6 091119 new conf.c: "-Dam" to disable auto. MAXIMA=delegated:N adjusting
9.9.6 091119 fix delegated.c: fixed SEGV on "/-/admin/logging" without -d1
9.9.6 091119 fix fpoll.c: compilation on Solaris10/SPARC with -m64 <fmontiton>
9.9.6 091118 mod syslog.c: erasing duplicated lines
9.9.6 091118 mod pam.c: trying dl-version of PAM (disabled by -Dpd)
9.9.6 091117 new sslway.c: cert. by addr. as CERTDIR/sa.xx.xx.xx.xx.pem
9.9.6 091117 new caps.c: notice about how to repaire "seems interpolated" 
9.9.6 091117 fix unsetenv_.c: unsetenv() for c++ / Solaris9 (9.9.4)
9.9.6 091116 new spinach.c: timeout of slow resp. and long idle keep-alive
9.9.6 091114 new spinach.c: faster Time() with GetTickCount() on WinCE
9.9.6 091114 fix spinach.c: don't timeout client-req. for Ecc (pre2)
9.9.6 091113 fix wince.c: removed useless log for close() and time() on WinCE
9.9.6 091112 new access.c: added AUTHORIZER="-fwd,..." to forward auth.
9.9.6 091112 new ftp.c: introduced MountOption "servon={init,user,pass}"
9.9.6 091111 new {inets,spinach}.c: sorting HOSTS cache by access frequency
9.9.6 091110 new {access,ftp}.c: introduced AUTHORIZER="-strip{@},..."
9.9.6 091110 fix httphead.c: SERVER=http://odst.-:- with PROXY <NoSFeRaTU>
9.9.6 091109 new spinach.c: /-/ysh/spinach to control spinach
9.9.6 091108 fix spinach.c: mutex among socket(),accept() and close()
9.9.6 091106 new spinach.c: connection timeout for idling client and server
9.9.6 091105 new spinach.c: flush pending input before doing close() socket
9.9.6 091104 new ident.c: "-DId" to completely disalbe the Ident protocol
9.9.6 091104 fix sox.c: fixed possible dup. invocation of closeQ() thread
9.9.6 091103 new nbio.c: implemented IsAlive() detection on WinCE
9.9.6 091102 new spinach.c: timeout for waiting request from a client
9.9.6 091102 new spinach.c: avoided delay in close() by select() peer's reset
9.9.6 091101 fix spinach.c: fixed stall in select() after connection error
9.9.6 091031 new spinach.c: sharing and reusing buffers between relays
9.9.6 091030 fix spinach.c: coped with "Proxy-Connection" (as Safari)
9.9.6 091028 fix spinach.c: disconn. client imm. after conn. err. to server
9.9.6 091027 fix spinach.c: discard dangling results from "Resolver" (pre2)
9.9.6 091026 fix spinach.c: fixed to close socket left after connection failure
9.9.6 091026 fix _-select.c: relaying OOB on Win32 (for Telnet)(9.4.0-pre4)
9.9.6 091025 fix spinach.c: fixed loop+stall on immediate connection failure
9.9.6 091024 fix spinach.c: immediate sweep of closed server in keep-alive
9.9.6 091023 new spinach.c: closing sockets by a background thread "Closer"
9.9.6 091023 new spinach.c: added a background thread for "Resolver"
9.9.6 091015 new sftp.c: "-Esf" applying SOCKS, SRCIF,... for conn. to sftp/SSH
9.9.6 091015 new smtp.c: SMTPCONF="bcc:x@y:*" or CMAP="x@y:SMTPBCC:*:*:*"
9.9.6 091010 fix hostlist.c: "-EHa" for access control for multi-homed host
9.9.6 091006 fix ystring.c: SEGV in dir. under /-/admin/ (9.9.4-pre11)<rghetta>
9.9.6 091004 fix caps.c: CAPSKEY for Win2K without a ServicePack
9.9.6 091002 fix spinach.c: "http-sp" file-descriptor jamming after recv()==0

9.9.5 090929 fix spinach.c: fixed thread-stack shortage in "http-sp" and -Ecc
9.9.5 090928 fix spinach.c: "http-sp" stall on long req. (head. or POST body)
9.9.5 090926 fix spinach.c: waiting HTTP req. EOH before resp. in "http-sp"
9.9.5 090926 fix {http,htmlgen}.c: putting vhost URL in "protocol error" mssg.
9.9.5 090925 new nntp.c: enabled MYAUTH=user:pass:nntp
9.9.5 090925 fix nntp.c: postpone the conn. to server with auth. <florent>
9.9.5 090924 new spinach.c: "http-sp" reusing keep-alive serv. on client reset
9.9.5 090923 fix nntp.c: fixed loop in hostcmpX() without NNTPCONF="ondemand"
9.9.5 090923 fix _-mutex.c: revival of mutex on Unix (9.9.4-pre9)
9.9.5 090923 new nntp.c: added GROUP cache (not by ACTIVE LIST cache)
9.9.5 090920 new nntp.c: introduced NNTPCONF="ondemand" and MountOption
9.9.5 090918 fix smtp.c: EHLO before STARTTLS for SERVER=smtp://serv STLS=fcl
9.9.5 090917 fix socks5.c: SEGV by RES_NS=x.x.x.x//y.y.y.y on SOCKS err.(9.8.2)
9.9.5 090917 new socks5.c: SRCIF=clif.-:0:socks-udp-tocl not to retry bind()
9.9.5 090917 new socks5.c: SRCIF=0.0.0.0:0:socks-udp-tosv to be RFC compliant
9.9.5 090917 fix socks5.c: coped with UDP ASSOC with DST.ADDR/PORT = 0.0.0.0:0
9.9.5 090917 fix spinach.c: don't reset clnt unexp. on unknown serv. or timeout
9.9.5 090916 new spinach.c: suported connection-timeout in "http-sp"
9.9.5 090915 new spinach.c: light select/read/write by cached handle/fd on Win
9.9.5 090915 new wince.c: auto. SYSLOG to 192.168.*.255 if exists
9.9.5 090914 fix smtpgate.c: coped with CAPSKEY request in quoted-printable
9.9.5 090913 fix spinach.c: /-/builtin/icons/ for "http-sp"
9.9.5 090913 fix iotimeout.c: removed overhead by fgetBuffered() on WinCE
9.9.5 090913 fix wince.c: fixed lost data by freadTIMEOUT() on WinCE
9.9.5 090913 fix wince.c: implemented fgetsByBlock() from tmpfile() on WinCE
9.9.5 090911 new spinach.c: enabled FTP/HTTP gw. by "http-sp" (with -d1+N)
9.9.5 090910 fix iotimeout.c: fixed slow cache read on Win (0.2sec. / 4KB text)(9.9.1-pre5)
9.9.5 090910 fix http.c: coped with thread-gzip on Win95 (poll for pipe)
9.9.5 090910 fix windows.c: coped with mutex on Win95 (no TryEnterCriticalSec.)
9.9.5 090910 fix windows.c: coped with thread waiting on Win95 (negative tid)
9.9.5 090910 new ftp.c: added FTPCONF="nopasv,doepsv" to accept EPSV only
9.9.5 090910 fix http.c: fixed possible SEGV in a single-process mode (-d1)
9.9.5 090909 fix http.c: frozen gzip thread on Win2K (9.8.2-pre15)<T.Akiyama>
9.9.5 090908 new ftp.c: added FTPCONF=noepsv to stop announcement of EPSV
9.9.5 090907 mod wince.c: changed to "-Q8080/http-sp" from "-Q8080/http" (dflt)
9.9.5 090906 new inets.c: "-Edr" to set DONTROUTE to local-segment (WinCE)
9.9.5 090906 new spinach.c: supported dial-up on connect() failure in "http-sp"
9.9.5 090905 fix resolv.c: "-Ens" to inactivate (sorting) no-resp. DNS server
9.9.5 090901 mod wince,winmo.c: displaying IP-address of WiFi and Modem at HOME
9.9.5 090901 new spinach.c: pool and reusing HTTP server in keep-alive
9.9.5 090829 fix http.c: has been so slow for 304 resp. with Content-Length in proxy keep-alive with Safari (-Bcs)
9.9.5 090829 fix spinach.c: supported switching servers in a keep-alive client
9.9.5 090829 fix spinach.c: http-sp relay after immediate connect() success.
9.9.5 090827 fix delegated.c: finishing f.g. -d1+N on Win32 (before WinXP/SP2)
9.9.5 090827 fix windows.c: fixed http://WinCE/-/screen/ + gzip (9.9.4-pre8)
9.9.5 090826 fix http.c: fixed truncation by bad Content-Length in gunzip/FTOCL
9.9.5 090825 new svconf.c: "http-sp" for HTTP simplified proxy instead of "ecc"
9.9.5 090823 new spinach.c: -Ecc option for multi-session threads(-d1+N)(WinCE)
9.9.5 090823 new spinach.c: adding lacking Host: header in HTTP/ecc relay
9.9.5 090823 new spinach.c: added -Q8888/ecc for WinCE
9.9.5 090822 fix http.c: revival of HTTP for WinCE (9.9.4-pre10)
9.9.5 090821 fix htaccept.c: possible freeze in restart on HTMUX server reboot
9.9.5 090820 mod ftp.c: "-Efp" reusing the same port num. for PASV repetitively
9.9.5 090819 fix src/Makefile: upd. ADMIN in auto. -Fimp from src/DELEGATE_CONF
9.9.5 090819 new delegated.c: "-Xi" to force imm. _exit() on SIGTERM
9.9.5 090819 fix delegated.c: Telnet server stopped with "x" (9.8.2)<castillon>
9.9.5 090819 fix delegated.c: X/Telnet does not start without built-in ADMIN
9.9.5 090818 fix ftp.c: don't reuse PASV port disconnected by the client
9.9.5 090817 new inets.c: -Dfb to suppress binding port# in FTP PASV client
9.9.5 090815 new ystring.c: -dr to test error code(return value) from functions
9.9.5 090815 fix delegated.c: possible SEGV in execFunc() to "%X" on Win64
9.9.5 090815 fix *.c: possible SEGV with printf/scanf "%X" for 64bits pointer
9.9.5 090814 fix htmlgen.c: fixed SEGV with verify=crc32 MountOption
9.9.5 090813 fix notify.c: fixed SEGV on notifying ABORT on 64bits ptr. CPU
9.9.5 090813 fix *.c: clean up of warnings by recent gcc (char* to const char*)
9.9.5 090812 new {mount,sslway}.c: introduced "sni=hostname" MountOption
9.9.5 090811 fix Strftime.c: imm. _exit() on SIGTERM in localtime()
9.9.5 090810 fix sysconf.h: enabled pthread on NetBSD and OpenBSD
9.9.5 090809 fix log.c: fixed duplicate free() with "-dp" (9.8.2-pre19)
9.9.5 090808 fix dl.c: modified dlopen() to cope with loading SSL on OpenBSD
9.9.5 090806 mod delegate.h,http.c: coped with compilation on AIX
9.9.5 090807 fix httpd.c: right finalizing client-context from MOUNT for ".dgp"
9.9.5 090805 fix delegated.c: fixed possible freezing with RIDENT=client
9.9.5 090805 new {delegated,caps}.c: new client counter on shared memory (-Esc)
9.9.5 090804 fix pstitle.c: removing spaces in pstitle on MacOSX (Darwin/9)

9.9.4 090729 fix delegated.c: closing PORT=xxx on SIGTERM (for SockMux -r)
9.9.4 090729 fix Thread.c: fixed SEGV by thread-id overflow on 64bits OS
9.9.4 090729 fix http.c: repaired client-side keep-alive in MITM
9.9.4 090729 fix ddi.c: leak/SEGV in FSV SSLway thread in MITM in keep-alive
9.9.4 090729 fix http.c: fixed leak of zombi SSLway thread for FSV in MITM
9.9.4 090728 fix distrib.c: fixed possible file-desc. jam. in multi-threads
9.9.4 090727 mod master.c: allowing group-ID 3(sys) to do SUDO and OWNER
9.9.4 090727 fix delegated.c: immediate _exit on SIGQUIT with pending Xf
9.9.4 090726 fix ystring.c: immediate _exit on signal in Xmalloc()
9.9.4 090726 fix filter.c: forcing safe putenv() "-Ete" for SSLway (pre11)
9.9.4 090725 fix Strftime.c: fixed freezing in localtime() in SSL thread
9.9.4 090724 fix Thread.c: SEGV in thread_wait broken id on 64bits OS (9.9.3)
9.9.4 090720 fix ftp.c: disabling PORT to serv. from PASV with FTPCONF=noport
9.9.4 090720 mod inets.c: stop retrial with SRCIF="*:0:ftp-data-pasv-src"
9.9.4 090717 new inets.c: -Dfb to disable retrying conn. with binding <Benawi>
9.9.4 090713 fix ystring.h: platform independent strcasestr() <iijimak>
9.9.4 090712 fix ystring.c: suppressed Xfflush(fp) for fileno(fp)<0
9.9.4 090711 fix master.c: fixed freezing in the negotiation for SSLtunnel
9.9.4 090711 fix filter.c: auto. "-Ete" for SSLway environ. to avoid SEGV
9.9.4 090709 fix stls.c: frozen in MITM waiting req. from disconn. SSL/fcl.
9.9.4 090707 fix gzip.c: imm. _exit on SIG in gzdopen()/non-dgzlib(Zlib-DGv3)
9.9.4 090705 fix {http,file}.c: imm. _exit() on SIGTERM with pending Xfputs()
9.9.4 090705 fix shutter.c: fixed freezing in mutex/localtime() on SIGSEGV
9.9.4 090704 fix log.c: freezing on signal in exit() on Fedora10 with SELinux
9.9.4 090701 fix http.c: applying X-Request: for FTOCL (9.2.3)<Hansen>
9.9.4 090628 fix log.c: ignore signals during exit() doing flushlbf()
9.9.4 090627 fix {http,file}.c: imm. _exit on SIGTERM with pending Xfclose()
9.9.4 090627 new env.c: "-Dts" to disable MTSS (multi-thread safe signal)
9.9.4 090627 fix forkspawn.c: uGetpid() unique among threads on LinuxThreads
9.9.4 090626 fix ystring.c: protected Xputenv() from signals
9.9.4 090625 fix delegated.c: freezing after longjmp/SIGALRM in SIGPIPE handler
9.9.4 090625 fix __sigaction.c: make with CFLAGS=-g (without -O)
9.9.4 090625 fix file.c: fixed frozen mutex by longjmp on signal in fclose()
9.9.4 090623 fix {forkspawn,abort}.c: simply exit() for abort() during fork()
9.9.4 090623 fix delegated.c: fixed SEGV on disk-full (detecting ENOSPC/fwrite)
9.9.4 090623 fix nbio.c: coped with signal (SIGPIPE) in PollIn() for IsAlive()
9.9.4 090622 fix cgi.c: fixed SEGV on SSLway (auto. on FreeBSD-7 or "-Ete")
9.9.4 090621 fix process.c: fixed SEGV in ResponseFilter on SIGTERM (FreeBSD)
9.9.4 090621 new Strftime.c: "-Etm" to force self-made gmtime() and localtime()
9.9.4 090621 fix __pthread_create.c: SEGV on thread_wait non-existent 64bits id
9.9.4 090621 new Strftime.c: self-made signal safe gmtime() and localtime()
9.9.4 090620 fix delegated.c: fixed SEGV+freeze on writing to mmap on disk-full
9.9.4 090620 mod {delegate,log}.c: blocking all lputLog() in the parent process
9.9.4 090618 fix forkspawn.c: made Fork() atomic not to be interrupted
9.9.4 090618 fix delegated.c: fixed freezing on exit with active Sticky
9.9.4 090618 fix Thread.c: inherit CSC-SSigMask enabled in parent to children
9.9.4 090618 fix delegated.c: SEGV by delayed longjmp into ended EXEC_client()
9.9.4 090615 fix _-mutex.c: initializing mutex/CSC after fork()
9.9.4 090614 fix ysignal.h: signal blocking for multi-thread CSC by SSigMask
9.9.4 090613 fix Thread.c: reduced needless mutex for threadidx (without -dN)
9.9.4 090612 fix sslway.c: immediate thread_exit from SSLway thread on SIGTERM
9.9.4 090612 fix {delegated,filter}.c: detecting SIGTERM in waiting SSL thread
9.9.4 090612 fix ystring.c: blocked Xsprintf and Xfread from interrupt
9.9.4 090611 fix ystring.c: blocked Xfree and Xmalloc from interrupt by signal
9.9.4 090611 fix cgi.c: fixed broken SSL environ var. on interrupt
9.9.4 090611 fix Strftime.c: fixed frozen gmtime() in interrupted localtime()
9.9.4 090611 fix http.c: reduced needless mutex for HTTP (without -dN)
9.9.4 090611 fix log.c: blocked fputLog() from interrupt (not to freeze)
9.9.4 090611 fix forkspawn.c: fixed frozen Fork() with threads on interrupt
9.9.4 090610 fix Thread.c: timeout CSC to avoid "spin_lock" on signal (9.8.2)
9.9.4 090609 fix subin/install.sh: for FreeBSD and Solaris10
9.9.4 090608 fix subin/install.sh: added lib. for CHROOT on Linux
9.9.4 090607 new mount.c: matching with the host in Referer: by udst={Hosts}
9.9.4 090607 fix htccx.c: don't scan META in ResponseFilter for non-HTML
9.9.4 090604 new mount.c: MOUNT to rewrite Referer ("where=ref" MountOption)
9.9.4 090603 fix filter.c: broken/frozen CFI output/input with "-fv" option
9.9.4 090602 fix http.c: don't buffer POST body with FTOSV CFI <ogawa>
9.9.4 090531 fix cache.c: fixed broken FTP cache on parallel cache updates
9.9.4 090529 new dget.c: showing MD5 in -Fdget (with -Emi)
9.9.4 090529 new ftp.c: logging MD5 in xferlog as size.md5 (with -Emi)
9.9.4 090531 mod http.c: disabled chunked enc. for PowerSketch/Viewer <yito>
9.9.4 090528 new filter.c: added ORIGINAL_SERVER_NAME/PORT for NAT <venere>
9.9.4 090528 fix Makefile: making under a dir. with space char. in the name
9.9.4 090528 fix service.c: re-enabled SERVER=exec (9.8.6-pre1)<venere>
9.9.4 090526 fix spinach.c: -Ecc don't reuse serv. of diff. port via SOCKS
9.9.4 090525 new spinach.c: SERVER=ecc as a tiny and simple HTTP proxy
9.9.4 090524 fix http.c: Connection: "closed" to "close" (9.6.2)
9.9.4 090523 fix spinach.c: fixed frozen -Ecc process on client-side reset
9.9.4 090521 new {ftp,stls}.c: STLS=fsv,im0.5 for timeout of implicit FTPS
9.9.4 090521 new anonymous-*.pem: new builtin certificate for anon. users
9.9.4 090520 fix admin.c: /-/admin Directory viewer for file largher than 2GB
9.9.4 090519 new ftp.c: connecting to FTPS server via FTP proxy with STLS=fsv
9.9.4 090518 fix fstat.c: displaying/sorting files largher than 2GB
9.9.4 090518 fix spinach.c: disabled -Ecc for FTP (for PORT)
9.9.4 090515 new admin.c: implemented {next,prev} in /-/admin/ file viewer
9.9.4 090514 fix smtp.c: fixed SEGV on SMTPCONF=reject:nomx (9.2.4)<osamura>

9.9.3 090509 mod spinach.c: -Ecc don't reuse connection for POST method
9.9.3 090509 fix spinach.c: fixed -Ecc frozen on EAGAIN to server-bound data
9.9.3 090506 fix dget.c: retrial on disconnected keep-alive in -Fdget
9.9.3 090505 mod httpd.c: requires AUTHORIZER for access to /-/bench?
9.9.3 090504 mod nbio.c: removed "SSL record head" in LOGFILE with MITM
9.9.3 090501 fix spinach.c: fixed destroying aborted connections (-Ecc)
9.9.3 090429 new http.c: retrying on 503 or empty response with -Ecc
9.9.3 090427 fix spinach.c: fixed -Ecc infinite loop by PS_HUP/poll()/connect()
9.9.3 090427 fix Thread.c: fixed duplicated thread with -Eti or 64bis (pre2)
9.9.3 090427 mod http.c: suppressed gzip for 404 to be retried
9.9.3 090424 mod http.c: suppressed gzip for slow "push server"
9.9.3 090423 fix {socks,service}.c: enabled -Ecc with PROXY, SOCKS and MASTER
9.9.3 090423 new access.c: conv. AUTHORIZER=-userpass:u:p to -list{u:p}
9.9.3 090423 mod _-select.c: imm. detect conn. reset by PS_PRI on Win32 (-Ecc)
9.9.3 090422 fix delegated.c: frozen ERESTART in foreground/Win32 (9.9.0-pre4)
9.9.3 090422 fix caps.c: enabled -Bx option as a service on Win32
9.9.3 090422 fix caps.c: enabled -Ecc as a service on Win32 and on HUP restart
9.9.3 090422 fix {http,spinach}.c: -Ecc abandon CCSV on incomplete resp. recv.
9.9.3 090420 fix http.c: retrying on server error on reused connection by -Ecc
9.9.3 090420 mod http.c: keep-alive on ContLeng:0
9.9.3 090420 fix http.c: fixed SEGV by duplicate fclose() in MITM
9.9.3 090418 fix nbio.c: fixed frozen MITM (in IsAlive() PollIn()+Peek1())
9.9.3 090416 new mime.c: MIMECONV=alt:flat to enumerate all alternatives
9.9.3 090415 new spinach.c: implemented -Ecc in non-blocking mode
9.9.3 090415 new mime.c: MIMECONV=alt:first to filter out secondary alt.
9.9.3 090414 new access.c: AUTHORIZER=-hostlist/Name with HOSTLIST=Name:List
9.9.3 090410 new spinach.c: new -Ecc option (for shared HTTP conn. cache)
9.9.3 090402 fix http.c: don't rewrite MD5 (9.0.5)
9.9.3 090402 fix http.c: removing "Content-Encoding:x-gzip" after unzip<sasaki>
9.9.3 090401 fix httphead.c: putting Content-MD5 in base64 (not in hex-dec)
9.9.3 090329 fix tcprelay.c: cleaning STLS=fsv SSL thread with SERVER=tcprelay
9.9.3 090329 new {Thread,env,unix}.c: -Eti to force thread-id mapping in 32bits
9.9.3 090328 fix Thread.c: error or SEGV in pthread_join()/thread_wait() with 64bits pthread_t

9.9.3 090322 new distrib.c: introduced MAXIMA=bps:128k as param. and MOUNT opt.
9.9.3 090321 new log.c: sweeping ACTDIR/sockets/* at the start-up or -Fsweepf
9.9.3 090321 fix distrib.c: removing AF_UNIX sockets left under ACTDIR/sockets on HTTP resp. in gzip (9.6.3-pre6)
9.9.3 090317 new master.c: routing by method (FORWARD=p://sv-_-http//POST)

9.9.2 090311 fix String.c: fixed loop in fgetsZ() on NFS ESTALE (9.2.4)<eddie>
9.9.2 090311 fix http.c: don't forbid SSLtunnel by HTMUX=sv with REMITTABLE=+,https (9.9.0-pre1)
9.9.2 090311 fix http.c: don't forbid MITM by RELAY="vhost:http" (pre6)
9.9.2 090310 new reshost.c: "#!max=N" in hosts-file to limit results <guill>
9.9.2 090309 fix url.c: re-enabled RELAY="nojava" (disabled in 7.9.11)
9.9.2 090309 fix conf.c: added RELAY="vhost,nojava:http:{*:80}:.localnet"
9.9.2 090308 mod ftp.c: regarding MOUNT=".. ftps://serv/.." as ftps://serv:990
9.9.2 090307 mod delegated.c: set TLSCONF=shutdown by default for SERVER=ftp
9.9.2 090305 new fstat.c: -Fls -ll -l f1 f2 ... with LSTFMT=%Y/%m/%d-%H:%M:%S
9.9.2 090304 fix caps.c: don't inherit pointer val. in the CAPSKEY env.
9.9.2 090303 fix ftp.c: fixed banner lines to end with CRLF (for recent lftp)
9.9.2 090303 fix ftp.c: coped with "Transmit3" with FTP over TLS (long resp)
9.9.2 090303 fix caps.c: sharing CAPSKEY beween Win32 and CYGWIN
9.9.2 090302 fix ftp.c: permit ftp/ftps gw. by default (without REMITTABLE)
9.9.2 090301 fix dgsign.c: getting signs of self via CGI (and ssh,rsh)
9.9.2 090301 fix delegated.c: -Fkill on Win32 "full-path of ..." (9.4.0-pre8)
9.9.2 090226 mod stls.c: relaying non-SSL data via SERVER=ftps with STLS=-fcl
9.9.2 090222 fix windows.c: fixed stat() for directory on Win32
9.9.2 090222 fix windows.c: enabled CAPSKEY in DeleGate as a service on Win32
9.9.2 090220 fix ystring.c: converting "%ll" to "%l" on "__alpha"
9.9.2 090220 fix Makefile,*.c: building on OSF1 (with make CFLAGS="-DNONCPLUS")
9.9.2 090218 fix http.c: removed delay in SSI-include for STLS for -Pxxx/admin
9.9.2 090218 fix {ssi,http}.c: forw. "user:pass@" in URL on SSI-include with AUTHORIZER (9.2.2)
9.9.2 090218 fix ssi.c: breaking SSI interpretation on client-disconnection
9.9.2 090217 new ssi.c: introduced <!--#echo var="relbase">
9.9.2 090217 new ssi.c: introduced <!--#exec cmd="pushbase path"> for file=...
9.9.2 090216 mod dl.c: added lib*.so.4 (for libssl.so.4 on Vine4)
9.9.2 090215 fix ftpgw.c: putting 502 code in PROTOLOG on FTP/HTTP conn. error
9.9.2 090215 mod Makefile,mkmake.c: loop in make src/Makefile with clock-skew
9.9.2 090214 fix gethostbyname2.c: SEGV by recursion with unknown-host on Solaris,HPUX (9.9.1-pre4)
9.9.2 090209 fix ftp.c: fixed a compilation problem (pre1)
9.9.2 090208 fix sftp.c: waiting upload completion before next command
9.9.2 090207 new sftp.c: TMPDIR param. for tmp. file to be TMPDIR/dg-sftpgw/*
9.9.2 090207 fix http.c: don't close non-reg. NULLFP() (/dev/null) (9.6.3-pre4)
9.9.2 090206 fix file.c: disabled dupclosed() for NULLFP() (enabled by -Bd)
9.9.2 090206 fix file.c: disabled fclose() for NULLFP() (enabled by -Bf)
9.9.2 090205 fix mkcpp.c: building on CYGWIN
9.9.2 090205 new httpd.c: extended time server for UTS as /-/date?zone=uts&...
9.9.2 090204 new spinach.c: a simple seed of protocol interpreter
9.9.2 090201 new sftp.c: MountOption to limt max. file size as "datamax=16g"
9.9.2 090128 new pilsner.c: a simple seed of common string processor
9.9.2 090123 new inets.c: added "_-DontRoute.host" preifx
9.9.2 090123 new inets.c: intduced "_-xxxxxx.host" generic preifx

9.9.1 090118 new ahy2fdif.c: added <METAX name=LANGUAGE>code</METAX>
9.9.1 090118 new ahy2fdif.c: added <METAX name=CHARCODE>code</METAX>
9.9.1 090118 new any2fdif.c: getting charcode from CHARCODE=code by -Fany2fdif
9.9.1 090118 new cgi.c: CHARCODE=thru MountOption to disable SVCC/CCX for CGI
9.9.1 090118 new any2fdif.c: guessing input-charcode to be used by m17n-lib
9.9.1 090117 fix smtpgate.c: finding out user-text in a split quoted-printable
9.9.1 090117 fix smtpgate.c: finding out user-text in a long line
9.9.1 090117 new {httpd,mount}.c: filtering /robots.txt by "nvhost", "avhost"
9.9.1 090116 new any2fdif.c: coped with rot13 for MHonArc
9.9.1 090115 new any2fdif.c: coped with output in utf-8 (--ocode=utf-8)
9.9.1 090115 new any2fdif.c: input char. code conv. for &#xxxx; in HTML
9.9.1 090114 new any2fdif.c: coped with m17n-lib (M17N=on + --ocode=xxx)
9.9.1 090113 new any2fdif.c: --yuc option to ouput yEUC code
9.9.1 090113 new JIS.c: escaping non-JIS char. with with CHARCODE="y-charcode"
9.9.1 090113 new inets.c: added SRCIF=-dontroute.xx HOSTS=-dontroute.xx/0.0.0.0
9.9.1 090112 fix mimehead.c: re-encoding encoded-word after char. code conv.
9.9.1 090111 fix mime.c: enabled m17n-lib for enMime MIME-encoded-word
9.9.1 090110 fix delegated.c: waiting prev. serv. proc. PID gone on "-r" (Unix)
9.9.1 090110 fix {sox,delegated}.c: close SockMux ports before exit on SIGTERM
9.9.1 090109 new {nbio,delegated}.c: "-odst.-" for ipwf + FreeBSD and MacOSX
9.9.1 090107 new ftp.c: "logindir" option for MOUNT="/* sftp://server/%2F*"
9.9.1 090107 fix ftp.c: MOUNT on non "/" login-dir (non-anonymous) with CACHE
9.9.1 090107 fix ftp.c: coped with MOUNT by "ls -opts" onto serv. on MacOSX
9.9.1 090107 fix ftp.c: fixed disabling CACHE=no for MOUNTed servers
9.9.1 090105 fix mime.c: fixed VStr overflow in rew. addr. in long line
9.9.1 090105 new nntpgw.c: new NNTP/HTTP MountOption "nocite,nomarkup"
9.9.1 090103 fix mime.c: putting "C-T-E: 8bits" for CHARCODE=8bitscset:tosv
9.9.1 090103 new mime.c: character code conv. for MIME body with m17n-lib
9.9.1 090103 new mimehead.c: MIME header (encoded-word) conv. with m17n-lib
9.9.1 090103 new m17nccx.c: multi-lingual char. code conversion with m17n-lib

9.9.1 090102 mod sftp.c: showing the reason of PASS login error. on sftp/FTP
9.9.1 090102 fix delegated.c: don't go background with -Fany2fdif -b (9.4.3)
9.9.1 090101 fix any2fdif.c: skipping <?...?> in XML and .rdf
9.9.1 081228 fix cgi.c: fix CGI resp. delay with req. Content-Length:0 (7.9.8)
9.9.1 081228 fix service.c: fix for -Fcgi (9.8.2 for -Pxxx/ysh)
9.9.1 081227 mod iotimeout.c: detecting EOS from clnt waiting non-NL ended text
9.9.1 081227 fix http.c: shorten timeout for slow txt resp. in CACHE_TAKEOVER
9.9.1 081227 mod smtpgate.c: trying return CAPSKEY to generic domain on filure
9.9.1 081227 new Makefile: "make mime" at the top dir. to make enMime/deMime
9.9.1 081227 new smtpgate.c: extended REJECT/HEADER:code,wcs:fname:[fvalue]
9.9.1 081225 mod delegated.c: added CMAP=thru-CONNECT:HTTPCONF:https:wii.com
9.9.1 081225 fix rfc822.c: extended NNTPCONF=nomapemail:{list}:{fields}
9.9.1 081224 fix swft.c: don't MOUNT SWF ver.4 of olders <mizuno>
9.9.1 081224 mod maker/__pthread_create.c: exp. default stack size 64k -> 128k
9.9.1 081224 fix builtin.c,Makefile: coped with HP-UX SIGBUS on alignment-error
9.9.1 081224 mod *.[hc]: coped with HP-UX w/o "hpux" with "__hpux__" <penske>
9.9.1 081224 mod {resolv,gethostbyname2}.c: for OS without gethostbyname2()
9.9.1 081222 mod inets.c: suppressed HOSTS cache/unknown refresh by sub-thread
9.9.1 081222 fix service.c: fixed SEGV with -Etw for -T.period (9.8.5)<sunils>
9.9.1 081220 new ldap.c: enabled TIMEOUT=io:T for SERVER=ldap with MOUNT
9.9.1 081217 new service.c: SOCKOPT=shutdown:g[:proto:dst:src]
9.9.1 081217 new service.c: SOCKOPT=buffsize:1024i+1024o[:proto:dst:src]
9.9.1 081212 fix httpd.c: coped with /robots.txt ending without NL
9.9.1 081207 mod http.c: don't reject access to self by REMITTABLE=proto/port
9.9.1 081206 new inets.c: SOCKOPT=noshutdown to disable shutdown() on Win32
9.9.1 081207 fix stls.c: coped with NTHT for MITM CONNECT 
9.9.1 081206 fix http.c: coped with NTHT for CONNECT method with a upper proxy
9.9.1 081206 fix winsspi.c: coped with NTHT for CONNECT method (non 100 resp.)
9.9.1 081205 fix {http,windows}.c: NTHT for Proxy-Auth. between chained proxy
9.9.1 081202 fix windows.c: don't try readlink() for an empty or device file
9.9.1 081130 fix mount.c: re-enabled "?" in URL as MOUNT="v r?*" (9.8.2-pre37)
9.9.1 081128 new inets.c: putting RES_WAIT messg. in slow resolv. on start-up
9.9.1 081128 mod windows.c: disabled shared lock on Win95 by default (9.0.6)
9.9.1 081127 fix windows.c: getting SPAWN_ENVIRON on Win95 (9.2.4)
9.9.1 081126 fix file.c: fixed delay of retrieval "//path.dll" on Win32 (9.0.1)
9.9.1 081126 fix windows.c: running on Win95 without socket inh. (9.2.5-pre4)
9.9.1 081126 fix vsap.c: FTP data-connection with RIDENT without HTMUX (9.9.0)
9.9.1 081126 new http.c: Keep-Alive for POST (HTTPCONF=bugs:do-keepalive-post)

9.9.0 081121 fix caps.c: fixed SEGV with CAPSKEY without ADMIN (on Solaris10)
9.9.0 081121 fix master.c: sync. SockMux with slow timer (FB6_64/VMWare)(pre4)
9.9.0 081121 new iotimeout.c: limiter of max. num. of SIGPIPE in sess. or proc.
9.9.0 081121 mod delegated.c: ignore SIGPIPE in main process, not to stall with STLS=fcl on RedHat9 (NPTL 0.29)(9.7.2)
9.9.0 081121 fix iotimeout.c: possible inf. loop SIGPIPE > stderr (9.8.2-pre9)
9.9.0 081120 fix {param,httpx}.c: passing HTTPCONF to ResponseFilter on Win32
9.9.0 081120 fix {httpd,ftpgw}.c: -d1 ResponseFilter for FTP/HTTP on Windows
9.9.0 081118 new http.c: HTTPCONF=bugs:add-contleng (for DoCoMo) <mizuno>
9.9.0 081118 mod http.c: don't remove Content-Length in chunked<akihito>(9.8.4)
9.9.0 081117 mod svport.c: use -Pxxx/local as PrimaryPort (for PIDFLE,LOGFILE)
9.9.0 081117 fix svport.c: fixed the name of service with HTMUX on Win32
9.9.0 081117 fix delegated.c: stop private SockMux thread on exit on WinCE
9.9.0 081116 fix wince.c: periodical check and adjustment of time on WinCE
9.9.0 081116 fix log.c: removed dup. initial-log.txt on WinCE (9.8.4)
9.9.0 081115 new ssi.c: timeout SSI include <--!#config var=timeout val=0.5 -->
9.9.0 081114 mod sox.c: enabled Credhy/SockMux for private SockMux with -d1
9.9.0 081114 fix {sox,htaccept}.c: auto reconnection of SockMux on Win32/CE
9.9.0 081114 fix sox.c: fixed trunc. resp. data via SockMux/HTUX (with poll()?)
9.9.0 081114 mod credhy.c: signed CRC8 by default (-DCS for backward compat.)
9.9.0 081113 fix sox.c: SEGV in SockMux thread with -d1 (thread stack size)
9.9.0 081113 fix ddi.c: don't recycle HTTP serv. sock. for conn. via SSL-TUNNEL
9.9.0 081112 new sox.c: "closer" thread to reduce delay of close() (WinCE)
9.9.0 081112 fix process.c: fixed leak of socket handles (WinCE)(9.8.2-pre6)
9.9.0 081112 fix process.c: fixed unnecessary delay in ResponseFilter (WinCE)
9.9.0 081112 fix process.c: don't close(0) in ResponseFilter thread (WinCE)
9.9.0 081112 fix vsaddr.c: SEGV on NULL-ptr. SockMux/HTMUX (unresolvable self)
9.9.0 081111 mod caps.c: HostId by GMT (to be signed in diff. time zone)
9.9.0 081111 fix caps.c: CAPSKEY on Zaurus (MACHINE.SID for samba?)
9.9.0 081111 fix credhy.c: -ECS to escape CRC8 bug (shift right signed char)
9.9.0 081111 fix credhy.c: Credhy/SockMux on KuroBox and Zaurus (CRC8 bug)
9.9.0 081110 fix {svport,delegated}.c: fixed lock-out of AcceptByMain(HTMUX=cl)
9.9.0 081110 fix delegated.c: fixed zombi ssh connection with SockMux for HTMUX
9.9.0 081110 mod svport.c: prioritizing explicit -Pxxx/remote for ACCET/HTMUX
9.9.0 081110 mod {svport,stls}.c: SSL-optional for -Pxxxx/admin with HTMUX=cl
9.9.0 081109 fix vsaddr.c: removed undef. IPv6%scope-id by gethostaddr()
9.9.0 081109 fix delegated.c: HTMUX on Fedora ("::1 localhost" in /etc/hosts)
9.9.0 081109 fix caps.c: don't add duplicated CAPSKEY (on SIGHUP)
9.9.0 081108 fix delegated.c: leak of mmap file descriptor on SIGHUP (9.8.2)
9.9.0 081108 fix log.c: leak of UDP socket descriptor on SIGHUP (9.8.2-pre10)
9.9.0 081108 fix delegated.c: reconnection of PrivateSOX on SIGHUP
9.9.0 081108 fix delegated.c: restarting the SockMux for HTMUX on SIGHUP
9.9.0 081107 fix rident.c: implemented RIDENT for WinCE
9.9.0 081107 fix sox.c: coped with HTMUX=cl with AUTHORIZER for non-HTMUX
9.9.0 081106 new sox.c: HTMUX=cl in the single-process mode (-d1+N) (WinCE)
9.9.0 081106 fix {htaccept,master,sox}.c: waiting SockMux/HTMUX start
9.9.0 081105 new cksum.:c new checksum by "-Fcksum -x file-list"
9.9.0 081105 new htaccept.c: HTMUX=cl:H:P with MYAUTH=user:pass:htmux
9.9.0 081104 mod http.c: don't try detect HTTPS/SSL/CONNECT over HTMUX
9.9.0 081104 fix ystring.c: enabled -fv for SockMux trace
9.9.0 081104 new svport.c: introduced -Qxxx/remote for HTMUX=cl
9.9.0 081103 new {delegated,svport}.c: introduced -Qxxx/local for HTMUX=cl
9.9.0 081031 fix htaccept.c: retrying on initial HTMUX connection failure
9.9.0 081030 fix {delegated,master}.c: enabled HTMUX as a service on Win32
9.9.0 081029 fix dglibs.c,maker/SSL_set_SSL_CTX.c: enabled "make sslway"
9.9.0 081029 new {htaccept,master}.c: forwarding ACCEPT with HTMUX=px:host:port
9.9.0 081028 fix delegated.c: immediate Sticky fin. on server exit on Win32 
9.9.0 081028 fix {windows,sox}.c: immediate Sox fin. on server exit on Win32
9.9.0 081027 fix delegated.c: don't dup. load common.conf in child on Win32
9.9.0 081027 fix delegated.c: coped with empty peername (VSAP client) on Win32
9.9.0 081027 fix caps.c: CAPSKEY for Win32
9.9.0 081027 fix sox.c: exiting PrivateSox process on server exit on Win32
9.9.0 081026 mod htaccept.c: rejecting HTMUX over indirect conn. (proxy or NAT)
9.9.0 081026 mod htaccept.c: sending "From: ADMIN=foo@bar" heaer in HTMUX
9.9.0 081026 fix httpd.c: acting as an origin server via RIDENT/SockMux
9.9.0 081025 fix sox.c: frozen init. in sox_setup()/fread() from the connection left marked ESTABLISHED in the client host but lost in the server host
9.9.0 081025 new sox.c: forwarding RIDENT by default on SockMux/VSAP
9.9.0 081025 new {sox,htaccept}.c: acting as SockMux by "Upgrade: SockMux/1.0"
9.9.0 081024 new smtpgate.c: returning generated CAPSKEY via SMTPGATE
9.9.0 081023 new caps.c: request, generate, and set CAPSKEY=key
9.9.0 081022 new caps.c: guessing system's installation date from /etc
9.9.0 081021 fix smtp.c: fixed SEGV on empty MX name (on EMERGENCY STOP)

9.8.6 081018 fix http.c: empty resp. on 304 serv. for If-None-Match <kawasaki>
9.8.6 081018 fix pop.c: terminating POP proxy process with FTOCL
9.8.6 081018 fix filter.c: MIME CFI by CMAP="xxx.cfi:FTOSV:pop,smtp,nntp"<fish>
9.8.6 081018 fix filter.c: dup. filter's LOGFILE and output to console with -fv
9.8.6 081018 fix nbio.c: don't apply recv(PEEK) for pipe on MacOSX (Darwin)
9.8.6 081018 fix filter.c: enabled FFROMCL+CFIscript for SMTP and NNTP
9.8.6 081017 fix tcprelay.c: finishing FTOCL with Tcprelay
9.8.6 081017 fix http.c: fixed leak of socketpair-descriptor (pre9)
9.8.6 081017 mod sslway.c: resp. to pending SSL shutdown from peer by default
9.8.6 081016 fix filter.c: don't disconn. FromC after FTOCL insertion
9.8.6 081016 fix http.c: fixed frozen/broken keep-alive with FTOCL/MITM/Win32
9.8.6 081016 fix delegated.c: finishing foreground proc. on SIGINT on Win32
9.8.6 081016 mod stls.c: set AUTHORIZER="-list{mitm}:mitm:*:*" by default
9.8.6 081015 fix wince.c: -Qxxx in common.conf.txt to add to default ports
9.8.6 081014 fix stls.c: enabled Digest Proxy-auth. for CONNECT/MITM
9.8.6 081014 fix {stls,http}.c: applying Proxy-auth. to CONNECT (not HTTPS/SSL)
9.8.6 081013 new wince.c: DGROOT and VARDIR in /DGROOT/common.conf.txt (WinCE)
9.8.6 081012 mod stls.c: forced Proxy-Auth. for "MITM" with revealing message
9.8.6 081011 fix stls.c: returning auth. error message on the CONNECT phase
9.8.6 081011 mod stls.c: removed code for MITM over HTTP
9.8.6 081011 mod sox.c: removed code for accept() and incomming connect()
9.8.6 081011 mod {vsap,htaccept}.c: removed code for accept() at remote host
9.8.6 081009 fix master.c: don't reject with REJECT by source_permitted()
9.8.6 081009 fix wince.c: changed to CACHEFILE=$[server:%P/=%-1mu/%-2mu/%mu]
9.8.6 081008 fix gzio.c: SEGV in HTTP/gzip + CFI/SSI (before Zlib-DGv3/9.8.2)
9.8.6 081008 fix process.c: don't inherit thread-info. in Conn. struct (Win32)
9.8.6 081006 mod wince.c: CACHEFILE=$[server:%P/=%-1mp/%-2mp/%mp] by default
9.8.6 081006 fix windows.c: VARDIR by "File Exploer"/"StorageCardPath" (WiNCE)
9.8.6 081005 new {yshell,wince}.c: switching elements in /-/screen/ (WiNCE)
9.8.6 081005 mod wince.c: decomposed NETWORK STATUS menu into sub-menus
9.8.6 081005 mod wince.c: keeping device awake in "Idle" mode (WiNCE)
9.8.6 080930 fix sslway.c: with both CERTIDR/ca-cl.pem and CERTDIR/ca-cl/
9.8.6 080930 fix sslway.c: possible SEGV on SSLway init. with CERTDIR/ca-cl/
9.8.6 080929 fix delegated.c: fixed "accepted (n.ms)" in LOGFILE with VSAP
9.8.6 080929 fix htaccept.c: fixed timeout/polling HTTP ACCEPT with -d1 (pre1)
9.8.6 080929 fix sox.c: fixed SEGV on reconnection of SockMux with -d1 (9.8.2)
9.8.6 080928 new master.c: enabled HTTP/ACCEPT over VSAP/SockMux
9.8.6 080926 new {wince,access,yshell}.c: MessageBox with timeout (WinCE)
9.8.6 080926 new wince.c: added "power Idle" MENU (WinCE)
9.8.6 080925 new {yshell,wince}.c: remote control via /-/screen/ (WinCE)
9.8.6 080924 new {yshell,httpd}.c: supported POST/HTTP to yshell
9.8.6 080922 fix mount.c: don't match "command:" with MOUNT="* ..." (9.8.4)
9.8.6 080922 fix nntp.c: clearing ServerSock on closing NNTP/HTTP sv.
9.8.6 080922 fix {http,nntpgw}.c: disconn. NNTP sv. on exit of NNTP/HTTP client
9.8.6 080922 new wince.c: periodical ping to the last client (WinCE) 
9.8.6 080921 fix wince.c: don't dismiss by "Revert to Default" MENU (WinCE)
9.8.6 080921 new wince.c: enabled "Small Font" MENU on low DPI device (WinCE)
9.8.6 080919 mod delegated.c: don't limit active threads with enough memory
9.8.6 080918 mod delegated.c: removed delay between VSAP retry on acc. timeout
9.8.6 080918 mod conf.c: suppressed "MAX_DELEGATEP ..." in LOGFILE with -vd
9.8.6 080917 fix process.c: SEGV in ResponseFilter thread (-d1 on Non WinCE)
9.8.6 080917 fix ftp.c: don't delay(2sec.) on unknonw AUTH method (since 9.8.5)
9.8.6 080917 new ftp.c: supported FTP via VSAP over HTTP
9.8.6 080917 new http.c: -Eha for REMITTABLE=+,ACCEPT + HTTPCONF=methods:ACCEPT
9.8.6 080917 new {vsap,htaccept}.c: supported VSAP over HTTP (ACCEPT,CONNECT) 

9.8.5 080914 new {vsap,htaccept}.c: sharing port bound dynamically (with -d1)
9.8.5 080913 fix master.c: SEGV in access-control cache by parallel threads/-d1
9.8.5 080913 fix http.c: Cont-Len for HEAD/Windows Update(9.8.4-pre1)<k-yamada>
9.8.5 080912 fix Thread.c: possible jam. after immediate exit of new thread
9.8.5 080911 new service.c: periodical permission check for -T.period (-Etw)
9.8.5 080911 new socks5.c: accepting via CONNECT .accept.- command / Socks5
9.8.5 080911 fix ftp.c: enabled SERVER=ftp STLS=fcl with AUTHORIZER <Benawi>
9.8.5 080907 fix yshell.c: fixed frozen gzip thread for screen dump (WinCE)
9.8.5 080907 fix windows.c: cleaning up thread table with thread_kill (WinCE)
9.8.5 080907 fix wince.c: non-blocking send without freezing on WinCE4.X
9.8.5 080905 fix delegated.c: fixed "accepted (n.ms)" in LOGFILE/Win32 (9.8.4)
9.8.5 080906 fix http.c: fixed relaying AUTHORIZER=-login to NTHT (9.8.2)
9.8.4 080903 fix {yshell,wince}.c: fixed not to freeze on scrdump.bmp/gzip
9.8.4 080903 fix {httphead,String}.c: digest auth. for URL including ","
9.8.4 080901 fix http.c: don't relay Proxy-Auth in MITM mode (9.7.0)
9.8.4 080901 fix http.c: don't add Proxy-Auth in MITM mode (9.7.0)
9.8.4 080831 new wince.c: MOUNT="/-/screen/* gendata:/-/ysh/screen/*" by dflt
9.8.4 080831 new ssi.c: date and uname as builtin SSI command (for WinCE)
9.8.4 080830 new {http,conf}.c: introduced CACHE=do,auth:Prt:Dst:Src
9.8.4 080830 new http.c: applying gzip to relayed image/bmp
9.8.4 080830 fix http.c: caching large binary data without Content-Length
9.8.4 080829 new wince.c: a switch to suppress expiration of AUTHORIZER=-man
9.8.4 080829 new filetype.c: added Content-Type:image/bmp for .bmp
9.8.4 080828 new yshell.c: applying gzip for BMP
9.8.4 080828 new wince.c: dumping screen image in BMP
9.8.4 080827 fix resolv.c: enabled dialup on DNS with single DNS serv. (WiNCE)
9.8.4 080826 fix ddi.c: fixed SEGV on recycling randstack area (with -d1+0)
9.8.4 080826 fix env.c: fixed -d1+1 to make 2 session threads
9.8.4 080826 fix httphead.c: digest auth. for long URL path (www.vmware.com)
9.8.4 080825 new sslway.c: enable Diffie-Hellman by CERTDIR/dhparam.pem<andre>
9.8.4 080824 new cache.c: added "%-NmX" for MD5 value of format X in N columns
9.8.4 080824 new cache.c: added conditional cache-path by "%(X==Y?A:B)"
9.8.4 080824 fix delegated.c: fixed logging of "accepted (n.ms)" (since pre2)
9.8.4 080822 fix access.c: reduced VStr overflow for AUTHORIZER=-list
9.8.4 080821 new mime.c: filtering non-text parts with MIMECONV=textonly
9.8.4 080820 fix process.c: fixed SEGV on Win32 with internal-filter
9.8.4 080819 add sslway.c: SSL shutdown by TLSCONF=shutdown <andre><Markus>
9.8.4 080814 fix htccx.c: CCX for POST request of MSIE (with Pragma:no-cache)
9.8.4 080814 new htccx.c: -ECC option to apply CCX to values in Cookie
9.8.4 080813 fix urlesc.c: thru "%25" (URL escaped ASCII "%") in CCX
9.7.8 080811 fix http.c: huge data (> 4GB) from serv. in non-chunked/Keep-Alive
9.8.4 080811 new sslway.c: "ca-sv.nodefault" to stop loading default certs.
9.8.4 080807 new env.c: -ERu to enable dup. HOSTS cache detection on update
9.8.4 080807 new yshell.c: /-/ysh/hosts.expire to force expiring HOSTS cache
9.8.4 080806 new yshell.c: /-/ysh/bench.html for network performance test
9.8.4 080805 fix httphead.c: rewriting Set-Cookie domain=.a.b attribute
9.8.4 080805 new nntp.c: added MOUNT="command:com/arg command:com/arg"
9.8.4 080805 fix delegated.c: fixed stack SEGV on subst. 304 response with -d1
9.8.4 080805 new nntp.c: caching for client's BODY with ARTICLE to serv.<Jeff>
9.8.4 080804 fix inets.c: don't create dup. HOSTS cache entries on refresh
9.8.4 080803 new nntp.c: added "nonlocal" option to force caching local-server
9.8.4 080803 fix ystring.c: fixed SEGV with -fv FSV=-tee on FC6_64 and FB6_64
9.8.4 080803 fix setutimes.c: Ftruncate() on FedoraCore (NNTP cache)
9.8.4 080802 new {inets,ysh}.c: dump HOSTS cache via yshell or /-/ysh/hosts

9.8.4 080730 fix ftp.c: auth. matching with mapped user by -authServ(user)
9.8.4 080730 new ftp.c: FTPCONF=proxyauth for MYAUTH=u:p:ftp:serv as a proxy
9.8.4 080730 new {inets,master}.c: SRCIF=clif.- and SRCIF=dontroute.clif.-
9.8.4 080730 new access.c: introduced -list{u:p},"-fail.badpass",-any
9.8.4 080730 new ftp.c: USER u@s + PASS p -> AUTHORIZER="-list{u:p}:*:s"
9.8.4 080729 new resolv.c: RES_DEBUG=0 to disable debugging log
9.8.4 080729 fix {inets,access}.c: caching get{sock/peer}name for socketpair
9.8.4 080729 new {env,httpx}.c: -Eic option to use client-address in URLget(0)
9.8.4 080729 fix stls.c: don't require SSL in URLget(0) with STLS=fcl (x.x.x)
9.8.4 080728 fix ystring.h: enabled ferror() detection on WinCE
9.8.4 080727 fix {mime,pop}.c: exit on fputs()=EOF by client's reset (WinCE)
9.8.4 080727 fix wince.c: supported ungetc() for socket and tmpfile() (WinCE)
9.8.4 080727 fix JIS.c: CHARCODE=K- prefix to escape ESC[K bug/MacOSX Terminal
9.8.4 080727 fix JIS.c: don't disable converstion after 0xA0 (9.5.0)
9.8.4 080726 fix {delegated,domain,sox}.c,log.h: coped with gcc4.2.0(2007q1-10)
9.8.4 080726 new delegated.c: -vq to suppress mssg. on loading default config.
9.8.4 080726 new wince.c: initial-log.txt for logging 10-minutes on WinCE
9.8.4 080725 new wince.c: added PAUSE by menu on WinCE
9.8.4 080726 new wince.c: displaying CPU usage on WinCE
9.8.4 080725 new svport.c: -Q1234/off to disalbe the previous -Q1234
9.8.4 080725 fix delegated.c: ${EXECPATH} relative files (WiNCE)
9.8.4 080725 fix delegate.h: elapsed time of "disconnected" in LOGFILE (WinCE)
9.8.4 084025 new delegated.c: introduced DGROOT/common.conf[.txt]
9.8.4 080724 mod {http,wince}.c: detecting client's reset in text relay (WinCE)
9.8.4 080723 mod http.c: erase short Content-Length in chunked (chunked-cleng)
9.8.4 080723 new wince.c: save/restore the SYSLOG flag on WinCE
9.8.4 080723 mod syslog.c: putting the syslog to LOGFILE too with -fv
9.8.4 080722 fix http.c: break keep-alive with server on incomplete recv. body
9.8.4 080722 fix access.c: don't source_permitted() for -man with -Eri (pre50)
9.8.3 080722 fix resolv.c: fixed dial-up for DNS on WinCE (9.8.2-pre50)
9.8.3 080722 fix resolv.c: fixed SEGV in dialup for DNS on WinCE (9.8.2-pre36)
9.8.3 080721 fix hostlist.c: fixed HostList jamming with mix of nvhost+avhost
9.8.3 080721 fix wince.c: suppressing ping with no routes
9.8.3 080721 new mount.c: -x.nvhost=host to select MOUNT for current vhost
9.8.3 080721 fix mount.c: enabled -f.condition and -b.condition
9.8.3 080721 fix mount.c: reverse rew. MOUNT="/* http://s/* nvhost=v,nvserv=r"
9.8.2 080717 new wince.c: save/resotre status flags set by Menu (WinCE)
9.8.2 080716 new {wince,winmo}.c: periodical ping to the default router (WinCE)
9.8.2 080716 fix http.c: AUTHORIZER=-man with -DAP (pre44) without -Eri(pre43)
9.8.2 080716 fix resolv.c: restricted DNS dialup only on UNREACH (WinCE)
9.8.2 080716 fix nbio.c: don't try dialup on refused TCP connection (WinCE)
9.8.2 080716 new wince.c: switch to show all routes on WinCE
9.8.2 080715 new nntpgw.c: "authru" MountOption to thru pass auth. info. with @ 
9.8.2 080714 fix script.c: SEGV in LIST a b c TSIL (pre37)
9.8.2 080714 fix access.c: pushing out oldest entry of AUTHORIZER=-man cache
9.8.2 080714 fix access.c: save/restore AUTHORIZER=-man cache into extern. file
9.8.2 080713 fix httphead.c: SEGV on NNTP caching proxy (pre46)<suzuki_h>
9.8.2 080713 fix httphead.c: enabled nvserv=-thru (or genvhost) with PROXY
9.8.2 080712 fix url.c: coped with rewriging URL in XML in long element name
9.8.2 080712 mod nbio.c: parallel connection trial (-Ecp) disabled by default
9.8.2 080711 new mount.c: introduced "avserv=host" MountOption
9.8.2 080711 fix ftp.c: fixed VStr overflow on PASV in FTP/HTTP gw. (pre42)
9.8.2 080710 new mount.c: "avserv=-thru" option to obsolete "genvhost=-thru"
9.8.2 080710 new mount.c: added MOUNT=/* http://odst.-/*" for SO_ORIGINAL_DST
9.8.2 080710 fix ftpgw.c: timeout on POST/CGI body shorter than Content-Length
9.8.2 080710 fix htmlgen.c: SEGV on MOUNT="/-/builtin/* http://sv/*" on sv down
9.8.2 080709 new {env,delegated}.c: introduced TIMEOUT="bind:5" and "bindenter"
9.8.2 080709 fix {inets,delegated}.c: retrying bind() on restart with -r
9.8.2 080708 fix delegated.c: termination by -Fkill or -r with -f or -v on Unix
9.7.8 080708 fix delegated.c: wait "Left children" on exit (-r restart failure)
9.8.2 080708 new delegated.c: introduced TIMEOUT=waitchild:3 for wait on exit
9.8.2 080708 fix filter.:c output of -tee filter to LOGFILE with -fv
9.8.2 080707 new mount.c: introduced odst=listOfOriginalDst for NAT
9.8.2 080706 new cache.c: don't unify caches for aliases as virtual host names
9.8.2 080706 fix http.c: don't remove gen. data with HTTPCONF=cache:any (pre37)
9.8.2 080705 new {mount,hostlist}.c: introduced "nvhost=hostList" MountOption
9.8.2 080704 new {httphead,mount}.c: introduced "rserv=host:port" MountOption
9.8.2 080703 fix ftp.c: infinite timeout with TIMEOUT=io:0 (9.2.2)<atsu-sato>
9.8.2 080702 fix url.c: MOUNTing URL in a nested XML element <shigeharu.>
9.8.2 080702 new mount.c: HTTPCONF=nvserv:auto to detect virtual serv. in MOUNT
9.8.2 080701 new mount.c: "nvserv" MountOption to MOUNT a virtual hosting serv.
9.8.2 080630 new {access,winsspi}.c: AUTHORIZER=-login using LogonUser on Win32
9.8.2 080628 new {http,winsspi}.c: Basic auth. client to NTHT server gateway
9.8.2 080628 new {http,winsspi}.c: added AUTHORIZER=-ntht to be NTHT server
9.8.2 080625 new {env,http}.c: added -Enh to enable NTHT proxy (NTLM over HTTP)
9.8.2 080623 fix {access,delegated}.c: suppressed AUTHORIZER-man on termination
9.8.2 080623 fix wince.c: added no-wraparound-text mode on WinCE
9.8.2 080623 fix wince.c: make shortcut to the current executable file on WinCE
9.8.2 080623 new wince.c: added OS version info. shown on WinCE
9.8.2 080622 fix http.c: don't ask AUTHORIZER=-man for CONNECT with -DAP
9.8.2 080621 new {svport,wince}.c: binding -Pxxxx to I.F. of WiFi or PC /WinCE
9.8.2 080621 fix {hostlist,access}.c: fixed access-control jamming on WinCE
9.8.2 080620 new wince.c: added SYSLOG on/off on WinCE
9.8.2 080620 mod Makefile: added /machine:arm for link option for WinCE
9.8.2 080620 fix service.c: SEGV after acc. from multi-clients on WinCE (pre41)
9.8.2 080619 new access.c: restricted paralell AUTHORIZER=-man on WiNCE
9.8.2 080619 mod access.c: suppress AUTHORIZER=-man interaction if non-RELIABLE
9.8.2 080619 new delegated.c: -Eri for reject immediately (default on WinCE)
9.8.2 080619 fix wince.c: showing the status on unexpected termination on WinCE
9.8.2 080616 fix dgsign.c: coped with bahavior of tar on MacOSX for ".DS_Store"
9.8.2 080616 new {ssi,dgsign}.c: getting EXESIGN of other DeleGate via SSI
9.8.2 080616 fix {inets,ftp}.c: coped with the mix. of EPSV and PASV via NAT
9.8.2 080616 new filter.c: -Fconnect -qh200 to send input as HTTP requests
9.8.2 080616 fix http.c: don't break on pipelined req. in keep-alive + FFROMCL
9.8.2 080615 fix any2fdif.c: fixed duplicated index of /path and /path/
9.8.2 080615 new any2fdif.c: enabled multiple "-x pattern" options
9.8.2 080615 fix httpx.c: re-enabled getting with -Fany2fdif -r URL(9.6.0-pre4)
9.8.2 080615 new rfc2mail.c: conversion from RFC.txt to the RFC822 format
9.8.2 080614 new Strftime.c: %B for full name of month (for RFC date)

9.8.2 080611 new wince.c: introduced stealth buttons on WinCE
9.8.2 080611 new {winde,access}.c: clearing cache of AUTHORIZER=-man on WinCE
9.8.2 080611 fix socks5.c: -DAP to disable AUTHORIZER for HTTP and SOCKS proxy
9.8.2 080611 fix wince.c: fixed MSG_PEEK on WinCE (for SOCKS5)(pre29)
9.8.2 080610 fix access.c: AUTHORIZER=-man for SOCKS (with CTX_auth(ctx,0,0))
9.7.8 080610 fix ddi.c: don't leave dangling file-desc. ToS/FromS + "onerror"
9.7.8 080609 fix filter.c: SEGV on retrying /favicon.ico + FTOCL (9.0.3)<imao>
9.8.2 080608 new wince.c: added On/Off switch for proxy-authorization on WinCE
9.8.2 080608 new {winmo,access}.c: showing MAC address for AUTHORIZER=-man
9.8.2 080605 fix http.c: coped with POST relay with FFROMCL/FFROMSV on Win32
9.8.2 080605 fix windows.c: couldn't start as service/Win32 with MYAUTH (pre33)
9.7.8 080605 fix delegated.c: 1st req. on restart on HUP or error Win32 (9.0.5)
9.7.8 080605 fix windows.c: restarting on HUP or conf. error Win32 (9.7.5-pre2)
9.8.2 080605 fix svport.c: passing -Pxxx/ftp to service on Win32
9.8.2 080604 new access.c: introduced TIMEOUT=authorizer:T
9.7.8 080604 fix http.c: discarding shouten cache on =+= 304 resp. from serv.
9.7.8 080604 fix http.c: discarding truncated cache on EPIPE by client
9.7.8 080604 fix http.c: don't manipulate cache if ended without resp. relay
9.7.8 080603 fix cache.c: %XX escape of cache file name for char. with MSB
9.8.2 080602 fix windows.c: control inheritance of socket by -Dis (pre26)
9.8.2 080602 fix {windows,Thread}.c: clean-up on thread_kill(tid,SIGKILL)
9.8.2 080602 fix http.c: coped with polling a pipe from a filter on Win32
9.8.2 080601 fix delegated.c: enabled -Pxxx,yyy/ftp notation on Win32
9.8.2 080601 fix mount.c: MOUNT path with space as "C:/Program Files/DeleGate"
9.8.2 080601 new script.c: added CAT PERMIT = http : server : client TAC
9.8.2 080531 new script.c: added "LST a b c TSL" in a DGscript to be a,b,c
9.8.2 080531 new script.c: enabled PERMIT=http:+={URL}:remaining...
9.8.2 080531 new dgauth.c: added auth. options AUTHORIZER=-dgauth(expire=30s)
9.8.2 080531 fix dgauth.c: fixed to accept AUTHORIZER=-dgauth(user)
9.8.2 080531 new smtp.c: added SMTPCONF=srcroute to allow "foo%bar@baz" relay
9.8.2 080530 new smtp.c: added MOUNT="//domain/user smtp://server/domain/user"
9.8.2 080530 new smtp.c: added MOUNT="... smtp://user@domain@server"
9.8.2 080530 new dgauth.c: added -dgauth{u1:p1,u2:p2,...}
9.8.2 080530 fix mount.c: MOUNT="... file:*" for origin server on Win (x.x.x)
9.8.2 080530 fix {delegated,conf}.c: coped with redundant "/" as DGROOT=path/
9.8.2 080527 mod reshost.c: don't try resolve 192.168.* and 127.* (on WinCE)
9.8.2 080526 mod inets.c: shorten expire of cached Unknown result in HOSTS
9.8.2 080525 new wince.c: keep awake while proxying is active on WinCE
9.8.2 080525 new ftp.c: coped with 150 resp. with form. as "(123,456 bytes)"
9.8.2 080523 new winmo.c: ConnMgr stab. to be common exe on WinCE and Mobile
9.8.2 080523 new {nbio,socksv5}.c: dialup on connect() and sendto() failure
9.8.2 080523 new {delegated,env}.c: introduced -DSp to disable SIGPIPE
9.8.2 080517 new wince.c: supported auto. dialup by ConnMgr on WinMobile
9.8.2 080517 new wince.c: supported auto. dialup by RAS on WinCE
9.8.2 080523 fix iotimeout.c: setting ferror() on SIGPIPE in fflush/fwrite/...
9.8.2 080522 http.c: fixed storm of "ClientEOF: fputReponse" on SIGPIPE (pre9)
9.7.8 080522 fix {ftp,ftpgw}.c: fixed freezing respose relay in FTP/HTTP gw.
9.7.8 080521 fix http.c: don't truncate cache on SIGPIPE durling =+= 304 resp. 
9.8.2 080516 new wince.c: added POP, IMAP and SMTP by default on WinCE
9.8.2 080516 mod mount.c: don't apply MOUNTs for file: to smtp,pop,imap,nntp
9.8.2 080515 fix delegated.c: exiting single-proc. serv. as service on Win32
9.8.2 080515 fix windows.c: fixed "tell error" on huge(>2GB) PROTOLOG on Win32
9.8.2 080515 fix lock.c: fixed "tell error" storm on lock() failure on Win32
9.8.2 080515 fix {pop,imap}.c: made POP and IMAP be multi-thread safe
9.8.2 080515 fix {smtp,smtpgate}.c: made SMTP-DeleGate be multi-thread safe
9.8.2 080514 new windows.c: listing IP-Address of RNDIS/ActiveSync on WinCE
9.8.2 080514 fix wince.c: getting process list using lesser memory on WinCE
9.8.2 080514 fix wince.c: adjusting window size by device rotation on WinCE
9.8.2 080514 fix wince.c: removed the latency to detect "restart" file (pre29)
9.8.2 080513 fix delegated.c: don't create temporary file on c:/tmp on Win32
9.8.2 080513 fix windows.c: passing the key for -Fimp to service on Win32
9.8.2 080513 new windows.c: logging to c:/Windows/Temp/dgx.log if it exists
9.8.2 080512 fix {delegated,windows}.c: passing key for -Fimp to service/Win32
9.8.2 080511 fix delegated.c: passing CRYPT=pass to spawned children on Win32
9.8.2 080510 fix env.c: hide CRYPT,PASS,MYAUTH in LOGFILE (recorded by -dS)
9.8.2 080510 fix delegated.c: putting auth. cache on /Windows/Temp on Win32
9.8.2 080510 fix windows.c: encrypting CRYPT,PASSWD,MYAUTH in registry on Win32
9.8.2 080510 fix script.c: coped with +=C:/path/xxx.cdh
9.8.2 080510 fix script.c: restoring stdin after +=xxx.cdh (9.0.3)
9.8.2 080509 fix dgsign.c: passing PASSWD to the service on Win <Jan.Killian>
9.8.2 080509 fix http.c: stop relaying on client side disconn. with FTOCL CFI
9.8.2 080509 fix Makefile: SEGV on SIGPIPE in gzip/HTTP thread on FedoraCore (where -lstdc++ seems mandatory?)(pre18)
9.8.2 080507 fix wince.c: fixed tmpfile creation without SD-Mem (on WinCE4.2)
9.8.2 080507 fix wince.c: fixed creating tmpfile on WinCE (pre27)
9.8.2 080506 new wince.c: getting the file name of the current process on WinCE
9.8.2 080506 new wince.c: adding shortcut of DeleGate to "Start Menu" on WinCE
9.8.2 080506 new wince.c: testing connection to "wince.delegate.org" on WinCE
9.8.2 080506 fix wince.c: mutex of the control window refreshment on WinCE
9.8.2 080505 new wince.c: delay after the first packet trying get ACK on WinCE
9.8.2 080502 new wince.c: dynamic socket SO_SNDBUF adjusting on WinCE
9.8.2 080502 new wince.c: stdio buff. size by the multiple of MSS on WinCE
9.8.2 080501 fix http.c: fixed truncation of resp. by SO_LINGER={1,0} on WinCE
9.8.2 080430 fix ftpgw.c: removed delay in FTP/HTTP gw. on cache hit (pre22)
9.8.2 080425 new ssi.c: added file=path#show to show #fsize of executable
9.8.2 080425 fix wince.c: fixed detection of StorageCard on Win32 (pre27)
9.7.8 080425 fix windows.c: fixed ABORT on exit during init. with VC++ 2005
9.7.8 080424 fix commands.c: fixed -Fimp on Win32(fopen("con",rw))(9.4.0-pre18)
9.8.2 080424 fix _-fcloseFILE.c: ABORT with fclose fileno()=-1 (pre12) on Win32
9.8.2 080423 mod wince.c: default VARDIR=${StorageCard}/DeleGate on WinCE
9.8.2 080423 mod wince.c: default DGROOT=/DeleGate on WinCE
9.8.2 080422 fix delegated.c: enabled -nN for service on Win32
9.8.2 080421 fix delegated.c: fixed possible SEGV in service termination on Win
9.8.2 080420 new windows.c: -Eid to try inherit socket by WSADuplicateSocket
9.8.2 080420 mod delegated.c: transferring extended -dX to the service process
9.8.2 080420 new filter.c: implemented "pre-filter" as a thread
9.8.2 080419 new windows.c: -Dis/-Eis to disable/enforce socket inehrit on Win
9.8.2 080418 new delegated.c: -nN for serving with fixed number of processes
9.8.2 080417 fix http.c: fixed broken keep-alive with empty body with rewriting
9.7.8 080417 fix http.c: fixed delay of FTOCL CFI on empty body resp. <imao>
9.8.2 080416 mod delegated.c: stopped checking sum for /wince-dg.exe (WinCE)
9.8.2 080415 new wince.c: added a display of IpAddress of the host (WinCE)
9.8.2 080415 new wince.c: introduced a progress meter on WinCE
9.8.2 080414 new delegated.c: multiple -Qxxx like -Pxxx
9.8.2 080414 fix svport.c: faster termination on WinCE (pre24)
9.8.2 080414 mod http.c: no "badServer? beforeREQBODYx" log on normal HTTP resp
9.8.2 080413 fix delegated.c: SockMux with SERVER=proto://sv,-in:-:-P...(pre22)
9.8.2 080413 fix htmlgen.c: fixed heap error in /-/admin/ access (pre22)
9.8.2 080413 fix windows.c: implemented thread_exit()
9.8.2 080413 fix __pthread_create.c: fixed thread_exit() to clean-up the thread
9.8.2 080413 fix {ystring,wince}.c: fixed SEGV on fdopen(-1,mode)
9.8.2 080413 fix windows.c: fixed (re-) waiting exited thread with timeout
9.8.2 080412 fix delegated.c: terminate all sub-threads before exit (for WinCE)
9.8.2 080411 mod wince.c: modified refreshing window on exit (WinCE)
9.8.2 080411 fix delegated.c: fixed SEGV on exit from single-proc mode (WinCE)
9.7.8 080410 fix ftpgw.c: waiting 226 before sending QUIT (for MS-FTP)
9.8.2 080407 fix {wince,nbio}.c: stopped "close... --ERROR--" in LOGFILE(pre18)
9.8.2 080407 new wince.c: introduced a window for a control panel on WinCE
9.7.8 080407 mod ftp.c: coped with "spftp" with non-pipelined auth. (McAfee)
9.8.2 080404 mod wince.c: AUTH=admin:-man by default
9.8.2 080404 fix {htmlgen,admin}.c: fixed memory leaks in /-/admin/
9.8.2 080403 mod htmlgen.c: escaping UTF-7 like pattern in HTML from req. str.
9.8.2 080403 fix htmlgen.c: multi-thread safe HTML generation for /-/admin/
9.8.2 080403 new httpd.c: AUTHORIZER="authServ@_{realmName}_"
9.8.2 080403 new env.c: introduced DGDEF="Name[,Flag]:Data" + "_{Name,Opts}_"
9.8.2 080402 mod nbio.c: shorten timeout of SOCKS under heavy load/single-proc.
9.8.2 080402 fix {socks4,socks5}.c: file-descr. jamming in SOCKS/multi-threads
9.8.2 080402 fix wince.c: coped with recv(MSG_PEEK) after dup()
9.8.2 080402 mod delegated.c: loading delegated.conf with ".txt" extension
9.8.2 080331 new wince.c: enabled SOCKS + FTP-origin server by default on WinCE
9.8.2 080331 new ftp.c: implemented mkdir,rmdir,remove and rename as origin-FTP
9.8.2 080331 fix wince.c: enabled read() from on-memory tmpfile on WinCE
9.8.2 080331 fix {socks4,socks5}.c: fixed memory leak (of FILE) in Socks serv.
9.8.2 080331 new wince.c: coped with MSG_PEEK (of 1byte) on WinCE
9.8.2 080328 mod inets.c: refresh resolver-cache of a host on connect() error
9.8.2 080328 fix windows.c: fixed SEGV by dup. CloseHandle(fh) for mmap (pre10)
9.8.2 080325 fix windows.c: getting muliple DNS servers from registry on WinCE
9.8.2 080321 new {delegated,service,httpd}.c: transparent proxy for any protocol by SERVER="protocol://odst.-" on Linux <kevin>
9.8.2 080321 new {inets,nbio}.c: coped with SO_ORIGINAL_DST on Linux
9.8.2 080321 new {delegated,svport,servcie}.c: -P21/ftp,80/http,1080/socks,...
9.8.2 080320 fix wince.c: fixed gettein DNS info. from registry in Unicode
9.8.2 080319 new {windows,yshell}.c: introduced -Fregdump and regdump/yshell
9.8.2 080319 fix url.c: don't rewrite INPUT/VALUE attr. with MOUNT <hweidner>
9.7.8 080319 mod sslway.c: no sess cache with SV by default(TLSCONF=scache:acc)
9.7.8 080319 fix ystring.c: removed debug message for realloc()(Win32)
9.8.2 080316 fix windows.c: fixed possible jamming of dup2() with multi-threads
9.8.2 080316 new {master,sox.c}: connecting via a private SockMux thread
9.8.2 080314 fix vsaddr.c: multi-thread safe inet_ntoa()
9.8.2 080313 new access.c: introduced authentication by hand AUTHORIZER="-man"
9.8.2 080313 mod {http,iotimeout}.c: shorten IO_TIMEOUT in single process mode
9.8.2 080312 new {ddi,nbio}.c: recycling sw. out serv. conn. in HTTP keep-alive
9.8.2 080310 fix smtp.c: fixed possible infinite wait with SMTPCONF=callback 
9.8.2 080308 new {svport,yshell}.c: introduced -Pxxxx/ysh for remote control
9.8.2 080307 new nbio.c: recycling a socket for parallel connect() trial
9.8.2 080306 fix http.c: caring "204 No Content" as a cacheable empty-body
9.8.2 080306 fix http.c: don't gen. If-Mod. based on 4xx or 5xx resp. cache
9.8.2 080306 fix http.c: don't reuse the cache of "400 Bad Request",401,407
9.8.2 080306 fix http.c: fixed buff. for peeping cached head via mmap (pre15)
9.8.2 080306 new ystring.c: duplicating LOGILE to stderr with -fv option
9.8.2 080305 fix windows.c: fixed SEGV on thread creation on Win (pre15)
9.8.2 080305 mod http.c: -Dst for REMITTABLE=+,ssltunnel (default on WinCE)
9.8.2 080305 mod http.c: longer timeout for "recvbody" and "gunzip"
9.8.2 080305 fix nbio.c: fixed the detection of parallel connect()
9.8.2 080303 new nbio.c: introduced parallel connect() trial on latency
9.8.2 080302 fix dglib.h,{inets,ddi}.c: multi-thread safe err.flag of connect()
9.8.2 080301 fix http.c: enabled keep-alive with clnt. on empty body (304,HEAD)
9.8.2 080229 new inets.c: scattering the dest. addr. of TCP connection (-Ecs)
9.8.2 080228 new inets.c: auto. sorting of IP addr-list on conn. failure/delay
9.8.2 080224 fix http.c: fixed SEGV on WinCE (Mobile) by cache with mmap (pre6)
9.8.2 080224 fix http.c: fixed file-desc. leak on broken keep-alive with serv.
9.8.2 080223 mod inets.c: shorten the mutex of gethostbyname/addr()
9.8.2 080223 fix http.c: fixed duplicated closing of ToS/FromS/ServerSock
9.8.2 080223 mod http.c: don't flush chunk of 404 response to reduce SIGPIPE
9.8.2 080223 mod http.c: reduced recv() err by clnt disconn in keep-alive (Win)
9.8.2 080222 mod ddi.c: enabled multiple cached server-connections with -d1+N
9.8.2 080221 new wince.c: introduced a thread for delayed fclose() on WinCE
9.8.2 080221 fix ystring.c: fixed SEGV. on bzero(CriticalSec) on Win32
9.8.2 080220 fix windows.c: fixed mem. leak by CreateThread/ExitThread on Win32
9.8.2 080220 new {delegated,env,windows}.c: report of memory usage
9.8.2 080220 fix gzip.c: mutex of malloc()/free() in gzdopen()/gzclose()
9.8.2 080219 fix ystring.c: mutex of putenv()
9.8.2 080219 fix randstak.c: stopped mem. leak by randenv()
9.8.2 080218 fix windows.c: fixed abortion by raise(SIGABRT/SIGPIPE) with -d1
9.8.2 080218 fix http.c: fixed SEGV without vsnprintf() (ex. SunOS5.5)(pre12)
9.8.2 080218 fix file.c: disalbed freeTmpFile() to avoid close(dangling-fd)
9.8.2 080218 fix http.c: don't guznip/gzip for respons of HEAD and 304
9.8.2 080217 fix ystring.c: mutex of filemmap() / freemmap() on Win32
9.8.2 080217 fix Thread.c: fixed repetitive "clear signal 22" on Win32
9.8.2 080217 fix {ddi,windows0}.c: reduced fragmentation of the heap
9.8.2 080216 fix windows.c: fixed {gzip,SSL} thread's HANDLE leak on Win
9.8.2 080216 fix windows.c: coped with thread HANDLE val. larger than 0xFFFF
9.8.2 080216 fix {http,Threads}.c: multi-threads safe parallel HTTP realy
9.8.2 080216 mod http.c: enlarged HTTPCONF=max-reqline:8k (<- 4k)
9.8.2 080215 fix http.c: fixed duplicated close(ServerSock) after CONNECT
9.8.2 080215 fix ystring.c: suppressed debug mssg. for realloc(9.7.0)<bginfo>
9.8.2 080215 fix reshost.c: detection of the default RESOLV with "sys" (pre12)
9.8.2 080214 fix windows.c: mutex pipe() on Win32
9.8.2 080214 fix windows0.c: mutex of tmpfile() creation on Win32
9.8.2 080214 fix ystring.h: mutex of dup() and dup2() on Win32
9.8.2 080213 fix fcloseFILE.c: not to be used prior to _-fcloseFILE.c on Win32
9.8.2 080213 fix file.c: fixed not to do chown(dir) after failed mkdir(dir)
9.8.2 080213 mod conf.c: increased MAXIMA=standby:16 to 32
9.8.2 080213 fix String.c: multi-thread safe scan_List()
9.8.2 080212 fix Thread.c: re-enabled compilation on CYGWIN (pre9)
9.8.2 080211 fix {ystring,windows}.c: mutex of socket() and closesocket()
9.8.2 080210 fix {http,file}.c: fixed fd/handle jamming by duplicated close()
9.8.2 080209 fix {delegated,Thread}.c: terminating by SIGTERM with -d1 on Win32
9.8.2 080209 fix unix.c: fixed SEGV by expand tmpfile() before mmap() on CYGWIN
9.8.2 080209 fix mkmake.c: coped with making on a tty of SSH/CYGWIN
9.8.2 080207 mod inets.c: ignore HTTP-Reload for DNS cache in 300 sec. with -d1
9.8.2 080207 fix {inets,resconf}.c: multi-thread safe RESOLV (RES_ORDER)
9.8.2 080206 fix fcloseFILE.c: fixed file-descriptor jumming in multi-threads
9.8.2 080206 mod randstack.c: no randfd() with para. sess.
9.8.2 080206 fix url.c: multi-thread safe URL rewriting (fixed possible SEGV)
9.8.2 080205 new http.c: HTTPCONF=cache:less-reload to supp. rel. by max-age=0
9.8.2 080205 mod http.c: relay If-Mod for req. with Cache-Control:max-age=0
9.8.2 080204 new http.c: don't gzip for resp. with "X-Pragma: no-gzip"
9.8.2 080203 new {gzip,gzio}.c: added fgzflush() callback for flush slow gunzip
9.8.2 080202 fix {admin,form2conf}.c: /-/admin/ to be muti-thread safe
9.8.2 080201 mod iotimeout.c: flushing for smooth relay of slow text without NL
9.8.2 080201 new {admin,log}.c: capturing without writing to local LOGFILE
9.8.2 080201 fix {delegated,log}.c: inherit UDP-LOG sockets by spawn on Win
9.8.2 080131 new admin.c: added /-/admin/logging to control -vX & capture log
9.8.2 080131 new windows.c: implemented UDP socketpair() on Win
9.8.2 080129 new http.c: memory mapped peeping of HTTP cache on Win and Unix
9.8.2 080128 new log.h,*.c: -vX and -dX on shared memory among DeleGate procs.
9.8.2 080128 new unix.c: implemented memory map on Unix
9.7.8 080127 fix hostaddr.c: freeze/SEGV on "slow gethostbyname"on Linux(5.6.1)
9.8.2 080125 fix sslway.c: fixed to clear the session cache on ssl_conn() error
9.8.2 080125 fix sslway.c: ssl_conn() err with SNI via chained MITM(9.8.0-pre2)
9.8.2 080125 new sslway.c: added TLSCONF=cache:no for xcahce:no,scache:no
9.8.2 080125 new http.c: introduced -dp[qrst] option to peep message
9.8.2 080123 mod {*,Thread}.c: implemented signal() context for each thread
9.8.2 080122 mod *.c: reduced warning from compilers
9.8.2 080121 fix log.c: mutex of on-memory log-buffer (for abort-log)
9.8.2 080121 fix String: fixed SEGV by reusing randstack with para-sess.
9.8.2 080120 fix delegated.c: enabled SIGTERM/SIGINT in para-sess. on Unix
9.8.2 080120 fix file.c: mutex of fclose and tmpfile for para-sess. on Unix
9.8.2 080120 new _-mutex.c: implemented timeout of critical section on Unix
9.7.8 080119 fix iotimeout.c: fixed undefined delay in text/gunzip relay(8.1.0)
9.8.2 080118 mod http.c: flushing for smooth output on slow text/gunzip relay
9.7.8 080117 fix smtp.c: enlarged com/arg buff. to stop VStr overflow<suzuki_h>
9.8.2 080117 fix http.c: SEGV on un-init. ptr in non-HTML relay(pre6)<suzuki_h>
9.8.2 080117 fix wince.c: fixed frozen in CreateDir.+GetFileAttr. on WinCE
9.8.2 080117 fix http.c: breaking keep-alive with multi-session threads
9.7.8 080114 fix Strftime.c: fixed timestamp in sub-second not to go back past
9.8.2 080114 fix wince.c: getting current time in milli-seconds on WinCE
9.8.2 080114 mod wince.c: HTTPCONF=bugs:no-flush-chunk by default on WinCE
9.8.2 080113 fix Makefile: fixed possible loop in "make -s files"
9.8.2 080112 fix {process,http}.c: fixed dup. fclose with ResponseFilter thread
9.8.2 080112 mod ystring.c: mutex of socketpair and accept on Win (osfhandle)
9.8.2 080112 fix http.c: closing pipe (socket) on "timeout waiting gunzip"
9.8.2 080112 fix httpd.c: disabled reusing tmpfile on multi-threads (on WinCE)
9.8.2 080111 fix {ddi,Thread.c}: fixed updating/retrieving active thread tables
9.8.2 080111 fix gzip.c: stopped duplicated close for gzip/gunzip (on Win)
9.8.2 080111 new {Thread,delegated}.c: introduced thread-group (per session)
9.8.2 080111 fix inets.c: fixed jamming in common hostent buf. in multi-threads
9.8.2 080110 fix ddi.c: limited keep-alive with server in multi-sess. threads
9.8.2 080110 mod serivce.c: suppressed Ident to client on access error on WinCE
9.8.2 080110 fix nbio.c: getting right errno in non-blocking conn. error on Win
9.8.2 080110 fix service.c: connecting to serv. from parallel threads(on WinCE)
9.8.2 080107 fix http.c: fixed broken file-desc. in threads by duplicated close
9.8.2 080106 fix delegated.c: "DGLEV" coped with multi-session-threads
9.8.2 080106 new http.c: faster cache check and reading using mmap on Windows
9.8.2 080106 mod http.c: no-gzip for local-hosts (on WinCE)
9.8.2 080104 new wince.c: "/Storage Card" etc. as candidates of DGROOT on WinCE
9.8.2 080103 new wince.c: implemented tmpfile() as on-memory file on WinCE
9.8.2 080101 new ftp.c: auto. CHARCODE conv. to UTF-8 for path in req. on WinCE
9.7.8 080101 fix windows.c: forwarding DYLIB_xxx to the service process
9.8.2 071231 fix stls.c: forwarding CONNECT server-name as TLSxSNI in MITM
9.8.2 071230 fix http.c: don't retry serv. conn. on disconn. keep-alive in MITM
9.8.2 071229 mod {nbio,http}.c: CONNECT/SSLtunnel coped with multi-threads
9.8.2 071228 fix {sslway,filter}.c: reduced memory-leak at SSLway filter invok.
9.8.2 071228 fix httpd.c: return 304 with CHARCODE for non-text as origin serv.
9.7.8 071227 fix dl.c: remembering consistent full-path of DLL on Windows
9.8.2 071227 mod _-poll.c: POLLRDHUP on Fedora for imm. detection of disconn.
9.8.2 071226 mod gzip.c: smooth gunzip by read/Zfread on non-WinCE with DG_Zlib
9.8.2 071226 fix http.c: discarding incomplete cache (truncated by client reset)
9.8.2 071223 fix http.c: discarding CGI-output cache truncated on client reset
9.8.2 071223 new http.c: added HTTPCONF=cache:vary (canbe set by cache:any too)
9.8.2 071222 mod http.c: immediate break out of gunzip+gzip on client reset
9.8.2 071221 mod http.c: set linger=0 on WinCE (in single process DeleGate)
9.8.2 071220 fix http.c: don't leak memory for FILE in CONNECT relay
9.8.2 071220 mod wince.c: faster relay for text data on WinCE
9.8.2 071220 mod {http,nbio}.c: no-limit the max. SSL turns at the init. 5 sec.
9.8.2 071219 fix wince.c: fixed memory leak by unclosed FILE for gzip filter
9.8.2 071217 new windows.c: implemented futime() on Windows
9.8.2 071216 fix iotimeout.c: fixed leak of FILE unclosed on EOF (2.4.8,9.6.3)
9.7.8 071216 fix http.c: don't gzip non-text data (on head. PEEK failure)(9.6.3)
9.8.2 071215 fix file.c: caching URL including "//" or "?" on WinCE (Windows)
9.8.2 071215 mod {http,cache}.c: don't remove cache dir. on 304 (non 404) resp.

9.8.2 071214 fix wince.c: writing Unicode to console on WinCE
9.8.2 071212 new ystring.c: introduced mutual-exclustion of heap allocation
9.8.2 071212 new {*,ystring.c}: detecting memory-leak in heap
9.8.2 071212 fix {http,ddi}.c: fixed memory-leak in heap in HTTP request
9.8.2 071212 mod old_alloca.c: enabled alloca() on Windows
9.8.2 071212 fix String.c: possilble broken param. scanned by dangling ref.
9.7.8 071212 fix log.c: possible SEGV by dup. free() on SIGTERM
9.8.2 071210 mod {String,ddi,dnsnode,htmlgen,resconf,reshost}.c: reduced malloc
9.8.2 071210 new wince.c: coped with logging in milli-seconds
9.8.2 071210 mod windows.c: coped with large SOCKET handle value on WinCE
9.8.2 071209 fix {windows,fstat}.c: enabled CACHE on WinCE
9.8.2 071209 mod http.c: reduced the "relayio" thread for gzip on Windows
9.7.8 071208 fix ystring.h: coped with "%lld" output in LOGFILE on ARM CPU
9.8.2 071208 mod wince.c: made fileno(FILE*) be positive value on WinCE
9.8.2 071207 new wince.c: DGROOT="/SD memor/DeleGate" by default on WinCE
9.8.2 071206 fix svstat.c: keeping server status file on WinCE
9.8.2 071203 mod conf.c: added "/Windows" and "/" to the default LDPATH on Win
9.8.2 071203 new wince.c: implemented "nul" device emulation on WinCE
9.8.2 071202 fix {http,httpd}.c: downloading Unicode mapping table on WinCE
9.8.2 071201 new wince.c: implemented getenv() and putenv() for WinCE
9.8.2 071201 new wince.c: coped with loading DLL on WinCE
9.8.2 071201 new Zlib,gzip.c: coped with gzip/gunzip on WinCE
9.8.2 071130 fix ystring.h,{file,wince}.c: set binary-IO for FILE on WinCE
9.8.2 071129 fix {httpd,wince}.c: coped with file-name in Unicode on WinCE
9.8.2 071129 fix sox.c: fixed infinite "POLL_ERROR 8" log. on POLLERR (SunOS5)
9.8.2 071129 new {wince,windows}.c: implemented Scandir() on WindowsCE
9.8.2 071129 fix windows.c: waiting thread on WindowsCE
9.8.2 071129 fix {process,http}.c: ResponseFilter by thread (for WindowsCE)

9.8.2 071125 new telnet.c: implemented telnet to SSH server GW
9.8.2 071124 fix wince.c: getting DNS server from the registory/WinCE
9.8.2 071122 fix Strftime.c: detecting out-of-range in month and wday
9.8.2 071122 new ystring.h,log.c: logging where Finish() is called
9.8.2 071122 new {delegated,env}.c: introduced MAXIMA=restart:N
9.8.2 071121 fix conf.c: fixed not to create /tmp and /var on Windows
9.8.2 071117 new {wince,windows,include-ce/,*.c}.c: ported onto WindowsCE

9.8.1 071116 new ftp.c: tentative FTPCONF=thruesc
9.7.8 071116 fix file.c: don't map MOUNT file:dir/* -> //dir/* with CHROOT=/
9.7.8 071116 fix file.c: re-enabled stat("path/") with stati64() (9.2.2-pre3)
9.7.8 071115 mod ___findfirst.c: scanning dir "C:" as "C:/"

9.7.7 071114 fix *.c: changed time() from _time64() to _time32() with VS2005
9.7.7 071110 new smtp.c: introduced SMTPCONF=MX:mail-servers:recipient-domains
9.7.7 071109 fix windows.c: revival of IPv6 on Windows (disabled since 9.2.2)
9.7.7 071107 fix http.c: enabled onerror MountOption for origin/gatway<Waldorf>
9.7.7 071105 fix *.[hc]: coped with compilation with VC++ 2005
9.7.7 071031 fix dgsign.c: compilation with gcc -g3 option <suzuki_h>
9.7.7 071030 fix {log,dgsign}.c: SEGV with SERVER=news and -vs <suzuki_h>
9.7.7 071028 fix http.c: overflow and frozen req. with mal-formed modified date

9.8.0 071102 fix {yselect,fpoll}.h: coped with CFLAGS=-m64 on Solaris10/amd64
9.8.0 071031 new {filter,sslway}.c: introduced CERTDIR=dir and me.pem, ca.pem
9.8.0 071031 fix ystring.{h,c}: preventing access to uninitialized VStr
9.8.0 071031 fix socks5.c: fixed finishing on the death of server in f.g.(Win)
9.8.0 071028 new http.c: HTTPCONF=no-cache:no-cache to follow resp. head
9.8.0 071028 mod src/Makefile: added /MT on Win32
9.8.0 071022 new stls.c: introduced STSL=fsv/im,fcl/im for implicit SSL
9.8.0 071019 fix stls.c: implicit SSL to serv. by SERVER=imaps:// and pop3s://
9.8.0 071019 new imap.c: supported "imaps:" in MOUNT

9.7.6 071026 fix src/Makefile: stopped /MT on Win32(SocksV5 port error)<bginfo>
9.7.6 071026 fix http.c: fixed HTTP "transmitted" log on SunOS5 (no vsnprintf)
9.7.6 071025 fix iotimeout.c: SEGV<-SIGPIPE on Solaris<=8 (9.6.3-pre4)<y-tsuch)
9.7.6 071024 fix windows.c: retrying CreateThread() on failure on Windows
9.7.6 071024 fix udprelay.c: fixed relay error by array overflow <NoSFeRaTU>

9.7.5 071022 fix http.c: SEGV on "<=+= 304" cache+keepalive+SIGPIPE(9.6.3-pre6)
9.7.5 071021 fix src/Makefile,fpoll.c: comilation with /MT on Win32
9.7.5 071021 fix windows.c: retrying _pipe() on failure
9.7.5 071016 fix delegated.c: fixed possible SEGV at invocation by arg. "%s"
9.7.5 071016 fix String.c: fixed trunc. of SMTPGATE REJECT/ACCEPT list at 1KB
9.7.5 071015 fix {http,gzip}.c: broken data by sync. err. gunzip thread (9.6.0)
9.7.5 071013 mod http.c: use auth. in rURL in MOUNT as ftp://user:pass@serv

9.8.0 071013 fix {delegated,svport}.c: fallback on service error on Win (9.2.3)
9.8.0 071013 new access.c: added AUTHORIZER="-crc32/4d{key}"
9.8.0 071012 fix ftp.c: coped with AUTHORIZER in MOUNT as an origin FTP server
9.8.0 071010 fix {delegated,dl}.c: setting LD_LIBRARY_PATH=${LDPATH} and exec()
9.8.0 071010 fix delegated.c: expanding ${HOME} in DGPATH and LDPATH

9.8.0 071008 new sslway.c: supported TLS ext. Server Name Inidication (SNI)
9.8.0 071004 new access.c: added AUTHORIZER=-crc32/key

9.7.4 071007 fix sslway.c: fixed to clear errors in previous SSL or crypto
9.7.4 071006 fix ystring.c: fixed possible buffer overflow by a '\0' (8.10.3)
9.7.4 071005 new sslway.c: supported chained certificate by SSLway -cert option
9.7.4 071003 fix httpd.c: fixed VStr overflow writing '\0' out of range (9.4.2)

9.8.0 071002 new stls.c: added STLS=mitm,-fsv to relay HTTPS/CONNECT to HTTP
9.8.0 070922 mod nbio.c: getting errno by SO_ERROR on nonblocking connect()
9.8.0 070914 mod {log,delegated}.c: replaced str_sprintf/LOGFILE with sprintf 
9.8.0 070912 new {ddi,socks,service}.c: applied CLUSTER for SOCKS with auth.
9.8.0 070912 mod master.c: regard as SOCKS=h:p:"*" when CONNECT=socks only
9.8.0 070829 new ldap.c: coped with MOUNT to "ldaps://" in the right-hand rURL
9.8.0 070823 fix {delegated,log}.c: let log completely silent with "(cond)-vs"
9.8.0 070812 fix timer.c: forwarding SIGALRM (SEGV on connect() in thread/Unix)
9.8.0 070811 new service.c: introduced CLUSTER=proto:serv1,serv2,serv3,...

9.7.3 070930 fix conf.c: refined detection of mem. shortage on Linux (MAXIMA)
9.7.3 070929 fix http.c: fixed shorten TIMEOUT=io:10 on memory shortage (9.6.3)
9.7.3 070927 fix delegated.c: killed by SIGPIPE on Solaris8 (9.4.3)<y-tsuchida>
9.7.3 070925 fix delegated.c: coped with daemon's output redirected to pipe

9.7.2 070925 fix nbio.c: fixed disconnection of SSLtunnel on FreeBSD (9.6.0)
9.7.2 070921 fix JIS.c: mixed EUCJP+Shift_JIS in explicit charset=EUC-JP
9.7.2 070919 fix iotimeout.c: getting SIGPIPE/write-TIMEOUT on LinuxThreads
9.7.2 070918 fix Thread.c: cause SIGPIPE in thread on Lin,Sol (disabled/9.6.2)

9.7.1 070916 fix ddi.c: disconn. serv. in keep-alive with FFROMSV
9.7.1 070915 mod http.c: allow multiple '\0' in HTML in conversion
9.7.1 070915 mod htccx.c: apply SVCC for pages without explicit charset decl.
9.7.1 070915 mod JIS.c: coped with bad charset name "ShiftJIS" for "Shift_JIS"
9.7.1 070914 fix process.c: fixed possible SEGV in spawnFilter()
9.7.1 070914 fix process.c: fixed possible freezing in spawnFilter()
9.7.1 070914 fix log.c: fixed SEGV on SIGPIPE to thread with -va (MacOSXi,Win)
9.7.1 070913 fix http.c: do gzip for large HTML (>1MB) as an origin HTTP on Win
9.7.1 070913 fix process.c: SEGV on threaded gzip/HTML/originHTTP/SSL (FreeBSD)
9.7.1 070913 fix iotimeout.c: fixed SEGV on SIGPIPE to thread (MacOSXi)

9.7.0 070824 new ftp.c: added FTPCONF=timeout:N
9.7.0 070909 fix tcprelay.c: frozen FSV=sslway waiting sever-side close (8.9.3)
9.7.0 070909 fix ftp.c: do disconn. on QUIT from server-side with STLS=fcl(9.6)
9.7.0 070908 fix Thread.c: implemented timeout of thread_wait() on Unix
9.7.0 070908 fix http.c: replying /-/builtin/icons/ and /-/admin/ in MITM mode
9.7.0 070908 fix http.c: cleared Proxy-Auth. on 'Unknown host' error in MITM
9.7.0 070907 fix {http,ddi}.c: forwarding Proxy-Auth. in MITM with MYAUTH=%U:%P
9.7.0 070907 fix http.c: don't forward-back hop-by-hop Proxy-Auth. error (407)
9.7.0 070906 fix http.c: fixed empty resp. for intermittent gziped via PROXY
9.7.0 070905 fix http.c: fixed empty resp. for slow gziped resp. on Windows
9.7.0 070903 mod windows.c: adding file permission on Windows (FILEACL=SYSTEM)
9.7.0 070901 mod windows.c: showing OWNER=user on error in StartService
9.7.0 070901 mod windows.c: coped with isatty() on CYGWIN
9.7.0 070831 new htccx.c: using ie=e or Encoding=e in URL if without SVCC
9.7.0 070831 fix ystring.h,mkmake.c: compilation on OpenBSD (9.6.3)
9.7.0 070830 mod http.c: permit Keep-Alive with -Pxxx/admin if shared with user
9.7.0 070829 mod htccx.c: substitute SVCC by ie=e or ENCODING=e in URL (9.4.4)
9.7.0 070827 fix conf.c: use explicit MAXIMA=delegated:N (9.6.3-pre8)
9.7.0 070826 mod {http,ddi}.c: breaking Keep-Alive proc. when server is killed
9.7.0 070826 mod http.c: leave Cont-Len on detatch-buff if without mod. (9.6.2)
9.7.0 070826 mod delegated.c: randomizing fd for 1st req. of StickySever on Win
9.7.0 070825 new http.c: guessing Content-Type of resp. if not indicated
9.7.0 070824 mod {dnsnode,log,ddi}.c: reduced realloc() to avoid mem leak (OSX)
9.7.0 070824 fix http.c: removed 10sec. delay in gunzip on Win (9.6.3-pre2)
9.7.0 070824 fix resconf.c: fixed possible SEGV with RESOLV=dns:ns:List (9.0.3)
9.7.0 070817 fix ystring.c: retrying realloc() on failure
9.7.0 070814 mod {conf,nbio}.c: don't supp. socket buff. exp. with enough mem.

9.6.3 070808 new conf.c: don't expand socket-buffer on small memory hosts
9.6.3 070807 fix windows.c: path with space as "Program Files"<firefly>(9.2.3)
9.6.3 070806 new {delegated,conf}.c: MAXIMA=delegated:N for small memory hosts
9.6.3 070806 new forkspawn.c: protected fork() from signals (SIGTERM)
9.6.3 070805 fix ystring.h: coped with "%f" format specifier on __amd64__
9.6.3 070805 new {Thread,__pthread_create}.c: randomized thread stack
9.6.3 070804 fix http.c: larger stack for gunzip thread for KURO-BOX-PRO
9.6.3 070804 fix http.c: suppressed gzip for small body (< 256B)
9.6.3 070803 fix sslway.c: fixed mutual exclusion of SSL session cache update
9.6.3 070802 fix http.c: fixed truncation of (gzip) data received via gunzip
9.6.3 070802 fix http.c: fixed disconn. of HTTPS/SSL/MITM server in keep-alive
9.6.3 070801 mod {delegated,file}.c: lighter wait /dev/null by reusing
9.6.3 070729 fix http.c: don't leave trunc. cache got by broken para. update
9.6.3 070729 fix {http,distrib}.c: parallel cache update getting chunked resp.
9.6.3 070729 fix http.c: waiting (TIMEOUT=io) slow resp. via a gunzip thread
9.6.3 070729 fix distrib.c: frozen gzip+CacheDistributor on parallel download
9.6.3 070728 new resolv.c: coped with nameservers on IPv6 address <tpeland>
9.6.3 070728 fix sslway.c: disabled session cache when unusable(Vine, KURO-BOX)
9.6.3 070727 mod sslway.c: load libcrypto before libssl (for Vine and KURO-BOX)
9.6.3 070727 fix {ddi,iotimeout}.c: clear per thread SIGPIPE counts at new req.
9.6.3 070727 fix http.c: introduced the timeout in GETRESPBIN
9.6.3 070727 fix http.c: SEGV on skipping resp. on "HTTP temporary error"(pre4)
9.6.3 070726 fix sslway.c: coped with the "%f" format specifier for KURO-BOX
9.6.3 070726 mod delegated.c: reduced Sticky detecting the activity of Stickies
9.6.3 070726 fix stls.c: removed 1.0s delay in MITM (serv in Keep-Alive)(9.6.0)
9.6.3 070726 mod http.c: removed unnecessary stack padding for threads (9.6.0)
9.6.3 070725 mod http.c: apply gzip to CFI output
9.6.3 070725 fix gzip.c: suppressed "FATAL: gzread()..." log on non fatal error
9.6.3 070724 fix http.c: fixed frozen SSL/sv thread on SIGPIPE with empty req.
9.6.3 070724 fix http.c: fixed SEGV in gunzip thread on stack growth(ex.SIGPIPE)
9.6.3 070724 fix http.c: fixed SEGV with both of gzip+gunzip threads
9.6.3 070723 fix http.c: duplicated gzip encoding (9.6.3-pre3)<pyzarlab>
9.6.3 070722 fix http.c: fixed SEGV on jamming in parallel fclose()
9.6.3 070721 fix {unix,log,Strftime}.c: fixed "spin_lock" in logging on SIGPIPE
9.6.3 070720 fix {http,iotimeout}.c: fixed frozen process and SEGV on SIGPIPE
9.6.3 070720 fix http.c: stopped repetitive SIGPIPE for chunked encoding
9.6.3 070719 fix Thread.c: blocked SIGPIPE during waiting a child thread
9.6.3 070718 fix iotimeout.c: don't cause duplicated longjump on SIGPIPE
9.6.3 070718 fix {http,gzip}.c: immediate exit from a thread with SIGPIPE
9.6.3 070717 fix http.c: gzip encoding for the output of CFIscript (on Win)
9.6.3 070717 fix http.c: enabled gzip encoding for data larger than 1MB
9.6.3 070716 fix iotimeout.c: detection of bad longjmp to dangling jmp_buf
9.6.3 070715 fix filter.c: don't shutdown FTOSV sock to get resp. (9.6.3-pre1)
9.6.3 070715 fix http.c: fixed broken gunzip under heavy load on Windows
9.6.3 070715 mod {delegated,nbio}.c: suppressing expsockbuf() under heavy load
9.6.3 070715 fix process.c: retrying fork(openFilter) under heavy load on Unix
9.6.3 070714 fix {http,windows}.c: don't fclose()/free() in non-mainthread
9.6.3 070714 fix windows.c: made socketpair() inheritable by default
9.6.3 070713 new pop.c: enabled "USER u@host..port" for "USER u@host:port"
9.6.3 070713 new pop.c: supported STLS=mitm with SERVER=pop3s
9.6.3 070711 fix {sslway,filter}.c: fixed data truncation with a filter on Win
9.6.3 070710 fix http.c: reusing FTOCL on re-conn. on broken keep-alive serv.
9.6.3 070709 fix windows.c: detecting system() proc. aliveness by CPU usage
9.6.3 070709 fix filter.c: retrying waiting thread after timeout (Win)
9.6.3 070708 fix delegated.c: waiting thread and process with CFI+SSL thread
9.6.3 070708 fix {file,ystring}.c: detecting malloc/fdopen/free/fclose jamming
9.6.3 070707 fix process.c: fixed frozen filter process on spawn() error
9.6.3 070707 fix randstack.c: reduced tmpfile on Windows for randfd
9.6.3 070706 fix ftp.c: re-enabled FTPCONF=proxy:user (9.2.2)
9.5.7 070704 fix socks5.c: forwarding UDP to MASTER (9.4.3-pre10)<Hayashinaka>
9.6.3 070704 fix {filter,windows}.c: don't inherit socketpair() for threads
9.6.3 070703 fix delegated.c: salvaging the fd for server with FSV=sslway
9.5.7 070628 mod delegated.c: for Windows Update at www.update.microsoft.com
9.5.7 070628 fix filter.c: re-enabled re-gzip/HTTP for browsers(8.6.0)<bieber>
9.5.7 070628 fix http.c: immediate break on detection of client-disconnection
9.6.3 070627 new windows.c: reduced TCP usage for heavy use of socketpair()
9.6.3 070627 fix sslway.c: added mutex of writing session-cache among threads
9.6.3 070626 new sslway.c: supported "-no_ssl2" option
9.5.7 070626 fix sslway.c: blocking on negotiation error in ssl_accept() <joe>
9.6.3 070626 fix sslway.c: freezing in ssl_accept/connect error with threads
9.6.3 070625 fix gzip.c: don't poll the pipe between threads on Windows
9.6.3 070625 fix windows.c: retrying socketpair() failed under heavy load
9.6.3 070625 fix delegated.c: swift sweep of proc. on accidental server finish
9.6.3 070625 fix windows.c: kill(pid,0)=1,errno=ESRCH if not in STILL_ACTIVE
9.5.7 070624 fix nbio.c: fixed inputReady() for pipe on Windows (9.x.x)
9.6.3 070624 mod delegated.c: don't let process block in accept() on Windows
9.6.3 070624 fix http.c: freezing by dup. SIGINT/TERM (3.0.54) on LinuxThreads
9.6.3 070623 fix __pthread_kill.c: compilation on several OSs (since 9.6.2)
9.6.3 070622 fix {sox,ddi,stls}.c: fixed auto. re-connection with STLS=fsv
9.6.3 070621 fix gzip.c: fixed frozen gzip thread on SIGPIPE on Solaris10

9.6.2 070619 fix http.c: setting SVCC and Vary: on "detach" for slow-response
9.6.2 070619 fix sftp.c: coped with newer sftp (LIST/NLST) which forces ECHO on
9.6.2 070617 fix ftp.c: freezing in FEAT command after SSL established(in FTPS)
9.6.2 070616 fix nntpgw.c: releasing POP/NNTP conn. on "302 Moved"
9.6.2 070616 fix httplog.c: broken time record in "%f" "double" in PROTOLOG
9.6.2 070616 fix Thread.c: blocked SIGINT/SIGTERM/SIGPIPE in child threads
9.6.2 070616 fix Thread.c: protected jamming of thread_fork() from signals
9.6.2 070614 fix iotimeout.c: fixed possible dangling longjump() to old thread
9.6.2 070614 fix ftp.c: FTP/HTTP gw. don't try RETR for non-existing file
9.6.2 070613 fix log.c: suppressed flockfile() without threads (for Solaris8?)
9.6.2 070613 fix {sslway,gzip,dl}.c: coped with loading DLL on CYGWIN
9.6.2 070612 fix {Thread,http}.c: killing main-thread in signal handler
9.6.2 070612 new __tcsetattr.c: built-in "stty -echo" for Unix
9.6.2 070611 fix {sftp,ccache}.c: fixed sftp/HTTPS (on BSD)
9.6.2 070611 fix {http,Thread}.c: finishing on SIGTERM with threads
9.6.2 070611 fix ftp.c: fixed sftp/FTP to exit (on login failure?)
9.6.2 070610 fix mime.c: decoding Transfer-Encoding in "textonly" extraction
9.6.2 070610 fix {mime,nntp,nntpgw}.c: times lighter POP/NNTP/HTTPS (no Xfgets)
9.6.2 070609 fix {forkspawn,sslway,gzip}.c: introduced setCloseOnFork()

9.6.1 070606 fix {forkspawn,delegated}.c: fixed bad "MAX_DELEGATE"(9.6.0-pre11)
9.6.1 070606 fix vsocket.h: compilation on non IPv6 capable OSs
9.6.1 070606 fix sftp.c: fixed truncated data on downloading (RETR)
9.6.1 070606 mod iotimeout.c: stopped sleeping in doNice() with threads
9.6.1 070606 mod filter.c: expanded the FSV/FCL socket buffer (for Win)
9.6.1 070605 fix windows.c: coped with the compilation with /MT option
9.6.1 070602 fix distrib.c: disabled process fork() after thread_fork()
9.6.1 070602 new windows.c: implemented flockfile() for Windows 
9.6.1 070601 fix delegated.c: no "DONT Finish" mssg on SIGTERM with threads/Win
9.6.1 070601 fix stls.c: fixed STLS error testing (based on signed char on ARM)
9.6.1 070601 fix __opendir.c: use dirent with __ino64 for -DSTAT64 (on Linux)
9.6.1 070601 mod log.c: modified LOGFILE="" to leave logs with -va as -vs do
9.6.1 070601 fix stls.c: don't connect to serv. if MOUNTed to another server
9.6.1 070531 new mount.c: added "again" MountOption to apply MOUNTs again
9.6.1 070531 mod httphead.c: matching MOUNT by full-URL first on MITM
9.6.1 070531 fix master.c: SUDO for Solaris older than Sol-10 (9.4.0)<k-yamada>
9.6.1 070529 fix {cksum,credhy}.c: fixed CRC32 error (by signed char on ARM)
9.6.1 070528 fix log.c: fixed SEGV on adjusted double for %f at 8bytes boundary
9.6.1 070527 fix ystring.h,{Strftime,strrcasestr,sftp}.c:ported to KURO-BOX-PRO
9.6.1 070528 fix log.c: mutex of log writing among threads using flockfile()
9.6.1 070528 fix http.c: fixed dangling FSV=sslway thread in MITM on CACHE hit
9.6.1 070525 fix cfi.c: fixed MIME-Filter: and CGI: (9.2.4-pre14)<shima>
9.6.1 070524 mod JIS.c: charset in META than Content-Type ? (9.2.4-pre12)
9.6.1 070523 fix http.c: relaying '\0' in HTML in conversion (MOUNT, CHARCODE)
9.6.1 070522 fix http.c: fixed truncated gunzip/HTTP on Solaris (9.6.0) <shima>

9.6.0 070519 mod httpd.c: reusing tmpfile() for 302 to reduce delay on Windows
9.6.0 070518 mod httpd.c: logging 302 for Moved (as origin) generated by self
9.6.0 070518 mod delegated.c: enabled StickyServer for origin SERVER=https
9.6.0 070518 fix mkcpp.c,vsocket.h: coped with making on RedHat6
9.6.0 070515 fix sox.c: VStr overflow by large data right after conn. done
9.6.0 070514 fix cgi.c: fixed possible SEGV with SSL thread on CYGWIN+SSHd
9.6.0 070512 fix ftpgw.c: /favicon.ico in FTP/HTTP gw. with MOUNT="/ ftp://"
9.6.0 070512 new {socks,socks5}.c: applied TIMEOUT=login for SOCKSv5 login
9.6.0 070512 fix ftp.c: don't freeze on wait() in SFTP/FTP gw. with SSL thread
9.6.0 070511 fix nntp.c: don't inherit socket for client to POP/NNTP-GW
9.6.0 070511 fix nntpgw.c: fixed pending SSL thread with NNTP/HTTP gw. err.
9.6.0 070511 fix httpd.c: returning /favicon.ico with SERVER=https
9.6.0 070510 fix Thread.c: repaired Getpid() to show the main-thread (pre10)
9.6.0 070510 fix sslway.c: freezing on ssl_connect() failure with thread

9.6.0 070508 fix cgi.c: fixed SEGV by putenv on STLS=fsv with thread (on Linux)
9.6.0 070508 fix log.c: client's conn. count with thread(on Linux)<suzuki_h>
9.6.0 070506 fix nntpgw.c: EUC/SJIS judgement of digest
9.6.0 070503 mod JIS.c: coped with Emacs internal code ? (0x92+EUCJP)

9.6.0 070502 mod http.c: resp. 403 (not 407) if ok-AUTHORIZER but not-REACHABLE
9.5.7 070501 fix delegated.c: StickyServer for machines of bitsof(pid_t) > 16
9.6.0 070430 mod inets.c: retrying connect() on ECONREFUSED by MAXIMA=contry:2

9.6.0 070430 mod credhy.c: don't activate the cache until the path is set
9.5.7 070429 fix stls.c: conveying ABOR of FTP over SSL with STLS=fsv (9.0.0)
9.5.7 070429 fix stls.c: jammed ToS in FTP data/cntl-conn with STLS=fsv (9.0.0)
9.6.0 070427 fix http.c: repaired downloading CCX tables (9.6.0-pre2)
9.6.0 070427 new telnet.c: supported rewriting DISPLAY in NEW-ENVIRON
9.5.7 070426 fix stls.c: fixed disconn. of SSLway by STLS=fcl on exit (8.10.4)
9.6.0 070424 fix ftp.c: fixed delay in client-side SSL-thread with FSV=sslway
9.6.0 070424 fix ftp.c: fixed frozen SSLway thread on ABOR or SIGPIPE

9.6.0 070423 fix delegated.c:loop on SIGPIPE with SSL/thread on Linux<suzuki_h>
9.6.0 070422 fix nbio.c: fixed truncation of resp. on disconn. by non-half-dup

9.6.0 070422 new http.c: added Proxy-Agent: header for the CONNECT method
9.6.0 070422 fix windows.c: yes/no fgets() on Win via sshd/CYGWIN(bad isatty())
9.5.7 070421 mod nbio.c: don't reject pipelined HTTPS/SSL as non-half-dup
9.6.0 070421 mod {delegate,http,nbio}.c: enabled StickyServer for CONNECT

9.6.0 070420 fix ftp.c: waiting (clearing) SSLway thread for data-connection
9.6.0 070419 fix file.c: fixed SEGV on fdopen() error for getTmpFile()
9.6.0 070419 fix sslway.c: freezing MITM in sync with jammed FSV+FCL as threads
9.6.0 070419 mod delegated.c: fork DeleGate for SERVER=https as a StickyServer
9.6.0 070419 mod delegated.c: enabled Sticky for HTTP to HTTPS serv./Keep-Alive

9.5.7 070419 fix sslway.c: don't cache SSL2 session <kwis>
9.5.7 070417 fix http.c: retrying /default.ico in MITM mode
9.5.7 070417 fix http.c: clearing SSL_ON/ServerFlags on fdopen() error in K-A

9.6.0 070417 mod maker/Makefile: use pthread prior to LWP on old SunOS
9.6.0 070417 fix stls.c: imm. resp. in IMAP, POP3 with thread STLS
9.6.0 070417 fix stls.c: imm. resp. in FTP + thread STLS=fcl AUTH TLS nego.
9.6.0 070417 fix stls.c: imm. resp. in SMTP + thread STLS=fcl STARTTLS nego.

9.5.7 070416 fix log.c: mutual exclution of LOG_write() for multi-thread
9.6.0 070416 new filter.c: enabled threaded FSV=sslway or STLS=fsv
9.6.0 070415 fix ddi.c: retrying CONNECT in Keep-Alive via PROXY=h:p:H in MITM

9.5.7 070414 fix forkspawn.c: retrying fork() on failure under heavy load
9.6.0 070413 mod stls.c: longer timeout for STLS=fcl detection to 8sec. at min.
9.6.0 070413 new inets.c: retrying connect() timeouted on Win under heavy load
9.6.0 070413 mod windows.c: reduced log messages and spawn() for StickyServer
9.6.0 070412 new dget.c: introduced -Fdget -pN for test of parallel sessions
9.5.7 070412 fix svport.c: repaired StickyServer with -Fimp -Pxxxx on Win
9.6.0 070412 fix tcprelay.c: close server-side socket at exit for StickyServer
9.6.0 070412 mod Makefile: CFLAGS=-O2 by default

9.6.0 070411 fix dl.c: clearing dlerror() by dlsym() before dlopen()
9.5.7 070411 fix nntpgw.c: broken code in NNTP/HTTP by dup. conv. for EUC-JP
9.5.7 070410 fix delegated.c: inheriting BINSHELL environment on SIGHUP restart
9.6.0 070410 new Thread.c: introduced -Dt option to disable threads
9.6.0 070410 fix http.c: fixed freezing on SIGSUSP in gunzip thread
9.6.0 070409 fix iotimeout.c: fixed SIGSEGV by longjmp() on SIGPIPE in thread
9.6.0 070409 fix delegated.c: fixed freezing on SIGPIPE in a child thread/Linux

9.5.7 070407 fix JIS.c: fixed judgement non-EUCJP (Chinese GB2312)
9.5.7 070407 fix {ssi,String}.c: coped with META tag with HTTP-EQUIV='...'
9.5.7 070407 fix any2fdif.c: repaired ^^i and ^^o (9.0.5)(9.0.6)<suzuki_h>
9.6.0 070407 new {sslway,stls}.c: introduced CFI_IDENT for sync. + ident.
9.6.0 070407 mod stls.c: immediate FSV=sslway after server conn. by MITM
9.5.7 070407 mod stls.c: longer timeout/2s of HTTPS/SSL detection with STLS=fcl
9.6.0 070406 new {filter,sslway,delegated}.c: FCL=SSLway as a thread
9.6.0 070406 fix filter.c: SSL-ctx cache, CFI_FILTER_ID (9.0.1) as CRC32
9.5.7 070406 mod {htccx,JIS}.c: coped with ENCODING=SJIS in URL

9.6.0 070405 new smtp.c: added periodical report of DATA xfer on slow line
9.6.0 070405 fix http.c: supp. flushResp with CHARCODE+gzip on slow resp.

9.5.6 070404 fix http.c: don't flush empty resp. on slow resp. with CHARCODE
9.5.6 070404 fix ddi.c: broken SSL with serv. in MITM Keep-Alive with clnt
9.5.6 070404 fix rfc822.c: coped with duplicated charset= in Content-Type

9.6.0 070330 new ftp.c: FTPCONF as a MountOption and in CMAP=conf:FTPCONF

9.5.5 070331 fix reshost.c: broken IPv4 addr. for IPv6 addr. in /etc/hosts
9.5.5 070331 fix _-select.c: SEGV in FTP data-conn. accept error (on BSD)<kaw>
9.5.5 070329 fix inets.c: re-enabled HOSTS="{a,b,c}" (9.5.0) <suzuki_h>
9.5.5 070328 fix htccx.c: init. CCX for CHARCODE=chset:tosv

9.6.0 070329 new delegated.c: logging the time and version at termination
9.6.0 070328 new delegated.c: recording thread-id in the LOGFILE by -dt
9.6.0 070328 fix http.c: expanding the stack of main() before thread_fork()
9.6.0 070323 fix nbio.c: detecting TCP conn. alive after dup() on Solaris2.5

9.5.4 070326 fix stls.c: for slow-starting SSL client + STLS=mitm(9.2.5-pre17)
9.5.4 070325 fix vsaddr.c: detecting socket conn. of socketpair() on OSX,Sol10
9.5.4 070323 fix ftp.c: uploading via chained FTP-DeleGate (9.2.2)<mason>

9.6.0 070316 mod http.c: disabled chunked encoding for small data
9.6.0 070315 fix smtp.c: coped with client's conn. reset during DATA relay

9.5.3 070319 fix JIS.c: not SJIS but EUCJP "settei"+zenkakuSP
9.5.3 070319 mod inets.c: enlarged recv. sock. buff. size 64K <- 16K by default
9.5.3 070318 fix ssi.c: coped with META tag with "CONTENT" before "HTTP-EQUIV"
9.5.3 070315 new http.c: coped with frozen server/Keep-Alive (IBM_HTTP_Server)
9.5.3 070314 fix JIS.c: recognizing SJIS string starting with SJIS 2nd lev.
9.5.3 070314 fix JIS.c: SJIS starts with 0x8F in EUC context but not EUC (9.0.3)
9.5.3 070314 fix JIS.c: coped with non-UTF8 in EUCJP context (9.4.3)
9.5.3 070314 fix JIS.c: coped with non-UTF8 in SJIS context (9.5.0-pre5)
9.5.3 070314 new JIS.c: introduced a status of "the character code of the line"

9.5.2 070309 fix Thread.c: fixed int array overflow in thread_PollIn()
9.5.2 070308 fix htccx.c: CHARCODE put broken JIScode at body top (9.0.3-pre14)

9.6.0 070312 fix http.c: doing gzip as an origin-server (disabled in 8.6.0)
9.6.0 070311 new http.c: to waiting enough size of gzip resp. to be buff.ed
9.6.0 070311 new Makefile: .cksum.*.c to confirm the update on recompilation
9.6.0 070310 new mkmake.c: coped with env. with pthread.h but without -lpthread
9.6.0 070309 new windows.c: thread_wait() and thread_yield() for Win
9.6.0 070308 mod http.c: enlarged lookup-size of HTTP resp. header to 1024B
9.6.0 070306 new {http,gzip}.c: gzip to client on the fly in stream by thread
9.6.0 070305 new {http,gzip}.c: gunzip from serv on the fly in stream by thread

9.5.1 070304 new http.c: flushing buff. right after charcode is got (HTTP/1.1)
9.5.1 070304 fix http.c: adjusting charset for HTTP/1.1 client (with chunked)
9.5.1 070304 fix JIS.c: judgement of SJIS on packet/chunk boundary (9.5.0-pre6)

9.5.0 070303 fix JIS.c: don't conv. UTF-16 with CHARCODE=guess
9.5.0 070303 fix JIS.c: don't conv. with CHARCODE=guess (recv. UTF8 in 6.0.0)
9.5.0 070303 mod JIS.c: thru binary like data without conversion
9.5.0 070302 fix {inets,dgbind}.c: appropriate err. mssg. of bind error reason
9.5.0 070301 fix ssi.c: stopped trial to PRIVATE-MASTER by HEAD + SHTML
9.5.0 070301 mod ssi.c: record the size of response of head+body in PROTOLOG
9.5.0 070301 mod ftpgw.c: recording the reason of (authentication) failure
9.5.0 070228 fix notify.c: frozen dbx on ABORT / EMERGENCY STOP (9.2.5-fix2)
9.5.0 070228 fix nntpgw.c: CCX error in "subject normalization" in NNTP/HTTP
9.5.0 070228 fix JIS.c: fixed VStr overflow for UTF8 in JIS-to-ASCII conv.
9.5.0 070227 mod ftp.c: disabled proxying by "OPEN" and "SITE" by default
9.5.0 070226 fix cgi.c: use CHARSET=xxx prior to Content-Type/CCX-Control
9.5.0 070226 new cgi.c: CCX-Control:ie=xxx;oe=yyy to overwrite C-Type:charset
9.5.0 070226 fix cgi.c: applied CHARSET=guess for CGI
9.5.0 070225 new ftp.c: introduced FTPCONF=ccx:any to enable automatic CCX
9.5.0 070225 fix log.c: fixed the time-stamp of "iLog" in sub-seconds (9.2.3)
9.5.0 070224 fix htswitch.c: getting POST body via proxy(separated head/body)
9.5.0 070224 new http.c: introduced HTTPCONF=tout-buff-resbody:T
9.5.0 070224 mod ftp.c: apply code conv. for dir. commands regardless of TYPE
9.5.0 070224 new ftp.c: code conv. of command arg. on the control-connection
9.5.0 070224 new JIS.c: UTF-8 kana followed with dakuten to dakuten-kana
9.5.0 070223 fix ssi.c: seeing ie=chset in SSI with CHARCODE but not "guess"
9.5.0 070223 fix JIS.c: fixed miss-judge of UTF-8 in EUC context
9.5.0 070223 fix JIS.c: fixed miss-judge of SJIS-1B with EUC
9.5.0 070222 new SSI.c: enabled SSI #config var=ie val=charcode
9.5.0 070222 new SSI.c: charcode conv. by META HTTP-EQUIV charset=charcode
9.5.0 070222 fix JIS.c: fixed miss-judge of SJIS-1Byte / EUC
9.5.0 070222 fix http.c: fixed truncation(ign. Keep-Alive in "Response Filter")
9.5.0 070221 mod ssi.c: enabled ie=i&oe=o for INCHARCODE=i&CHARCODE=o
9.5.0 070221 fix JIS.c: fixed miss-judge of SJIS in non-Japanese 8bits codes
9.5.0 070221 fix ssi.c: use Cont-Type:charset from SSI by #config CHARCODE=...
9.5.0 070221 fix cgi.c: use Cont-Type:charset from CGI as default in-code
9.5.0 070220 mod JIS.c: identifying mixed charcode for CHARCODE=guess
9.5.0 070220 mod JIS.c: enabled switching to EUC in SJIS (9.2.4-pre12)
9.5.0 070220 fix httpd.c: adjust Cont-Leng for text/* with CHARCODE / orig-serv
9.5.0 070219 fix JIS.c: fixed UTF-8 in EUC context
9.5.0 070219 fix JIS.c: fixed uninitizlized SJIS status
9.5.0 070218 new ddi.c: enabled SERVER=tcprelay://host:port.udp without SOCKS
9.5.0 070218 fix sslway.c: fixed not to cache useless empty session
9.5.0 070218 new stls.c: enabled STLS=mitm + PROXY
9.5.0 070218 fix httpx.c: re-enabled STLS=mitm + MASTER (9.2.5-pre17)
9.5.0 070218 fix JIS.c: coped with SJIS or EUC in UTF-8 context
9.5.0 070217 fix tcprelay.c: fixed infinite loop on TCP-reset to UDP/SOCKS5
9.5.0 070217 fix socks5.c: SEGV in SERVER=tcprelay to UDP via SOCKS (9.2.5)
9.5.0 070217 fix service.c: fixed SEGV on jump to address 0 by SERVER=sftp
9.5.0 070217 fix sftp.c: fixed possible SEGV on repetitve login (dangling ptr)
9.5.0 070217 fix vsaddr.c: numeric %id as HOSTS=name/__1%1 (9.2.0-pre8)
9.5.0 070217 fix socks5.c: possible SEGV in SERVER=udprelay via SOCKS from TCP
9.5.0 070216 mod admin.c: moved ADMDIR/svstats/ to ADMDRI/svstats9/
9.5.0 070216 mod svstat.c: expanded svstat struct. for long hostname or IPv6
9.5.0 070215 fix inets.c: IPv4/IPv6 mixed addr. list in HOSTS=name/{addrlist}
9.5.0 070214 fix httphead.c: fixed expires=T MountOption (9.0.3)
9.5.0 070213 fix {stls,filter}.c: STLS=fsv + SERVER=telnets or tcplreay (9.0.1)
9.5.0 070215 mod *.c: bcopy() to Bcopy()
9.5.0 070214 mod *.c: QVSSize() for and read()/fread()

9.4.4 070210 fix ftp.c: fixed to cope with user/xxx@host (8.6.0)<emmanuel>
9.4.4 070210 fix JIS.c: SEGV on ref. to un-initialized pointer (9.4.3-pre9)
9.4.4 070210 fix httphead: forwarding http://vhost by "genvhost=vhost" + PROXY
9.4.4 070210 new httpd.c: introduced HTTPCONF="ccx-url-ie:ie,ei"
9.4.4 070210 mod htccx.c: disabled SVCC when URL is with queray ?ie=charset
9.4.4 070210 fix htccx.c: rew. charset param. in req.body head with CCX_TOSV
9.4.4 070210 fix htccx.c: fixed CCX for body of non x-www-form-urlencoded
9.4.4 070210 new http.c: rewriting application/soap+xml in POST request body
9.4.4 070210 new {http,url}.c: rew. Content-Type:application/soap+xml as XML

9.4.3 070208 fix http.c: fixed keep-alive with both client+serv. + SSLtunnel
9.4.3 070207 fix inets.c: fixed freezing ftp-data with SOCKSTAP=ftp (-pre5)
9.4.3 070207 fix ftp.c: fixed freezing data-conn. via SOCKS after error
9.4.3 070206 new socks.c: enabled SERVER=udprelay + ROUTE=socks://u:p@...
9.4.3 070206 new {socks,socks5}.c: SERVER=socks + ROUTE=socks://u:p@... for UDP
9.4.3 070206 new {socks,service}.c: enabled ROUTE/FORWARD=socks://u@p:H:P-_-...
9.4.3 070206 new resconf.c: enabled RES_NS=h..p//s..p for RES_NS=h:p//s:p
9.4.3 070206 fix resconf.c: enabled RES_NS=h:p//s:p (DNS on non 53 via SOCKS)
9.4.3 070205 new {socks,socks5}.c: routing UDP over SOCKS SOCKS=h:p:dstHostList
9.4.3 070203 fix JIS.c: fixed miss-judged SJIS as UTF-8 in SJIS (9.2.0)
9.4.3 070201 new JIS.c: coped with &#xXXXX; notation
9.4.3 070201 new JIS.c: hankaku to zenkaku by CHARCODE=z-chcode or -z-chcode
9.4.3 070131 new service.c: enabled SOCKSTAP=telnet
9.4.3 070131 fix ftp.c: relaying multiple files in different charcodes
9.4.3 070131 fix service.c: coped with testing "readonly" on SOCKSTAP=ftp
9.4.3 070131 fix http.c: enabled SVCC with conditional CHARCODE=chset:tocl:...
9.4.3 070131 fix textconv.c: CHARCODE with dstHostList matching with "!"(-pre4)
9.4.3 070130 fix socks5.c: relaying UDP ASSOC from SOCKS client to SOCKS serv.
9.4.3 070128 fix inets.c: init. RES_NS,RES_CONF before doing RES_WAIT (9.2.2)
9.4.3 070128 fix hostlist.c: fixed SEGV on empty port-list in HostList
9.4.3 070128 new master.c: enabled "host..port" for host:port in HostList
9.4.3 070128 fix master.c: checking "proto" in FORWARD=URL-_-proto
9.4.3 070128 fix ddi.c: re-using auth. for g.w. with serv. in keep-alive(-pre5)
9.4.3 070128 new service.c: introduced ROUTE=noroute
9.4.3 070128 new service.c: introduced ROUTE=direct-_-... and FORWARD=direct-_-
9.4.3 070127 fix JIS.c: don't convert non ISO-8859-1/ANSI char. (9.4.2)
9.4.3 070127 new {ftp,inets,master}.c: enabled ftp via SSLtunnel
9.4.3 070127 new {access,ftp}.c: FORWARD + auth. for http,ftp,socks,delegate
9.4.3 070126 new telnet.c: enabled CHARCODE=chcode:tosv with SERVER=telnet
9.4.3 070126 new tcprelay.c: enabled CHARCODE=chcode:tosv with SERVER=tcprelay
9.4.3 070126 new service.c: enabled FORWARD=proto://"user:pass@"host:port
9.4.3 070126 new service.c: enabled ROUTE=proto://"user:pass@"host:port
9.4.3 070126 new service.c: enabled ROUTE="ssltunnel"://host:port/-_-dst:src
9.4.3 070125 new {http,stls,master}.c: enabled STLS=fsv + PROXY + MYAUTH
9.4.3 070125 new filter.c: enabled FSV=sslway + SSLTUNNEL + MYAUTH
9.4.3 070124 mod access.c: MYAUTH=u:p:ssltunnel by default with SSLTUNNEL=h:p
9.4.3 070121 fix delegated.c: close fd for shared on SIGHUP
9.4.3 070121 fix delegated.c: close fd for svstat on SIGHUP
9.4.3 070121 fix Strftime.c: close fd by ctime() on SIGHUP on MacOSX
9.4.3 070120 new delegated.c: added -b option to go background immediately 
9.4.3 070120 fix httphead: suppressed "VStr ovreflow" warning (9.4.2-pre8)
9.4.3 070120 fix {httphead,rfc822}.c: scanning/skipping long cookie values
9.4.3 070120 new JIS.c: coped with 3bytes of UTF-8 in EUC-JP context
9.4.3 070119 mod delegated.c: re-detect resolvers on restart on error
9.4.3 070119 mod delegated.c: don't wait daemon in f.g. without tty (9.4.0)

9.4.2 070111 new ftp.c: supported CHARCODE=chset[:tosv] in "TYPE ASCII"
9.4.2 070111 new {smtp,mime}.c: supported CHARCODE=chset:tosv (for MIME body)
9.4.2 070111 new JIS.c: suppressed JISX0212 in ISO-2022-JP with MSIE
9.4.2 070111 new JIS.c: coped with Shift_JIS with IBM+NEC extentions
9.4.2 070110 fix httpd.c: dup. header by add-rhead MountOption (9.4.2-pre5)
9.4.2 070110 fix htccx.c: don't CCX by SVCC when only with CHARCODE=guess
9.4.2 070110 fix urlesc.c: fixed unescape and conv. ISO-2022 seq. in URL 
9.4.2 070106 new {htccx,http}.c: introduced "DeleGate-Control-CLCC" Cookie
9.4.2 070106 fix JIS.c: fixed not to erase JISX0212 string with CHARCODE=guess
9.4.2 070106 new JIS.c: supported conversion to US-ASCII in &#xxxx;
9.4.2 070106 new JIS.c: supported from ISO-8859-1/ANSI to UTF-8
9.4.2 070105 fix JIS.c: fixed hankaku -> zenkaku for str. ending with hankaku
9.4.2 070104 fix httpd.c: enabled POST + SHTML
9.4.2 070104 fix JIS.c: guessing charcode of text with 3bytes of EUC-JP
9.4.2 070104 new htccx.c: introduced "-Furlccx"
9.4.2 070103 fix ssi.c: fixed to adjust charcode of SSI #include
9.4.2 070103 fix ddi.c: fixed truncated REMOTE_HOST env. (by strfConn("%h"))
9.4.2 061231 new cgi.c: introduced "CCX-Control: charcode"
9.4.2 061231 new {cgi,htccx}.c: CHARCODE conv. for POST body to CGI
9.4.2 061230 mod mkmake.c: changed to put trial cc errors to makers/errors
9.4.2 061228 new httpd.c: introduced HTTPCONF="replace-head:NAME:VALUE"
9.4.2 061228 new ftp.c: coped with FTP auth. serv. without CRLF line end
9.4.2 061228 new http.c: introduced HTTPCONF="add-i[qr]head:NAME:value"
9.4.2 061228 new domain.c: getting DNS request from multi-ports (-Px,y,z)
9.4.2 061228 mod JIS.c: changed to allow "Shift-JIS" for "Shift_JIS"
9.4.2 061227 new JIS.c: added scanning UTF-16 with BOM and conv. to UTF-8
9.4.2 061227 fix JIS.c: fixed scanning 4-bytes of UTF-8
9.4.2 061226 fix delegated.c: redirecting 1>2> to STDOUTLOG on ERESTART
9.4.2 061226 fix ystring.c: coped with fprintf("%f") on 64bit CPU (9.2.2)
9.4.2 061225 fix delegated.c: close tty/stdin as daemon (for SSH/Solaris10)
9.4.2 061225 new windows.c: spawning non-DeleGate program lightly
9.4.2 061223 new access.c: introduced AUTHORIZER="-cmd{com arg}{E1=v1 E2=v2}"
9.4.2 061222 fix delegated.c: repaired -Fkill-hup (9.4.0)<pyzarlab>

9.3.2 061221 fix httpd.c: access to src. of .CGI / .SHTML on caseless file-sys
9.3.2 061220 mod credhy.c: moved the cache file of Credhy to under ACTDIR
9.3.2 061219 fix windows.c: fixed SEGV on service STOP (on restart too)
9.3.2 061217 fix credhy.c: fixed SEGV when cannot write the cache for Credhy

9.4.2 061218 fix delegated.c: coped with encrypted param. by -Fimp -k on Win
9.4.2 061217 fix mkmake.c: ld test with "-lstdc++" if "-x c++" in CFLAGS(Fedora)
9.4.2 061215 fix JIS.c: removed repetitive "ESC-$-(-D" for JISX0212 output
9.4.2 061213 new http.c: immediate finish wait resp. on disconn. from client
9.4.2 061213 new JIS.c: introduced CHARMAP=jis:2121-7F7F/222E
9.4.2 061213 new conf.c: extended CACHE=do,no[:proto:dst:src]
9.4.2 061213 new htccx.c: introduced HTTPCONF=post-ccx-type:listOfTypes
9.4.2 061213 new textconv.c: extended CHARCODE=xxxx[:tosv[:proto:dst:src]]

9.4.1 061213 fix nntp.c: getting cached ARTICLE on pipelined GROUP+ARTICLE
9.4.1 061213 new service.c: extended SOCKSTAP=connMap[:parameters]
9.4.1 061210 new service.c: introduced SOCKSTAP=connMap parameter
9.4.1 061207 new service.c: metamo. from SOCKS server to a HTTP/FTP/... proxy 
9.4.1 061206 new delegated.c: introduced DGCONF parameter (the default +=conf)
9.4.1 061206 new srcipt.c: -sx to permit encrypted +=file only
9.4.1 061206 mod dgsign.c: turn off SUOE/root with -Fimp -z
9.4.1 061206 mod dgsign.c: turn off the executable flag for others on -Fimp -m
9.4.1 061206 mod {embed,dgsign}.c: -u "root,.owner" by default for bin. dist.
9.4.1 061206 mod commands.c: allow owner's -Fimp even if Fimp is disabled by -C
9.4.1 061206 new dgsign.c: -Fimp -c x to exclude "-x" and --c x to exclude "x"
9.4.1 061206 mod commands.c: disabled -Func + SUOE/root (-Fimp -c Func to add)
9.4.1 061205 new dgsign.c: introduced -Fdec -e option

9.4.0 061201 fix credhy.c: faster strtoHex/hextoStr without sscanf/sprintf
9.4.0 061130 new {httpx,script,delegated}.c: generic usage of enc: URI "scheme"
9.4.0 061130 mod {dgauth,dgsign}.c: accepts ":passWord" for "pass:passWord"
9.4.0 061130 fix script.c: coped with large +=enc: string
9.4.0 061129 new dgsign.c: erasing implanted param/opts with -zPARAM / -z-X
9.4.0 061129 new dgsign.c: -Fenc / -Fdec to encrypt/decrypt +=enc:ext:...
9.4.0 061129 new dgsign.c: loading encrypted parameters as +=enc:ext::xxxx:
9.4.0 061129 new dgsign.c: saving encrypted parameters with -Fimp -se or -sk
9.4.0 061128 new dgsign.c: supported -Fimp -U on Win
9.4.0 061128 new windows.c: implemented getting the owner name on Win
9.4.0 061128 new windows.c: implemented st_ino on Win (but only in short int)
9.4.0 061128 fix dgsign.c: supported -Fimp -k on Win
9.4.0 061127 fix dgauth.c: re-enabled CRYPT=pass:xxx as a parameter (pre14)
9.4.0 061127 new dgauth.c: showing decrypted password with -Fauth -V
9.4.0 061126 new {dgauth,dgsign}.c: generic PASSWD=Dom:User:pass:xxxx storage
9.4.0 061125 new dgsign.c: introduced -Fimp -k to encrypt implanted config.
9.4.0 061125 fix {delegated,pelcgb}.c: fixed SEGV on long CRYPT key
9.4.0 061125 mod dgsign.c: allow -Fimp only to the owner and the group of exe.
9.4.0 061124 mod credhy.c: stopped too slow "dazzling" in CreyEncrypts(9.0.6)
9.4.0 061124 fix hostlist.c: infinite loop by malformed hostlist as "{a,b}c"
9.4.0 061123 new credhy.c: added simple safe string encoding instead of Hex
9.4.0 061123 fix {dgsign,credhy}.c: coped with a large config. file
9.4.0 061122 new param.c: supported -Fimp -C -PARAM to disable the PARAM
9.4.0 061122 new dgsign.c: save/load commented configuration of -Fimp as is
9.4.0 061121 new dgsign.c: introduced -Fimp -e option (edit with vi or EDITOR)
9.4.0 061120 new dgsign.c: enabled arbitrary parameter NAME=value with -Fimp
9.4.0 061120 mod embed.c: enlarged the default size of IMP area to 4KB
9.4.0 061119 mod delegated.c: act as a filter if without -Pxxx and via socket
9.4.0 061117 fix dgsign.c: fixed broken password MD5 for repetitive -Fimp
9.4.0 061117 mod delegated.c: -Fkill as a usual -Ffunction (ctrl.ed with -Fimp)
9.4.0 061117 new {delegate,param*.c: added ".lock.NAME=value" or ".lock.NAME"
9.4.0 061117 new embed.c: setting size of -Fimp area as "make IMPSIZE=1234"
9.4.0 061116 new dgsign.c: -Fimp coped with rewriting self on ETXTBSY
9.4.0 061115 fix sox.c: SockMux on a FIFO pair with Credhy preamble (8.8.6)

9.3.1 061111 fix sslway.c: sess. cache with client's certificate(9.2.4)<shima>

9.4.0 061113 mod sslway.c: introduced TLSOCNF="context:xxx"
9.4.0 061113 mod {http,httpd}.c: introduced HTTPCONF=kill-iqhead / kill-irhead
9.4.0 061110 mod sslway.c: showing errors in library loading on the start (-vl)
9.4.0 061108 fix telnet.c: relay DM/OOB A.S.A.P. without seeing TM(9.0.3-pre18)
9.4.0 061109 fix {nbio,fpoll}.c: FFROMC=-p,filter for binary-relay (by CONNECT)
9.4.0 061108 fix _-select.c: don't care EOF of PIPE as OOB on FreeBSD (9.0.3)
9.4.0 061108 fix delegated.c: fixed SEGV on start (9.4.0-pre1)<suzuki_h>
9.4.0 061107 mod delegated.c: wait in foreground till daemon proc. launch
9.4.0 061107 mod dgsign.c: -Fimp -m not to change the group-ownership
9.4.0 061107 mod embed.c: SUDOAUTH=":root,.u,/.g,/wheel,/staff" by default
9.4.0 061107 new svport.c: showing help for -Fimp -m on bind(-Pxx) error
9.4.0 061107 mod sudo.c: set the owner of SUDO socket to the one in OWNER
9.4.0 061107 mod dgsign.c: -Fimp -o copies modes of original to a new exec.
9.4.0 061107 mod delegated.c: create LOGFILE as DGROOT/{sudo,sudo-error}.log
9.4.0 061107 fix delegated.c: don't create generalist PROTOLOG for SERVER=sudo

9.4.0 061106 mod windows.c: MAXIMA=winmtu:0 (from 1024) by default (7.9.4)
9.4.0 061105 mod {pstitle,setproctitle}.c: use setproctilte() if available
9.4.0 061104 mod {__locking,_-CreateThread}.c: merged into windows.c
9.4.0 061103 mod unix.c: extracted Unix only code from windows.c
9.4.0 061103 mod {winserv,winreg}.c: merged into windows.c
9.4.0 061103 new pop.c: implemented RFC2449 "CAPA" for STLS <soldatov>
9.4.0 061102 new delegated.c: detecting interpolation of the executable file
9.4.0 061102 new {service,delegated}.c: masking capable protocols by -Fimp -C
9.4.0 061102 new {dgsign.c,commands}.c: masking capable functions by -Fimp -C
9.4.0 061101 new delegated.c: coped with "-r" for INETD="" without -Pxxx
9.4.0 061031 mod delegated.c: don't start in background without -Pxxx
9.4.0 061028 fix file.c: coped with "OWNER=nobody" on MacOSX (where uid == -2)
9.4.0 061028 new dgsign.c: -Fimp to implant config. params. into executable
9.4.0 061028 mod master.c: OWNER="invoker-uid" by default on set-uid-on-exec
9.4.0 061028 new sudo.c: introduced SUDOPASS=pass to be run with set-uid-flag
9.4.0 061028 fix httpd.c: fixed SERVER=tunnel1 for TUNNEL=tty7:x.shio (8.0.1)
9.4.0 061027 fix {delegated,winserv}.c: restarting as a service from CGI/SSI
9.4.0 061027 fix delegated.c: closing stdout on error restart from CGI/SSI
9.4.0 061026 fix {delegated,remote}.c: enabled invocation via SSH
9.4.0 061024 new windows.c: sending a file desc. by DuplicateHandle on Win
9.4.0 061024 mod delegated.c: re-enabled AF_UNIX on Solaris (3.0.35)
9.4.0 061024 fix nbio.c: fixed connect() with timeout to work with AF_UNIX
9.4.0 061022 new sendFd1.c: sending a file descriptor via AF_UNIX socket
9.4.0 061022 fix inets.c: repaired AF_UNIX + UDP to work (since 9.0.0 for IPv6)
9.4.0 061022 mod {vaddr,vsocket}.h: expanded VSAddr from 32B to 128 for AF_UNIX

9.3.0 061105 fix delegated.c: fixed pstitle shown with CHROOT by dgchroot

9.2.5 061031 fix socks5.c: possible SEGV on recv() error in UDP/SocksV5 realay
9.2.5 061028 fix htccx.c: don't guess charset in gzip (conv. for text in gzip)
9.2.5 061028 fix dgsign.c: ignore '{SIGN:...}' when making MD5 to be signed
9.2.5 061025 fix http.c: filtered/broken Cookie with MASTER (9.0.6)<tokunaga>
9.2.5 061025 new http.c: introduced HTTPCONF=dgcroute:no
9.2.5 061024 mod any2fdif.c: became tolerant with '\0' in HTML
9.2.5 061024 fix JIS.c: fixed SEGV on non-existent map from "half-width-kana"
9.2.5 061023 fix libpam.c: to be compiled without C++ (9.2.5)
9.2.5 061022 fix notify.c: don't cause disk overflow on dbx infinite loop
9.2.5 061021 fix JIS.c: coped with conv. of Apple specific code of DASH UTF-8

9.2.5 061019 fix ftp.c: PWD resp "/" instead "" as origin-FTP for further MOUNT
9.2.5 061018 new {service,filter}.c: enabled FCL=sslway + FMD=sslway & MASTER
9.2.5 061018 fix filter.c: disabled FCL=sslway + FSV=sslway & MASTER <martin->
9.2.5 061018 mod sox.c: restart DeleGate on repetitive conn. err. to the server
9.2.5 061018 new sslway.c: introduced TLSCONF="libs:libcrypto.so+libssl.so"
9.2.5 061018 mod sslway.c: changed to load libeay32.dll before ssleay32.dll
9.2.5 061018 fix htccx.c: expanded buff. for CCX of req. body(no VStr overflow)
9.2.5 061017 fix delegated.c: no "SERIOUS: Broken Sticky..." for non Sticky
9.2.5 061016 add admin.c: OpenSSL version in the menu of /-/admin/ after auth.
9.2.5 061016 fix TLEX.c: SEGV on scanning "NON-DETERMINISTIC" rexp.
9.2.5 061016 mod sslway.c: made OPENSSL_...() and ENGINE_...() be optional
9.2.5 061015 fix stls.c: freezing in SSL detection with pipelined client(9.0.1)
9.2.5 061013 mod httpd.c: introduced HTTPCONF="belocal:shtml"
9.2.5 061013 mod access.c: AUTHORIZER=asv":delegate" for SERVER=delegate
9.2.5 061013 mod access.c: MYAUTH=serv":delegate" by default with MASTER=h:p
9.2.5 061013 mod access.c: MYAUTH=serv":socks" by default with SOCKS=host:port
9.2.5 061012 mod access.c: MYAUTH=serv":http-proxy" by default for SERVER=http
9.2.5 061011 mod dl.c: introduced LDPATH=... for dynamic library search
9.2.5 061010 mod dl.c: added DYLIB=dglib*.so by default
9.2.5 061007 new {libpam,pam}.c: PAM has become an optional dynamic library
9.2.5 061007 fix hostlist.c: enabled -Phost:xxx in a HostList as well as -Pxxx
9.2.5 061007 fix {ddi,master}.c: coped with SRCIF with HTTP serv. in KeepAlive
9.2.5 061007 fix delegated.c: made MAXIMA=standby:0 default with INETD <igor>
9.2.5 061006 fix delegated.c: enabled SRCIF (SOCKS, etc.) in INETD <igor>
9.2.5 061005 new sslway.c: added "-ssl2" "-ssl3" and "-tls1" options
9.2.5 061005 mod http.c: don't wait the arrival of POST body in HTTP/1.1(5.9.2)
9.2.5 061005 fix http.c: coped with 100-Continue during POST req. body <jaewh>
9.2.5 061004 fix ftp.c: uploading via chained FTP-DeleGate in XDC (9.2.2)<p2s>
9.2.5 061003 fix delegated.c: suppressed needless "Waiting predecessor..."
9.2.5 060930 mod {smtp,stls}.c: enabled implicit SSL for "smtps://server"
9.2.5 060930 new {httpd,ssi}.c: introduced -Fssi /path/of/file.shtml
9.2.5 060929 mod {stls,nbio}.c: more strict detection of SSL/TLS Client_Hello
9.2.5 060929 fix http.c: appropriate resp. on CONNECT error in upstream proxy
9.2.5 060929 new delegated.c: repairing StickyReport[] on disconnection (?)
9.2.5 060927 new {master,socks,service}.c: FSV/FCL=-credhy for MASTER/SOCKS
9.2.5 060927 new socks.c: SERVER=tcprelay://host:port.udp with SOCKS=shost
9.2.5 060927 new {socks,socks5,udprelay,tcprelay}.c: relaying UDP via SOCKS
9.2.5 060926 new svport.c: enabled "-Pxxx.udp" as well as "-Pxxx/udp"
9.2.5 060925 mod httpd.c: non-default /-/data: (needs MOUNT="/-/data:* data:*)
9.2.5 060924 new {dgdate,Timeofday,strftime}.c: introduced -Fdate command
9.2.5 060924 new httpd.c: added time server as /-/date or /-/date?$Y$m$d$H$M$S
9.2.5 060923 new {embed,dgsign}.c: introduced sign/verify for executable file
9.2.5 060923 fix ystring.c: removed halmful recov. of buff ending (9.11.0-pre2)
9.2.5 060921 fix mkmake.c,md5/global.h: fixed MD5 on 64bits machine
9.2.5 060920 mod src/*.h: moved to include/ (to be copied to gen/ by mkcpp)
9.2.5 060920 new {sslway,gzip}.c: added version logging of dynamic libraries
9.2.5 060918 fix sftp.c: fixed SEGV on PASV+RETR+QUIT without USER+PASS
9.2.5 060918 fix JIS.c: fixed miss-judged SJIS as UTF-8 in SJIS (9.2.0)
9.2.5 060917 fix windows.c: immediate select() return for regular file on Win
9.2.5 060917 mod windows.c: immediate detection of exit of command on Win
9.2.5 060914 fix sftp.c: "stty -echo" to cope with pty on Linux <k.akiba><gsa>
9.2.5 060914 fix windows.c: a workaround to save ".exe" commands frozen on Win
9.2.5 060912 fix sox.c: SEGV on the overflow of 4bytes in 16k buff. (9.2.3)
9.2.5 060912 mod http.c: suppress resolver's cache only when with "no-cache"
9.2.5 060910 new Strftime.c: enabled "%.3S" instead of "%S%.3s"
9.2.5 060909 fix ystring.c: converting %lld to %qd for FreeBSD4.X (9.2.2)
9.2.5 060908 fix http.c: SEGV on fflush(NULL) on 5xx resp. with cache with bad Content-Length (9.2.3)
9.2.5 060908 mod http.c: stop relaying POST req. body on detected resp.
9.2.5 060907 fix {ftp,ftpgw}.c: close the conn. with client in SFTPGW-CC
9.2.5 060907 fix ftp.c: connecting to MOUNTed sftp://server:port/path <gsa>
9.2.5 060907 fix {ftp,sftp}.c: relaying (PASS) arg. beginning with spaces
9.2.5 060906 new Strftime.c: fmt. spec. "%s" for "seconds since the Epoch"
9.2.5 060906 new httpx.c: tracking 302 to "Location: /path" by MS-IIS
9.2.5 060906 new service.c: added crypted MASTER auth. with MYAUTH+AUTHORIZER

9.2.4 060831 fix mime.c: fixed generation of dup. --boundary after empty body
9.2.4 060830 fix {rfc822,mime,String}.c: erase '\0' in MIME (for POP)<gateman>
9.2.4 060830 fix windows.c: running DeleGate as a non-direct-child descendant of DeleGate on Win (erase+ignore SPAWN_ENVIRON)
9.2.4 060830 fix {inets,__opendir}.c: compilation of Cygwin
9.2.4 060828 mod inets.c: added finding RESOLV=file:path in LIBPATH
9.2.4 060828 mod inets.c: enabled RESOLV="file:X:/.../hosts" for Win (9.0.3)
9.2.4 060828 mod nbio.c: checking that the version of SSL ALERT is in SSLv3
9.2.4 060824 fix nbio.c: relaying HTTPS/SSLv2 by CONNECT (9.0.3)<tana@g-search>
9.2.4 060823 new mime.c: new -ot option for enMime/deMime to extract text only
9.2.4 060823 fix rfc822.c: erased multi-part ending line in TEXTONLY extraction
9.2.4 060823 fix any2fdif.c: erased PGP header in a message from the digest
9.2.4 060821 new gzip.c: fast gzip without gzip.exe using "dgzlib1.dll" on Win
9.2.4 060819 new {delegated,hostlist}.c: -R/* for matching about RIDENT=client
9.2.4 060819 fix ddi.c: matching MountOption "from=" with RIDENT=client
9.2.4 060817 new service.c: access restriction (ex. REACHABLE) with -Fany2fdif
9.2.4 060817 fix any2fdif.c: don't trace arbitrary links with -r <marya>
9.2.4 060817 mod ftp.c: FTPCONF=noxdc by default when acting as a proxy
9.2.4 060816 new windows.c: timeout of mysystem() for child without active I/O
9.2.4 060816 fix filter.c: close server ports (-Pxxx) on exec of mysystem()
9.2.4 060815 fix http.c: no delay on 5xx resp. in Keep-Alive with cache (2.9.9)
9.2.4 060815 mod htmlgen.c: hide the server in 502 CantConn msg. with MOUNT 
9.2.4 060815 mod http.c: ignore broken cache without "HTTP/1." (cache:any)
9.2.4 060814 mod http.c: write cache to #LOADING (HTTPCONF=bugs:old-cache)
9.2.4 060814 mod inets.c: ignore (broken) x.x.x.x.in-addr.arpa as PTR from DNS
9.2.4 060814 fix cache.c: removing cache on error on Win (path with drive:)
9.2.4 060814 fix http.c: removing broken/truncated cache automatically on Win
9.2.4 060813 fix __locking.c: fixed shared lock on Win for cache (9.0.6)
9.2.4 060813 new http.c: supported "Cache-Control: only-if-cached" as server
9.2.4 060813 new {conf,cache}.c: introduced CACHEARC="dir1;dir2;..."
9.2.4 060811 new http.c: tentative CFI "Control/CFI-control: no-filter"
9.2.4 060810 new http.c: detecting disconnection from client waiting cache lock
9.2.4 060810 fix http.c: parallel downloading of large file with cache
9.2.4 060810 fix {distrib,http}.c: fixed truncation on simultaneus cache-read
9.2.4 060810 fix delegated.c: blocks with -Pmulti-port for HTTP on Win32(9.0.6)
9.2.4 060809 new smtp.c: SMTPCONF=reject:nomx+notselfmx+notmxhelo+pipeline
9.2.4 060808 new cfi.c: matching with CGI env. in CFIscript as SERVER_NAME:xxx
9.2.4 060808 fix sslway.c: mutual exclsion of access to cache write/read
9.2.4 060807 new {access,env}.c: conditional-param for auth. user by AUTHORIZER
9.2.4 060807 new delegated.c: introduced SAC for access control simulation
9.2.4 060805 new master.c: SOCKMUX for mux. SOCKS/MASTER/PROXY over SockMux
9.2.4 060803 mod JIS.c: mod. to ignore duplicated <META HTTP-EQUIV charset>
9.2.4 060803 mod JIS.c: mod. to ignore EUC-JP ? in explicit charset=Shift_JIS 
9.2.4 060803 new commands.c: exec. name with "dg" prefix "dgxxx" for "-Fxxx"
9.2.4 060803 new sox.c: expanded the packet size (512 -> 16K) with negotiation
9.2.4 060803 new sox.c: supported AUTHORIZER + MYAUTH for SockMux
9.2.4 060803 fix ftp.c: don't cause SIGPIPE in vain after control-conn. reset
9.2.4 060803 fix ftp.c: fixed blocking by unused data-conn with FSV,FCL
9.2.4 060803 new {ftp,stls}.c: rURL "ftps://" to be implict SSL with serv.
9.2.4 060802 fix filter.c: fixed to work with both FSV+FCL (as STLS=fsv,fcl)
9.2.4 060802 fix ftp.c: fixed EPSV via Socks (maybe not necessary practically)
9.2.4 060802 fix sslway.c: fixed SEGV in session cache on accept/connect error
9.2.4 060802 new socks.c: coped with PORT/FTP (BIND) over SOCKS over SSL
9.2.4 060802 new socks.c: implemented SOCKS over SSL (with STLS=fsv)
9.2.4 060801 new {cgi,sslway}.c: implemented the session cache for FSV
9.2.4 060728 new versign,vervrfy: sign and verify source code
9.2.4 060727 new {service,httpx}.c: enabled MITM to MASTER without CONNECT
9.2.4 060727 fix master.c: fixed to do CONNECT from me in MITM to MASTER
9.2.4 060727 fix {master,stls}.c: fixed jam. between SSL and MASTER <kano>
9.2.4 060727 new {version,versign}.c: fixed the random. fact. by each ver.
9.2.4 060726 mod http.c: do Keep-Alive with server in Sticky after MITM mode
9.2.4 060726 fix http.c: Proxy-Auth. + CONNECT for non #443 port (9.2.3-pre8)
9.2.4 060726 new fstat.c: setting time-format of -Fls with "LSTFMT" env. var.
9.2.4 060725 fix http.c: don't wait the exit of FCL=SSLway alive with client
9.2.4 060725 new ftp.c: "AUTHORIZER=-smtp-vrfy@{error message}" MountOption
9.2.4 060725 fix mount.c: enabled "name={value with space}" in MountOption
9.2.4 060724 fix {http,delegated}.c: don't wait SSLway to server in Keep-Alive
9.2.4 060724 mod http.c: increased to HTTPCONF=max-cka:20 by default
9.2.4 060724 new {stls,http,delegated}.c: enabled Sticky in MITM mode
9.2.4 060724 new sslway.c: introduced TLSCONF=scache:no
9.2.4 060724 mod http.h,ddi.c: enabled Keep-Alive with client in MITM mode
9.2.4 060722 fix ftp.c: removed "V/" in the response for NLST (9.2.3)
9.2.4 060722 exp hostlist.c: added "?*" for unresolvable name or address
9.2.4 060722 fix ystring.c: partial revival of -p,-w,filter (since 8.10.0)
9.2.4 060722 exp rary.c: touch file with futime() on BSD and Win32
9.2.4 060721 fix delegated.c: don't try defreeze when not freezed
9.2.4 060721 fix delegated.c: VStr overflow on restarting -Pa,b by HUP on Win
9.2.4 060719 fix JIS.c: conv. of half-width-kana in UTF-8 to ShiftJIS
9.2.4 060717 fix service.c: immediate forwarding RIDENT after conn. (9.0.5)

9.2.3 060716 fix delegated.c: redirect to stdout.log for SERVER=dns and sockmux
9.2.3 060714 fix vsaddr.c: resolving a hostname including "_"(9.2.0)<burdick>
9.2.3 060712 fix delegated.c: close tty/stdin as daemon(for SSH+Linux)<Steffen>
9.2.3 060712 fix ftp.c: escaping response code in msg. from server <Steffen>
9.2.3 060711 fix ftp.c: set "asproxy" after MLST //serv + CWD //serv (9.2.2)
9.2.3 060711 fix ftp.c: coped with relative-path arg. on virtual-dir.<Steffen>
9.2.3 060711 add ftp.c: FTPCONF=debug:0x20 to pass 150 resp. on serv. sw. as is
9.2.3 060711 add ftp.c: enabled FTPCONF=noport for client
9.2.3 060710 add {stls,http}.c: supported Proxy-Authorization in MITM mode
9.2.3 060708 new delegated.c: check ports before being a service to be blocked
9.2.3 060708 add windows.c: trace socket/descriptor mapping by -ds option
9.2.3 060708 fix file.c: fixed file-descriptor jam after fclose(socket) on Win
9.2.3 060708 fix ftp.c: suppressed "recvPeek: failed: 0" flood in LOGFILE
9.2.3 060707 add {delegated,shutter}.c: supported Notify-Mail in init. phase
9.2.3 060707 add *.c: introduced internal log in the initizlization phase
9.2.3 060705 add ftp.c: added announcement of "AUTH TLS" to FEAT command
9.2.3 060705 mod delegated.c: moved service start log to TEMP/delegate/ (Win)
9.2.3 060705 fix delegated.c: loading ${EXECNAME}.conf on Win (with .exe)
9.2.3 060705 new stls.c: spot MITM by STLS=-mitm + "https://-mitm.host.domain"
9.2.3 060705 mod bcounter.c: CountUp log be optional (act. by COUNTER=do,debug)
9.2.3 060705 mod http.c: relay gzip encoded text as a binary from the start
9.2.3 060705 fix http.c: fixed to do gunzip for postponed CFI (pre3)
9.2.3 060704 fix http.c: suppressed fwrite() in caching "takeover"mode for text
9.2.3 060702 fix access.c: enabled @Realm even for -none or -any
9.2.3 060702 fix mount.c: fixed MovedTo from "url" to "url/" by MOUNT "asproxy"
9.2.3 060701 fix http.c: don't reuse cache/K-A if no PERMIT matched with auth.
9.2.3 060629 new {stls,http}.c: introduced STLS="mitm" Man-In-The-Middle mode
9.2.3 060629 new mount.c: introduced "vurl:URL" in rURL for recursive MOUNT
9.2.3 060629 new {ftp,fstat}.c: added Unique=B64(dev,ino)fact to MLST/MLSD resp
9.2.3 060628 fix ftp.c: fixed to hold virtual CWD in switchings by non-CWD
9.2.3 060628 new ftp.c: supported caching MLST response
9.2.3 060628 fix ftp.c: virtualized the real-path returned in MLST response
9.2.3 060627 new ftp.c: supported caching MLSD response
9.2.3 060627 new fstat.c: introduced "virtual node" with stat by facts of MLST
9.2.3 060626 new filter.c: stopped repetitive search for gzip.exe on spawn(Win)
9.2.3 060626 mod ystring.c: changed to use vsnprintf() instead of snprintf()
9.2.3 060626 new http.c: HTTPCONF=bugs:do-pre-filter to force "pre-filter"
9.2.3 060626 new http.c: HTTPCONF=bugs:no-cfi-delay to force imm. CFI insertion
9.2.3 060626 new syslog.c: enabled bind. syslog src. port. as SRCIF=:514:syslog
9.2.3 060624 mod {conf,script}.c: ${EXECDIR} in DGPATH, DATAPATH, SUBIN, ...
9.2.3 060624 new delegated.c: dir. in symbolic links of executable into LIBPATH
9.2.3 060624 fix delegated.c: enabled DGROOT="../dir"
9.2.3 060623 mod filter.c: don't use a command shell by system() if unncessary
9.2.3 060623 mod param.c: conv. DGROOT=rel-path to abs-path in argv[] (Win)
9.2.3 060623 mod delegated.c: pass DGROOT=abs-path in argv[] to childlen (Win)
9.2.3 060623 fix {delegated,filter}.c: finding EXECDIR of self in PATH
9.2.3 060623 fix filter.c: fixed possible SEGV with CFI on fileno(NULL)
9.2.3 060622 mod process.:c removed the delay by msleep(100) for CFI on Win
9.2.3 060622 new delegated.c: -vT3 -vT6 ... for log. time stamp in milli/micro
9.2.3 060622 fix delegated.c: don't check the config. for "DeleGate"(8.9.6/Win)
9.2.3 060622 mod filter.c: don't insert pre-filter for FTOCL of CFIscript (Win)
9.2.3 060622 mod http.c: delayed inserting CFIscript until response relay.
9.2.3 060621 fix ftp.c: fixed listing symbolic links in MLSD <Steffen>
9.2.3 060621 fix nbio.c: repaired SSLway (STLS=fcl) (9.2.3-pre1)<suzuki_h>
9.2.3 060617 new syslog.c: enabled SYSLOG=-vs,-vh,file:/path
9.2.3 060617 new syslog.c: enabled multiple SYSLOG=syslog//host:port
9.2.3 060617 mod http.c: CMAP=thru-CONNECT:HTTPCONF:https:update.microsoft.com
9.2.3 060617 fix ftp.c: fixed proxying by "USER user@server" (9.2.2)
9.2.3 060617 fix delegated.c: fixed SERVER=ftp://server (disabled in 9.2.2)
9.2.3 060616 new access.c: enabled AUTHORIZER=authServ({user:pass@host:port})
9.2.3 060615 new admin.c: enabled AUTHORIZER=authServ(user) + AUTH=admin::user
9.2.3 060615 new {reshost,String}.c: wildcard "*" in host-name in /etc/hosts
9.2.3 060615 new {reshost,inets}.c: introduced "unknown::*.domain"
9.2.3 060615 fix httphead.c: broken header erasing Cookie "Secure"<xchene>
9.2.3 060614 new backup.c: introduced file copying suppressing identical one
9.2.3 060612 fix JIS.c: broken char-code conv. for UTF-8 and EUC (9.2.0-pre7)
9.2.3 060611 mod nbio.c: Peek() recv(MSG_PEEK) on MacOSX (Darwin8)

9.2.2 060610 new access.c: enabled authServ "host..port" as well sa "host/port"
9.2.2 060609 fix {http,httpx}.c: fixed not to wait non-child processes in SSI
9.2.2 060609 fix {filter,http}.c: fixed to wait pre-filter process
9.2.2 060609 fix http.c: fixed to stop Keep-Alive with FFROMSV
9.2.2 060607 fix cfi.c: fixed FTOCL=xxx.cfi on Windows (9.2.0)<xchene>
9.2.2 060607 new dl.c: added DYLIB="+,lib*.so.0.9.7"(for Debian3.1 for a while)
9.2.2 060607 fix ddi.c: resetting (ClientAuth.i_stat & AUTH_FORW) on Keep-Alive
9.2.2 060606 fix String.c: protoList as CMAP=sslway:FSV:ftps,https (9.1.1)
9.2.2 060605 new inets.c: introduced RES_WAIT=10:WWW.DeleGate.ORG
9.2.2 060604 new access.c: AUTHORIZER=authServ(user@host) to be user at host
9.2.2 060604 fix pop.c: modified to reject non-SSL to POP server with STLS=fsv
9.2.2 060604 add {pop,stls}.c: modified to do implicit SSL for "pop3s" protocol
9.2.2 060604 add pop.c: supported "pop3s://serv" in rURL of MOUNT <maurits>
9.2.2 060604 add cfi.c: MIME-Filter like Message-Filter except the status-line
9.2.2 060603 fix ftp.c: suppressed /-stab- MOUNT in proxy mode (by !asproxy)
9.2.2 060602 new mount.c: introduced "!asproxy" MountOption
9.2.2 060603 add access.c: enabled multiple authServ + RELIABLE=user@authServ
9.2.2 060601 fix access.c: auth. serv. after -pam as AUTHORIZER=-pam,-list{a:b}
9.2.2 060601 new access.c: encrypted AUTHORIZER -list{user:pass} in memory
9.2.2 060601 new http.c: using/forwarding auth. in URL "http://user:pass@host"
9.2.2 060531 new {ftp,fstat}.c: partial support for MLST & MLSD
9.2.2 060531 mod ssi.c: unbuffered output from SSI "#exec" and "#include"
9.2.2 060530 fix {cgi,filter}.c: don't inherit the socket of -Pxxx to CGI/SSI 
9.2.2 060529 new {ftpgw,http}.c: coped with large file>4GB in FTP/HTTP gateway
9.2.2 060528 mod ftp.c: STOR over XDC without copying whole data into tmpfile
9.2.2 060528 mod http.c: detach buff. for large text(regardlress of Keep-Alive)
9.2.2 060528 new http.c: coped with logging size info. of large data > 4GB
9.2.2 060528 mod httpd.c: don't read so much (upto 128KB) to guess file-type
9.2.2 060528 fix ftpgw.c: fixed possible truncation of FTP/HTTP Range: data
9.2.2 060528 new {ftp,ftpgw}.c: 64bit Range: header for FTP/HTTP gateway
9.2.2 060528 new {http,httpd}.c: supported 64bits Range: header
9.2.2 060528 fix file.c: Xfwrite emulating fwrite()=0 for reset socket on Win
9.2.2 060527 new ftp.c: fixed orign FTP server on Win with MOUNT to "X:/path/*"
9.2.2 060527 new windows.c: emulate SIGPIPE by SIGABRT
9.2.2 060526 fix ftp.c: enabled FTP STAT with MOUNT to "X:/path/*" on Win
9.2.2 060526 fix file.c: coped with "X:" and "path/" for stat64() on Win
9.2.2 060526 new ftp.c: added MOUNT="/* file:/-stab-/* default"
9.2.2 060526 new lstat.c,file.h: coped with _stati64 (file>4GB) on Windows
9.2.2 060525 new {ftp,msg}.c: supported ABOR for XDC (DeleGate-DeleGate mode)
9.2.2 060525 fix msg.c: fixed XDC/BASE64 encode for triple chained DeleGates
9.2.2 060525 fix {ftp,file}.c: coped with REST > 4GB
9.2.2 060524 fix ftp.c: fixed broken data on EAGAIN/Nonblocking-IO(9.2.2-pre1)
9.2.2 060524 new ftp.c: displaying correct size of large file (> 4GB)
9.2.2 060523 new {ftp,file}.c: reading and writing large file (> 2GB) on Linux
9.2.2 060522 mod {ftp,xferlog}.c: modified file size from int -> int64
9.2.2 060522 new file.h,{file,fstat}.c: introduced FileStat and -DSTAT64
9.2.2 060522 fix ftp.c: don't forward ABOR when loading from cache
9.2.2 060522 mod ftp.c: faster data-relay (reduced delayes by poll())
9.2.2 060522 fix {ftp,cache,fstat}.c: coped with file larger than 2GB<Steffen>
9.2.2 060522 fix ftp.c: coped with SIGXFSZ signal
9.2.2 060518 new cfi.c: introduced Options:NoPerfection
9.2.2 060518 fix ftp.c: cope with authERR by AUTHORIZER as MountOption (9.1.0)
9.2.2 060518 fix conf.c: check & ask DGROOT=relPath before creation

9.2.1 060513 fix delegated.c: ignore -r (from +=file) in a restarted service
9.2.1 060513 fix log.c: logging as a service by non-Administrator/Win(OWNER="")
9.2.1 060513 fix ssi.c: doing chdir() to the base dir. of SHTML (for #exec)
9.2.1 060513 fix http.c: FTOCL + MASTER or transparent-px(GET /p+Host:)(8.8.0)
9.2.1 060512 fix log.c: expireing conn. counter on Win ("too many Keep-Alive")
9.2.1 060511 fix httphead.c: SHTML+FTOCL sends Connection:Close in Keep-Alive
9.2.1 060511 fix {Makefile,file,mime}.c: making MimeKit library
9.2.1 060511 add ssi.c: coped with #echo var=COUNTER url="relative-URLpath"
9.2.1 060508 fix http.c: wait shutdown() while there are children alive
9.2.1 060508 fix admin.c: fixed "#" in a file name into an anchor URL

9.2.0 060507 mod cache.c: unify escaped URLpath (disabled with CACHE=nounify)
9.2.0 060506 mod url.c: modified not to do reverse MOUNT for "#label" only URL
9.2.0 060506 fix ssi.c: revival of reverse MOUNT for local file: (8.9.6)
9.2.0 060506 fix filter.c: fixed freezing cmd.exe for .bat in CGI or SSI
9.2.0 060506 new ssi.c: supported <!--#exec cmd="..." -->
9.2.0 060506 fix cgi.c: don't wait child CGI if it's not active <Vetter>
9.2.0 060504 fix rfc822.c: don't convert "@echo." as a Email in anonymizing
9.2.0 060503 fix {ssi,any2fdif}.c: coped with ISO-2022-JP (with ">) in attr.
9.2.0 060503 fix {ddi,cache}.c: coped with ISO-2022-JP in COUNTER/Conn fmt str.
9.2.0 060503 fix {cgi,windows}.c: coped with CGI program on Windows
9.2.0 060502 new smtpgate.c: introduced REJECT/HEADER:code:fname:[fvalue]
9.2.0 060501 new {smtp,smtpgate}.c: introduced counter for errors
9.2.0 060430 new ssi.c: introduced <!--#config var=name val=... -->
9.2.0 060430 fix access.c: counter for client IP-address via RIDENT
9.2.0 060430 new {domain,smtp,ftp}.c: added TOTAL_HITS for DNS,SMTP,FTP server
9.2.0 060430 new cache.c: introduced "%3,08d" format specifier
9.2.0 060429 new {cache,ssi,http}.c: introduced TOTAL_HITS
9.2.0 060428 new cache.c: introduced %X (last ten clients) and %N (networks)
9.2.0 060426 new ssi.c: introduced sel="ssi,ref,inc" attr in the PAGE_COUNT tag
9.2.0 060426 new {http,ssi}.c: introduced var=REFERER_COUNT
9.2.0 060426 new JIS.c: subst. Shift_JIS only character to EUC/JIS7
9.2.0 060424 fix reshost.c: don't try resolve non-hostname as a hostname
9.2.0 060424 fix vsaddr.c: don't try Win inet_pton() for non-host addr. <snowl>
9.2.0 060421 fix JIS.c: detecting 2bytes UTF-8 at the start of auto. detect.
9.2.0 060420 new cache.c: introduced the COUNTER parameter
9.2.0 060418 new ssi.c: supported <!--#echo var=PAGE_COUNT -->
9.2.0 060418 new {cache,http}.c: introduced URL#count
9.2.0 060417 new dgauth.c: enabled per-client Cookie encryption key like %a %P
9.2.0 060413 new JIS.c: coped with UTF-8 text in SJIS context
9.2.0 060413 new JIS.c: coped with wrong charset=UTF-8 for SJIS or EUC text
9.2.0 060412 mod http.c: allow '\0' in HTML in conversion
9.2.0 060412 mod JIS.c: allow mapping error to Unicode by 0xFD and 0xFE
9.1.2 060411 fix sftp.c: coped with sftp seeking the output file in get
9.2.0 060410 new conf.c: supported DGROOT specified in a relative-path <snowl>
9.2.0 060409 fix hostlist.c: suppressed resolution of reg.exp. as "-*.*"
9.2.0 060409 fix url.c: rewriting multiple xmlns="URL" in a XML tag
9.2.0 060408 new {cgi,htccx}.c: code conversion of %XX in URL for CGI program
9.2.0 060407 new htccx.c: added char. conversion of &#xxxxx; in URL
9.2.0 060407 new JIS.c: added char. conversion of &#xxxxx; with "u-" prefix
9.2.0 060331 mod http.c: don't apply STLS=fsv:https for CONNECT method
9.2.0 060331 new any2fdif.c: supported a text/HTML only message
9.2.0 060330 new {html,nntpgw}.c: showing a text/HTML only article
9.2.0 060330 new html.c: introduced a HTML to plain/text filter
9.2.0 060330 add url.c: supported rewriting XML/RDF/RSS <mizuno>
9.2.0 060329 new httphead.c: introduced HTTPCONF=cryptCookie:attrs:password
9.2.0 060328 mod http.c: enabled reverse MOUNT="fullURL fullURL" as a proxy

9.1.2 060425 fix cfi.c: lost 1st character in CFI Filter on Windows <Vetter>
9.1.2 060420 fix rfc822.c: don't match '@' in ISO-2022 as Email-addr (8.8.0)
9.1.2 060420 fix inetd.c: re-enabled INETD (8.10.3)<ksparacin>
9.1.2 060419 fix any2fdif.c: searching tag attr. with quoted name="name"
9.1.2 060413 fix ftp.c: VStr overflow when running on a host of long name>32
9.1.2 060407 fix urlesc.c: fixed not to unescape %XX in ISO-2022-JP

9.1.2 060406 fix filter.c: SIGSEGV on MOUNT="v r FSV=sslway" (9.0.1) <Vetter>
9.1.2 060404 fix hostlist.c: SIGBUS with '&','|','!' HostList operator (9.0.5)
9.1.2 060329 fix stls.c: supported STLS=fsv with implicit FTPS clients <spohn>

9.1.1 060327 new vsaddr.c: supported FTP EPRT "|1|x.x.x.x|dddd|"
9.1.1 060325 new access.c: enabled AUTHORIZER=asv:proto//POST as a MountOption
9.1.1 060325 new ddi.c: enabled STLS=fsv as a MountOption
9.1.1 060325 fix {filter,master}.c: enabled STLS=fsv:https (should be default)
9.1.1 060325 mod ystring.c: don't abort() on VStr underflow (9.0.6-pre4)
9.1.1 060325 fix access.c: repaired AUTHORIZER=-any (9.0.3-pre3)
9.1.1 060323 fix resolv.c: parsing RRs after SOA in a message
9.1.1 060323 fix ftp.c: don't abort with "Microsoft FTP" <imao>(9.0.6-pre4)
9.1.1 060323 fix svport.c: don't forward to myself (hosts resolved to 0.0.0.0)

9.1.0 060317 fix gzip.c: fixed possible loop in un-gzip zlib:gzread()(9.0.1)
9.1.0 060317 add {ftp,xferlog}.c: logging REST (for Range) like "512+R1024"
9.1.0 060315 mod *.c: mod. buf-sizes to reduce VStr wornings on long hostname
9.1.0 060315 fix String.c: stopped error message of wordscanX() of just in size
9.1.0 060315 fix http.c: fixed broken head. on trunc. Via: without CRLF <imao>
9.1.0 060312 new ftp.c: enabled anon. FTP AUTHORIZER as a MountOption

9.0.6 060310 mod http.c: don't cache response with header not ended with CRLF
9.0.6 060309 fix http.c: retrying POST body at EOF from reused Keep-Alive serv.
9.0.6 060307 mod http.c: checking response HTTP/* with HTTPCONF="rvers:HTTP/1."
9.0.6 060307 add tcprelay.c: enabled SERVER=tcprelay < respfile
9.0.6 060307 mod dl.c: don't repeat DYLIB search on Win32(setting it in environ)
9.0.6 060307 mod delegated.c: modified not to MOUNT /-/ext/ without -Pnnn/admin
9.0.6 060307 fix cgi.c: modified to return 503 NotAvailable on fork() error
9.0.6 060307 add forkexec.c: logging fork() error
9.0.6 060307 fix nntpgw.c: fixed not to allow submitting with bad Auth-Key (!)
9.0.6 060306 mod http.c: stop Keep-Aive and cache of resp. with multi. Cont-Leng
9.0.6 060303 fix inets.c: fixed to run without IPv6
9.0.6 060302 add nbio.c: auto. expansion of SO_SNDBUF on EMSGSIZE for UDP socket
9.0.6 060302 fix sox.c: flushing remaining output on close at remote-agent
9.0.6 060302 fix sox.c: logging elapsed time of connection
9.0.6 060228 fix resolv.c: fixed SEGV by read overrun on malformed DNS packet
9.0.6 060221 fix ystring.c: introduced detecting VStr underflow in buffers
9.0.6 060221 fix sslway.c: return close notify <johan>
9.0.6 060217 new {http,httpd}.c: introduced HTTPCONF=thru-type:application/x-rpm
9.0.6 060216 new url.c: enabled MOUNT="/-/data:* data:* src=-A/MSIE"
9.0.6 060216 add mime.c: enabled anonymizing with MIMECONV=rewaddr + -FdeMime
9.0.6 060215 add {conf,file,dl}.c: introduced -dP option to trace path finding
9.0.6 060208 new {delegated,windows}.c: TIMEOUT=spawn:T and -dW for Win32
9.0.6 060207 add __locking.c: enabled shared lock for Win32 (disabled by -ls)
9.0.6 060207 mod delegated.c: checking the deafult "screen" periodically
9.0.6 060206 fix delegated.c: enabled TIMEOUT=standby:T on Win32
9.0.6 060206 mod inets.c: don't repeat sethostcache() for MOUNTed hosts in HOSTS
9.0.6 060202 mod httpd.c: return 403 Forbidden for unknown internal(not MOUNTed)
9.0.6 060201 fix vsaddr.c: don't use sin6_family (for VC++ without IPv6)
9.0.6 060201 fix delegated.c: fixed restoreing dumped CRYPT for -Pxxx,yyy
9.0.6 060201 mod vsaddr.c: convert "__1" without asking DNS <gklein>
9.0.6 060128 add access.c: intrdocued AUTH=pass:admin:creysalt:PassWord
9.0.6 060128 fix {nntpgw,nntp}.c: fixed RIDENT from NNTP/HTTP with KeepAlive
9.0.6 060128 fix stls.c: fixed ServerFlags for FSV without SSL (for RIDENT)
9.0.6 060122 new {smtp,smtpgate}.c: introduced PROTOLOG ".smtp" for SMTP
9.0.6 060121 fix nntpgw.c: detection of "too wide range" for $N
9.0.6 060120 add ssi.c: enabled "URL.shtml?query"
9.0.6 060117 new {reshost,domain}.c: extended RESOLV=type:addr:dstList":srcList"
9.0.6 051205 new {service,http}.c: selected MASTER in HTTP Cookie and reuse
9.0.6 060116 mod delegated.c: don't do default MOUNT for -Ffunc
9.0.6 060116 fix rfc822.c: fixed possible overflow in Email rewriting (8.10.3)
9.0.6 060113 add {http,httpd}.c: introduced HTTPCONF=default-vhost:...
9.0.6 060112 fix ddi.c: applied BASEURL as a MountOption (for MovedTo)
9.0.6 060104 add credhy.c: introduced Crey encryption without Deffie-Hellman
9.0.6 060103 add {nntp,mime}.c: introduced masking From,Body,signature,...
9.0.6 060102 add {nntp,nntpgw}.c: added forwarding mail to the poster
9.0.6 060101 add pop.c: introduced POPCONF=listmax:30 for NNTP/POP gw.
9.0.6 051228 add ssi.c: introduced <!--#echo var="-enclientid">
9.0.6 051227 fix {http,httpd}.c: supported "Range: X-" format <martin->
9.0.6 051225 add smtpgate.c: enabled REJECT/To: address
9.0.6 051223 fix {delegated,master}.c: fixed RIDENT=server with STLS=fcl
9.0.6 051222 add {smtp,smtpgate}.c: added gateway=name MountOption
9.0.6 051220 fix nntpgw.c: disabled code conv. by uninitizlized buff.
9.0.6 051220 fix {httpd,textconv}.c: break Keep-Alive on code conv (bad ContLen)
9.0.6 051218 fix nntp.c: repetitive NEXT and LAST command as an origin NNTP
9.0.6 051215 add nntp.c: introduced PROTOLOG ".nntp" for NNTP
9.0.6 051215 add mime.c: introduced MIMECONV=headmask
9.0.6 051215 add smtpgate.c: enabled "OUTPUT/From:" and "OUTPUT/Message-ID:"
9.0.6 051212 add smtpgate.c: added "smmdgate", SeviceMail to Majordomo gateway
9.0.6 051210 add {enews,rfc822}.c: introduced <12345@-group.Group> Message-ID

9.0.5 051205 add sox.c: implemented svstats for SockMux
9.0.5 051204 fix {delegated,log}.c: enabled aging "screen.log"
9.0.5 051204 fix stls.c: don't try detection of SSL for URLget(from_myself)
9.0.5 051202 new {version,svstat}.c: introduced DeleGate/x.x.x-fixN
9.0.5 051128 fix mkmake.c: compilation on FreeBSD 5.4 <maenaka>
9.0.5 051124 add admin.c: introduced a FORM interface for management of CA
9.0.5 051124 add sslway.c: stabs for dynamic-linking of RSA functions
9.0.5 051124 add httphead.c: introduced "sign" and "verify" MountOption
9.0.5 051121 add htmlgen.c: introduced default MOUNT for "/-/ext/"
9.0.5 051121 add ddi.c: introduced "thru" MountOption for HTTP RelayTHRU
9.0.5 051118 fix url.c: ignored leading newline in HREF=" CDATA " <SGP00240>
9.0.5 051111 add delegated.c: ADMDIR/exeid for fast CRC32 of executable (-pre4)
9.0.5 051114 add pdft.c: tentative fitler for PDF to text conversion
9.0.5 051114 mod any2fdif.c: don't digest anchor lists in TABLE at the HTML top
9.0.5 051114 add any2fdif.c: -hN option for hops of links to be tracked
9.0.5 051113 fix any2fdif.c: tracking with -r http://server/index.html or so
9.0.5 051106 add {master,admin}.c: enabled REJECT=admin//stop._self_
9.0.5 051106 add delegated.c: introduced SCREEN=expire/N option
9.0.5 051106 add hostlist.c: introduced --expire.N,__hostSet
9.0.5 051104 mod smtpgate.c: escaped unsafe character in mail-box file name
9.0.5 051104 add enews.c: X-Resent-Message-ID and POST Control:add-resent-...
9.0.5 051102 fix http.c: bad /favicon.ico in MASTER-DeleGate (9.0.3) <hina>
9.0.5 051031 add admin.c: visual interface for SCREEN in /-/admin/
9.0.5 051031 add {log,inets}.c: introduced -Fhosts command
9.0.5 051029 add nntpgw.c: article digest in article-list in NNTP/HTTP HTML
9.0.5 051029 add hostlist.c: introduced "__hosts" prefix for external hostSet
9.0.5 051028 fix nntpgw.c: "Up" link for POP/NNTP/HTTP <tomtsuji>
9.0.5 051026 fix httplog.c: escaping '"' to '%22' in HTTP access log
9.0.5 051026 add service.c: supported paired STLS=fcl and STLS=fsv for MASTER
9.0.5 051025 fix any2fdif.c: -c.pdf to be indexed as text <suzuki_h>
9.0.5 051022 add delegated.c: introduced SCREEN="opts:hostList"
9.0.5 051020 mod http.c: logging request timeout as ext. status code 'Q'
9.0.5 051019 add ssi.c: introduced <!--#echo var="-rusage.Format">
9.0.5 051018 fix ystring.c: coped with Xsprintf "%f" (double) on OSF/1
9.0.5 051013 add mimehead.c: decoding EUC-JP and Shift_JIS in non-ASCII head
9.0.5 051012 add http.c: adjusting MAXIMA for timout&keep-alive on heavy load
9.0.5 051012 fix http.c: check implicit STLS=fcl after returnACK in MASTER
9.0.5 051011 fix filter.c: FCL=sslway (built-in) as a Master <martin->(9.0.1)
9.0.5 051008 fix windows.c: destruction of file's mtime+atime on Win32
9.0.5 050927 add delegated.c: apply ${EXECNAME}.conf to -F${EXECNAME} too
9.0.5 050927 fix windows.c: SEGV on bad timestamp (gmtime() returns NULL)
9.0.5 050925 mod {htmlgen,admin}.c: escaped MSIE's strange <BUTTON> spec.
9.0.5 050920 fix {winserv,winreg}.c: don't ask (fgets(stdin)) in service/Win32
9.0.5 050920 fix winserv.c: copy adhoc ADMIN into argv of service on Win32
9.0.5 050915 add JIS.c: introduced CHARSET=guess-and-set to unify encoding
9.0.5 050911 add _-getrusage.c: introduced printing resource usage
9.0.5 050910 add {param,admin}.c: introduced CONFOPT parameter
9.0.5 050909 new admin.c: introduced ${ADMDIR}/initlog and {ADMDIR}/svstats
9.0.5 050909 add install.sh: supported *.dylib install for CHROOT on MacOSX
9.0.5 050909 add script.c: +=fd:N option to load script from a file-descriptor
9.0.5 050909 add delegated.c: introduced -s option to be strict on config. error
9.0.5 050907 add htmlgen.c: ${setenent} and ${~item} to control entity encoding
9.0.5 050907 fix fstat.c: ls_unix on MacOSX (st_size != long int)
9.0.5 050830 add access.c: introduced -list{user:MD5:md5(pass)}
9.0.5 050829 add access.c: enabled AUTH="admin" for AUTH="admin:-pam:%O"
9.0.5 050826 add admin.c: introduced line editor for configuration
9.0.5 050826 add delegated.c: introduced soft break to break further sessions
9.0.5 050822 add admin.c: introduced ADMDIR/authlog
9.0.5 050821 add admin.c: introduced /-/admin/showdir/
9.0.5 050821 fix {delegated,log}.c: enabled getting startup-log on Linux
9.0.5 050818 fix access.c: MOUNT AUTHORIZER=sv":P:D:S" part set with AUTH_SET
9.0.5 050817 add admin.c: introduced AUTH=admin:authServ:user":clientHostList"
9.0.5 050816 mod admin.c: don't use "Ident" when AUTH=admin:authServ is given
9.0.5 050816 new svport.c: introduced -Pxxx/admin
9.0.5 050815 fix svport.c: inheriting -Pxxx/udp or -Pxxx/tcp on restart
9.0.5 050815 add {service,hostlist}.c: enabled STLS="fcl:https:-:-Pxxxx"
9.0.5 050815 add {socks,svconf,delegated}.c: SERVER=socks4 and SERVER=socks5
9.0.5 050814 fix delegated.c: inheriting DELEGATE_Modified on Win32
9.0.5 050814 fix windows.c: F.D. array overflow on multiple CloseOnExec (> 8)
9.0.5 050814 fix nntp.c: setCloseOnExec without clearCloseOnExec
9.0.5 050812 fix {admin,cgi}.c: fixed dynamic MOUNT (x.x.x)
9.0.5 050812 fix service.c: dynamic-mount to work with SERVER=http,https
9.0.5 050812 new dgauth.c: introduced -dgauth{user1:pass1,user2:pass2,...}
9.0.5 050811 new mount.c: introduced MountOption "withssl[={cl,sv}]"
9.0.5 050811 mod server.c: auto. SERVER=https (CLNT_PROTO) when STLS=fcl is ON
9.0.5 050811 new admin.c: introduced AUTHORIZER=authServ:"admin"
9.0.5 050811 new {access,admin}.c: introduced AUTH=admin:authServ:userList

9.0.4 050805 htccx.c: fix. empty "charset=" in header by CHARSET=guess (9.0.3)
9.0.4 050804 filter.c: fix. duplicated init. of dynamic-linked sslway (9.0.3)
9.0.4 050803 JIS.c: fix. charset name utf8 -> UTF-8 (after conv. non-JP head)
9.0.4 050801 http.c: add. application/xml to be CHARSET converted and MOUNTed
9.0.4 050731 {log,delegated}.c: new. -fv to put copy of LOGFILE to console too
9.0.4 050731 {sftp,ccache}.c: new. SFTPCC (reusing SFTP session/connection)
9.0.4 050731 {ftpgw,http,url}.c: new. SFTP/HTTP gateway
9.0.4 050731 ftp.c: new. "noanon" MountOption for FTP-MOUNT
9.0.4 050731 ftp.c: mod. immediate login if "/" is MOUNTed to sftp://serv
9.0.4 050730 ftp.c: fix. empty PASV Mode() resp. with MOUNT + login error
9.0.4 050729 {ftp,sftp}.c: new. gateway from FTP client to SFTP server
9.0.4 050728 service.c: mod. STLS=fcl as SSL-only for non STLS proto as tcprelay

9.0.3 050725 {script,filter}.c: added "sslway" and "config" into "-dgauth@admin"
9.0.3 050724 {delegate,srcipt}.c: added encrypted script as +=encrypted.cdh
9.0.3 050723 dgauth.c: repaired Digest auth without SERVER=dguath (8.8.1)
9.0.3 050723 JIS.c: changed guessing of non-JP codes
9.0.3 050723 delegated.c: added getting passphrase by DGAuth user "sslway" 
9.0.3 050723 {sslway,filter}.c: added callback to DeleGate for passphrase
9.0.3 050722 JIS.c: added conversion of {SJIS,EUC} HALF WIDTH KANA to UTF-8
9.0.3 050722 htccx.c: fixed CHARSET=guess (9.0.3-pre32)
9.0.3 050721 stls.c: enabled STLS="fcl,{sslway -cert X:path}" <marya>
9.0.3 050721 filter.c: fixed SEGV on +=http://server/... <marya>(8.0.5)
9.0.3 050721 JIS.c: added conversion to/from JISX0212 in 7bits with "ESC$(D"
9.0.3 050721 JIS.c: added conversion from 2bytes UTF-8
9.0.3 050721 htccx.c: modified to auto. download codemap for CHARSET={Japanese}
9.0.3 050719 JIS.c: added JISX0212 conv. among {Shift_JIS,EUC-JP and utf-8}
9.0.3 050717 {delegated,log}.c: fixed recursive Finish/signal during Finish
9.0.3 050717 http.c: mod. min. leng. of warning for long request line 256->1024
9.0.3 050717 ystring.c: added dumping the conent of the buffer caused overflow
9.0.3 050715 http.c: modified not to convert 304 to 200 for image,video
9.0.3 050715 mount.c: enabled MOUNT="//* //x.*" <sire>
9.0.3 050714 imap.c: coped with AUTHENTICATE/LOGIN for IMAP+AUTHORIZER
9.0.3 050714 {html,http,ssi}.c: treat <?XML ... encoding=cset> as HTTP-EQUIV
9.0.3 050712 delegated.c: enlarged the size of buff. for printed -Pports <kaw>
9.0.3 050711 access.c: enabled AUTHORIZER=-list{u1,u2,...} without password
9.0.3 050711 imap.c: enabled AUTHORIZER for IMAP
9.0.3 050710 master.c: enabled REJECT for source_permitted() (8.4.0)
9.0.3 050710 socks.c: enabled access restriction before peeking request
9.0.3 050710 httphead.c: supported HTTPCONF=add-rhead for origin data (gateway)
9.0.3 050709 nbio.c: fixed relaying from regular file with select()
9.0.3 050707 windows.c: fixed to try receive pid from child only once <bginfo>
9.0.3 050706 httphead.c: added WebDAV methods to default HTTPCONF=methods
9.0.3 050705 http.c: introduced -dC option for debugging character conversion
9.0.3 050703 cfi.c: coped with CFI+external-filter for HTTP on Win32
9.0.3 050702 vsaddr.c: fixed SEGV on strchr(NULL,) in SRCIF=*:N:tcpbound(9.0.0)
9.0.3 050702 ftp.c: added FEAT response {MDTM,SIZE,EPSV,EPORT}
9.0.3 050701 nbio.c: introduced disconnection when non-SSL packet is detected
9.0.3 050629 http.c: modified not to rewrite charset=xxx when with SVCC=NoConv
9.0.3 050629 http.c: fixed not to rewrite charset= if no conversion is done
9.0.3 050629 JIS.c: fixed to distinguish unknown charset from abbrev. JIS name
9.0.3 050625 windows.c: fixed not to wait3 child on select error <bginfo>
9.0.3 050624 ystring.h: modified for porting to Solaris2.X
9.0.3 050624 vsaddr.c: fixed FTP EPSV/EPRT port number on little endian <hina>
9.0.3 050624 vsaddr.c: fixed judgement of IPv6 address with "%scope" on BSD
9.0.3 050624 inets.c: fixed IPv6 address respresentation for little endien
9.0.3 050623 {nntp,enews}.c: fixed spool for non-std port NNTP on Win32 <damir>
9.0.3 050622 html.c: extended the size of URICONV set tag/attributes to 64bits
9.0.3 050622 nbio.c: fixed not to break SSLtunnel by non-half-dup on SSL ALERT
9.0.3 050619 conf.c: fixed IMG anchor in the CONNECT method error message
9.0.3 050618 JIS.c: fixed EUC / Shift_JIS distinguish for "Matsui"
9.0.3 050617 inets.c: fixed address matching for both IPv4+v6 client <hina>
9.0.3 050617 inets.c: modified the truncation of too long client name (>70)
9.0.3 050616 http.c: added hinting CCX's in-charset by Content-Type:charset
9.0.3 050616 telnet.c: modified to force relay Timing-Mark before Data-Mark
9.0.3 050616 {http,urlesc}.c: fixed to URL-encode reserved ch. in multi-byte ch
9.0.3 050615 telnet.c: modified to relay by a single process & single thread
9.0.3 050615 sox.c: supported relaying OOB over SockMux on BSD
9.0.3 050615 _-select.c: fixed disconnection on OOB over Telnet/SockMux on BSD
9.0.3 050614 {nbio,telnet}.c: supported relaying OOB over tcprelay and Telnet
9.0.3 050613 http.c: fixed not to make broken response by gzip+FTOCL MountOption
9.0.3 050612 http.c: added charset= for Content-Type:application/x-javascript
9.0.3 050612 http.c: added rewriting charset=xxx for application/x-javascript
9.0.3 050611 JIS.c: fixed UTF-8 to UTF-8 conversion
9.0.3 050611 imap.c: fixed not to disconnect server on LOGIN failure <suzuki_h>
9.0.3 050610 http.c: introduced DeleGate-Control-SVCC cookie
9.0.3 050610 JIS.c: fixed UTF-8 to Shift_JIS conversion
9.0.3 050608 _-select.c: added OOB detection on OS without poll() (like MacOSX)
9.0.3 050608 *.c: coped with compilation errors on Solaris10 <mk>
9.0.3 050607 httphead.c: introduced "expires=T" MountOption
9.0.3 050602 swft.c: escaped stopping in Compressed SWF (with URICONV=where:any)
9.0.3 050602 {filter,sslway}.c: fixed SSLway both in FSV and FCL (9.0.1)
9.0.3 050601 {reshost,resolv}.c: modified to use unknown cache as a DNS proxy
9.0.3 050601 resolv.c: modified not to retry unknown name as a DNS proxy
9.0.3 050601 http.c: copy charset in HTTP-EQUIV to Content-Type head with guess
9.0.3 050601 http.c: don't remove charset in HTTP-EQUIV with CHARSET=guess
9.0.3 050531 {resolv,inets,hostlist}.c: added RESOLV=dns:x.x.x.x:{192.*,*.local}
9.0.3 050530 resolv.c: fixed not to search SRV record without RESOLV=dns(9.0.0)
9.0.3 050529 nntpgw.c: introduced MHGWCONF=hide:From:from1,from2,...
9.0.3 050527 sslway.c: fixed dynamic linking of SSL on FreeBSD <marya>
9.0.3 050527 delegated.c: MOUNT="/favicon.ico builtin:... onerror" by default
9.0.3 050527 {http,httpd,mount}.c: introduced "onerror" MountOption
9.0.3 050527 httpd.c: enabled "builtin:icons/ysato/..." as rURL in MOUNT
9.0.3 050527 env.c: retrieve env. ver. param. DG_ADMIN in prior to ADMIN
9.0.3 050526 nntpgw.c: fixed "$N" as an article number (Nth before the last)
9.0.3 050526 nntpgw.c: fixed to put error on unknown-Mssage-ID or Auth.err
9.0.3 050526 mount.c: modified not to put port-number for rURL "///x moved"
9.0.3 050525 nntpgw.c: introduced hiding info./message for "anonymous" user
9.0.3 050524 access.c: introduced AUTHORIZER=auth"(mappedUser)" like -none(anon)
9.0.3 050524 access.c: fixed to recognize AUTHORIZER="{a1,a2}" as MOUNT option
9.0.3 050521 notify.c: modified to put the copy of Notify-Mail into LOGFILE
9.0.3 050521 resolv.c: fixed gw. hosts.Dom to DNS for DNSCONF=domain:Dom(9.0.0)
9.0.3 050520 resolv.c: fixed SEGV on relaying empty SOA name (9.0.0)
9.0.3 050520 sox.c: introduced "CONNECT+DATA" and "CONNECTED+DATA" packet
9.0.3 050519 {strrcasestr,filetype}.c: fixed suffix matching <firefly>

8.11.5 050707 http.c: modified to close Keep-Alive for requests with body
8.11.5 050704 notify.c: fixed waiting debugger process
8.11.5 050703 delegated.c: fixed Sticky+conditional-params on Win32 (8.2.0)
8.11.5 050630 windows.c: fixed not to freeze on child sending delayed response
8.11.5 050627 nntp.c: coped with bug in Gcc3.4 with -O2 (inline expansion)
8.11.5 050623 file.c: fixed log and cache for non-standard port on Win32(8.10.3)
8.11.5 050608 _-poll.c: fixed the complation error (since 8.10.3)<mk>

9.0.2 050518 sslway.c: don't use visible file to set default cert/key
9.0.2 050517 resolv.c: fixed not to relay SOA from upstream without RESOLV=dns
9.0.2 050517 reshost.c: fixed bad IPv6 answer for IPv4 from "file","nis"<hina>
9.0.2 050516 vsocket.h: coped with Tru64 (without gethostbyname2())<mogi>
9.0.2 050515 nntp.c: modifed to escape a bug in gcc <derphysiker>
9.0.2 050515 *.c,*.h: coped with 64bits machines (pointer <-> int conversion)
9.0.2 050515 mkmake.c: coped with "make CFLAGS=-m64 LDFLAGS=-m64" (or -m32)
9.0.2 050511 mkmake.c: coped with CC which does not support zero size arrary
9.0.2 050510 ystring.h: modifed to fit VC++ or compilation with -DNONC99
9.0.2 050509 {reshost,inets}.c: fixed SEGV in IPv6/HTTP to MASTER<hina>
9.0.2 050508 ystring.h,*.c: MemFile as the real structure (no size mismatch)
9.0.2 050504 *.c: modified to be compilable as C (with make CFLAGSPLUS="")
9.0.2 050504 http.c: proxy HTTPS-client/HTTP-server with SERVER=https FCL=-fcl

8.11.4 050516 TLEX.c: coped with Tru64 (ctos() in <sys/wait.h>)<mogi>
8.11.4 050510 notify.c: fixed possible infinite loop in debugger on EMERGENCY
8.11.4 050509 http.c: obsoleted X-Locking header
8.11.4 050508 ystring.h: added #include <sys/wait.h> for wait3() on Unix
8.11.4 050508 ystring.h: enlarged MemFile to be enough for 64bits arch.<k.mogi>
8.11.4 050505 socks5.c: fixed SOCKS UDP ASSOC via MASTER (8.7.1) <Hayashinaka>
8.11.4 050504 {JIS,mount,abort}.c: modified to be compiled with gcc4.0 <tan>
8.11.4 050501 version.c: introduced DGSIGN="V.R.P/Y.M.D"
8.11.4 050426 sslway.c: coped with ClientHello with Content-Type:handshake

9.0.1 050502 {filter,sslway}.c: built-in anonymous certificate/private-key
9.0.1 050502 windows.c: implemented dlopen() for Win32 DLL
9.0.1 050502 {filter,sslway}.c: use dl-"sslway" prior to external "sslway"
9.0.1 050501 dl.c: introduced DYLIB=lib*.so,lib*.dylib,...
9.0.1 050501 {filter,gzip}.c: enabled dynamic-link for Zlib (gzip/gunzip)
9.0.1 050430 filter.c: modified to do Keep-Alive for FCL="sslway"
9.0.1 050430 http.c: modified not make penalty delay on /favicon.ico
9.0.1 050430 sslway.c: make SSLway SSL_CTX at the start-up (&copied by fork())
9.0.1 050430 filter.c: resolv full-path of CMAP=command:FILTER at start-up
9.0.1 050430 sslway.c: SSLway as a builtin-filter (dynamically linked)
9.0.1 050430 {mkstab,dl}.c: supported interface for dynamic linker
9.0.1 050429 log.h: fixed SEGV in SSLway on Win32 with -vs option
9.0.1 050428 http.c: implemented RFC2817 HTTP Upgrade to TLS as a server
9.0.1 050428 {delegated,windows}.c: introduced shared file among CFI programs
9.0.1 050427 {http,httphead}.c: modified to do Keep-Alive with STLS=fcl
9.0.1 050427 sslway.c: implemented session cache at the SSL server-side
9.0.1 050427 stls.c: introduced STLS="fcl,-im" option to disable implicit SSL
9.0.1 050427 {stls,service}.c: enabled implicit SSL for any protocol by STLS=fcl
9.0.1 050426 enews.c: modified to enable ':' and space in file name
9.0.1 050425 {nbio,sox}.c: supported TCP_CORK and TCP_NOPUSH in SockMux

9.0.0 050421 hostlist.h: introduced "_4." and "_6." prefix for HostList
9.0.0 050421 {vsocket,vaddr}.h: modified to be compiled with VC++ without IPv6
9.0.0 050421 inets.c: introduced  -P__0:xxxx to accept IPv4-mapped IPv6
9.0.0 050421 {inets,vsaddr}.c: supported HOSTS="v6host/fe80__xx%if"
9.0.0 050419 inets.c: implemented UDP over IPv6
9.0.0 050418 vsaddr.c: supported http://ABCD--1234-5678.ipv6
9.0.0 050418 {ftp,inets,vsaddr}.c: supported EPSV and EPRT for IPv6
9.0.0 050418 {socks5,socks,vsaddr}.c: supported Socks5 IPv6 address for TCP
9.0.0 050415 vsocket.h: coped with non-IPv6 compile time environment
9.0.0 050415 resolv.c: extended to relay SOA as a proxy resolver
9.0.0 050413 resconf.c: introduced RES_TYPES={4|6|46|64}
9.0.0 050411 resolv.c: modified to search A/AAAA of CNAME <hina>
9.0.0 050411 {reshost,rescache}.c: new cache for AAAA "byname" as "byname6"
9.0.0 050410 {hostlist,inets}.c: heuristic mask for IPv6 "FFFF:FFFF:FFFF:FFFF::"
9.0.0 050410 hostlist.c: enabled IPv6 mask like "ffff_ffff__"
9.0.0 050409 inets.c: introduced "-P*:xxxx" to accept IPv4-mapped IPv6
9.0.0 050409 {vsaddr,windows}.c: porting for WinSock (inet_pton())
9.0.0 050408 resolv.c: relaying query/response for AAAA record as a DNS server
9.0.0 050407 {inets,reshost,rescache}.c: extended DNS cache for IPv6
9.0.0 050406 {reshost,resolv}.c: implemented DNS retrieval for AAAA record
9.0.0 050406 {reshost,vsaddr}.c: added inverse DNS retrieval based on RFC1886
9.0.0 050405 {inets,vsaddr}.c: introduced "_" for ":" in IPv6 address notation
9.0.0 050405 {inets,vsaddr}.c: introduced IPv6 socket(),bind() and connect()

TODO in
DeleGate ver9
 IPv6 ... DNS, FTP and so on.
 SSL ... dynamic linking of SSL
 GZIP ... dynamic linking of GZIP, ZLIB
 Dynamic link for modules ... libdelegate.so
 TSP ... time stamp protocol for NNTP/SMTP
 http://-.-/-/certificate/ ... install the certificate of DeleGate
 config
  Install/Config ... directories & default .conf ./{src,DGROOT/{etc,lib,subin}}
  ... the DGROOT is ../ if the delegated is under ../etc
  xinetc ... configuration files for each protocol instead of INETD=...
  HTTP interface for configuration ... also usable for FreyaSX
  ADMIN info and password in the directory?
 Binary distribution packages for Linux, MacOSX and Win32
  ... ${EXECDIR}/.. as the default ${DGROOT}
  ... make install into DGSRC/DGROOT
 Remote admin over HTTPS ... https://delegate/-/admin/ 
 Majordomo/HTTP gateway ... for asahi-net
 CFI ... thread for internal filter
 SockMux ... faster
 SockMux ... HTTP/1.0 connection upgreade to SockMux/x.x
 SockMux ... parallel clients, coupler between clients
 STLS ... for SockMux
 COUPLER protocol again ... as a refrector for simple tunneling
 PVStr(p),AVStr(a) -> char *p, a, automatic translation
 LOG ... multple LOGFILE, more systematic message, syslog()
 LOG ... standard format of access log, for SMTP, POP, NNTP, SOCKS
 FreyaSX ... NNTP/HTTP Next/Prev article with the current search
 FreyaSX+NNTP ... search in newsgroups by *** vin ***
 HomePage (Book mark) editor
 Simple BBS based on SMTP/NNTP
 9.0 NEW DEFALUT
 -- RELAY=nojava obsoleted
 -- URICONV=where:any by default
 -- CMAP=sslway:FSV:https or STLS=fsv:https
 -- stop using Ident protocol in FTP, Telnet, ...
 -- MAXIMA=listen:N <== MAXIMA=delegate:N ?
 MOUNT ... URICONV=where:any
 HTTP ... pipelining
 FTP ... MLST
 https://www.delegate.org/lib/* ... verified with built-in certificate
 Licence manager ... MAX number of clients
 SMTPGATE ... forward plain-text only, mailing-list for DeleGate-En
 COUPLER protocol again ... as a refrector for simple tunneling
 PGP ... SMTP/POP sign/verify using gpg
 ICAP ... for example with ClamAv
 IMAP ... connection cache for IMAP
 PICS ...

(to be 8.11.4 ?)
9.0.0 050419 svport.c: added Ismyself() cache
9.0.0 050419 svport.c: added CLIF_HOST:CLIF_PORT as Ismyself(host,port)
9.0.0 050415 resolv.c: don't return REFUSED when acting as a proxy resolver
9.0.0 050413 resconf.c: introduced RES_NS=dns1,",END."

8.11.3 050421 http.c: fixet to forbid CONNECT by RELAY=no (without RELAY=proxy)
8.11.3 050418 stls.c: fixed to reject non-SSL FTP client with STLS=fcl <lsa>
8.11.3 050417 {master,socks5}.c: fixed Socks5 CONNECT work with FTOSV,FFROMSV
8.11.3 050413 cfi.c: fixed Header-Filter (since 8.10.3)<SGP00240>
8.11.3 050411 httphead.c: fixed Cookie rewriting for HTTPS/HTTP MOUNT <anfrage>
8.11.3 050406 dnsnode.c: fix for relaying DNS inverse query for IPv6 addr.

8.11.2 050403 html.c: added BACKGROUND/TABLE,TR,TD to be MOUNTed <YAMAWAKI>
8.11.2 050401 http.c: fixed SEGV on "badServer" for cached data (6.1.9)
8.11.2 050331 http.c: stopped wordscan VStr err.msg on long Accept-Enc<kyamaguc>
8.11.2 050330 windows.c: changed to try inherited socket for DuplicateHandle
8.11.2 050330 log.c: fixed SEGV on stdout.log creation failure(8.9.3)<spratlen>
8.11.2 050325 windows.c: use WSADuplicateSocket(FATAL: inherited.. not socket)
8.11.2 050325 inets.c: enabled connection timeout (TIMEOUT=con:N) on Win32
8.11.2 050324 imap.c: added IMAPrv1 to CAPABILITY

8.11.1 050314 {mkcpp,*}.c: expand MStr() with #define instead of s[0] for VC++
8.11.1 050314 ftp.c: fixed truncation of large status response message
8.11.1 050314 httpd.c: suppress chunked and put Content-Length:0 for EMPTY.txt
8.11.1 050314 httpd.c: fixed the ability to work as "transparent proxy"(8.9.6)
8.11.1 050302 httpd.c: fixed forward to self vhost if MOUNTed(8.9.6)<kyamaguc>
8.11.1 050301 *.c: converted Msprintf,Mstrcpy,MVStr to sprintf,strcpy,AVStr
8.11.1 050228 mkmake.c: enabled CFLAGSPLUS=-DNONC99
8.11.1 050227 ftp.c: coped with non-PASS server by "CWD //serv" <suzuki_h>
8.11.1 050227 Makefile,mkmake.c: coped with non-C99 complient preprocessors
8.11.1 050227 _spawnvp.c: fixed to include stdlib.h for exit() <tao>
8.11.1 050222 iotimeout.c: fixed resetting sigmask(SLGALRM) on repettive TIMEOUT
8.11.1 050222 inets.c: fixed resetting sigmask(SIGALRM) before longjmp()

8.11.0 050221 ftp.c: coped with non-PASS server via chained FTP-DeleGate<tao>
8.11.0 050217 smtp.c: fixed sending DeleGate-Report <suzuki_h>
8.11.0 050216 ystring.c: fixed broken stack in Xsscanf(8.10.3)<suzuki_h>
8.11.0 050212 subin/Makefile: fixed to refer LDFLAGS to make subin<derphysiker>
8.11.0 050210 maker/mkmake.c: modified to use "-c" when checking CFLAGS
8.11.0 050210 shutter.c: added Abort(exit,reason) -> abort()
8.11.0 050209 ystring.{h,c}: wrapped malloc() functions with error-detection

8.10.6 050204 http.c: fixed relaying POST request (8.10.5)<imao>
8.10.6 050202 rfc822.c: inhibited echoing CRLF in ?_?add-head Proxy-Control
8.10.6 050202 http.c: fixed to stop KeepAlive with client when resp seems broken
8.10.6 050129 http.c: fixed VStr err.msg for HTTP/0.9 request(>32B)(8.10.3)
8.10.6 050128 windows.c: fixed symlink on Win32(8.10.3)
8.10.6 050128 {__link,log}.c: fixed trials of link() on Win32(8.10.3)<bginfo>

8.10.5 050126 ddi.c: fixed to reset D_SERVER on Keep-Alive
8.10.5 050126 httpd.c: fixed to put HTTP header for .dhtml (6.0.0)
8.10.5 050125 delegated.c: enlarged minimum stack-size limit to 2MB
8.10.5 050124 httpd.c: fixed infinite recursion on bad MOUNT for 404-unknown
8.10.5 050124 FMODE.c: fixed binary I/O on Win32 with C++ by VC++ (8.10.3)
8.10.5 050119 httpd.c: stopped wordscan VStr err.msg for long ?query
8.10.5 050119 smtp.c: stopped wordscan VStr err.msg for long RCPT
8.10.5 050118 smtp.c: modified to send EHLO after successful STARTTLS <olaf>
8.10.5 050118 *.c: qualified Strncpy() with PVStr/AVStr
8.10.5 050116 *.c: replaced char *p=q; with refQStr(p,q)
8.10.5 050115 *.c: made defQStr() as const char* from char*
8.10.5 050114 *.c: made PVStr() as const char* from char*

8.10.4 050112 smtp.c: supported NOOP as an origin-SMTP server
8.10.4 050111 http.c: fix for MOUNT with "moved,vhost=..." (8.9.6)
8.10.4 050110 httpd.c: supported "Range:" as an origin HTTP server
8.10.4 050109 url.c: reduced wordscan VStr err.msg. for MOUNT(8.10.3)<suzuki_h>
8.10.4 050108 {ftpgw,ftp}.c: supported "Range:" for FTP/HTTP with REST<poulch>
8.10.4 050108 {stls,smtp}.c: suppress optional STARTTLS with non-STARTTLS serv.
8.10.4 050107 {http,httphead,ftpgw}.c: supported "Range:" for FTP/HTTP
8.10.4 041228 subin/Makefile: fix for linking with PAM library (8.10.3)
8.10.4 041228 imap.c: added filtering STARTTLS capability when unavailable
8.10.4 041225 nntp.c: fixed SEGV on NNTP/NNTP relay (since 8.10.3)
8.10.4 041225 ftp.c: fixed empty resp. with FSV and cached response
8.10.4 041224 stls.c: introduced STLS=FSV,FCL:ConnMap parameter
8.10.4 041223 stls.c: gathered STARTTLS implementations into this file
8.10.4 041223 smtpgate.c: fixed to relay error code for DATA to client
8.10.4 041223 smtp.c: fixed to relay 421 code in greeting to client <olaf>
8.10.4 041222 {Makefile,_-recv.c,snprintf,master}.c: ported to Solaris2.5.1
8.10.4 041222 ystring.h: coped with sigXXX() on Solaris7 <olaf>
8.10.4 041222 {inets,passwd}.c: fixed linking with NIS library(8.10.3)<fsuzuki>
8.10.4 041221 pop.c: enabled CMAP=sslway:FCL:starttls for POP
8.10.4 041220 ftp.c: fixed data jam with FSV after error(ex. RETR /unknown)
8.10.4 041220 ftp.c: enabled CMAP=sslway:FCL:starttls for FTP
8.10.4 041219 smtp.c: fixed SEGV on -smtp-vrfy by access to closed FILE (5.3.0)
8.10.4 041217 {nntp,nntpgw}.c: fixed uninit. buff. ref. on "/unknown-group/"
8.10.4 041216 access.c: fixed SEGV on auth. on PAM by param. mismatch (8.10.3)
8.10.4 041215 smtp.c: fixed relaying EHLO response from origin server (7.4.0)
8.10.4 041215 {smtp,filter}.c: introduced CMAP=sslway:FCL:starttls[:dH:sH]

8.10.3 041208 telnet.c: repaired disabled XDISPLOC substition for 'x' (8.10.0)
8.10.3 041208 telnet.c: fixed disconn. on pending ESC-seq. in code-conv. mode
8.10.3 041208 nntpgw.c: fixed to use '%' in POP/NNTP user name(7.9.11)<suzuki_h>
8.10.3 041208 *.c: changed PVStr(d) from "char *d" to "char *cosnt d"
8.10.3 041207 qastrip.c: removed QA annotations from the distributed files
8.10.3 041207 Makefile: added -lstdc++ and -lc before -lsubst <imao>
8.10.3 041206 abort.c: without including the definition of abort() <imao>
8.10.3 041206 Strftime.c: replaced "long" with "time_t" for portability <imao>
8.10.3 041205 *.c: qualified arrays of misc. types
8.10.3 041205 *.c: marked "char *xxx()..." functions with "const"
8.10.3 041202 ystring.h: fixed the definition of BVStr()
8.10.3 041202 *.c: qualified "char*[]" with "const"
8.10.3 041130 {windows,fpoll}.c: _read() and _write() for stdio/WinSock in C++
8.10.3 041129 Makefile: changed default to compile as C++ with "CFLAGS=-x c++"
8.10.3 041129 Makefile,mkmake.c: changed not to use CFLAGS in ld phase
8.10.3 041128 mkcpp: generate .cpp with expanded __VA_ARGS__ for VC++
8.10.3 041127 *: coped with VC++.net (/TP to be recognized as C++ source)
8.10.3 041126 *: re-ported onto Win32 (with VC++ ver.5)
8.10.3 041125 ystring.h:coped with -O(inline)for VStr by char x[z];enum{xSIZE=z}
8.10.3 041124 {log,String}.c: restored FQDN_hash() as "unsigned int" (8.10.0)
8.10.3 041124 iotimeout.c: verified the size given as parameter by alertVStr()
8.10.3 041124 iotimeout.c: qualified xxxTimeout() functions with QVStr()
8.10.3 041120 smtpgate.c: fixed "ARCHIVE:${seqno}" and "${pid}" (6.1.0)
8.10.3 041120 nntp.c: fixed free() memory for relaying article without "Xref:"
8.10.3 041119 *.c: introduced assertVStr()
8.10.3 041118 src/*.c: qualified local pointer with "const"
8.10.3 041116 *.c: replaced "const char *xxx" as a parameter with "PCStr(xxx)"
8.10.3 041116 *.c: replaced fgets() with Xfgets()
8.10.3 041116 url.c: fixed possibly-unterminated string (6.1.21)
8.10.3 041114 pop.c: fixed mount1(char*with) which must be mount1(int*with)
8.10.3 041113 *.c: replaced fscanf() with fgets()+Xsscanf()
8.10.3 041113 resolv.c: fixed RES_CONF=file:/path (8.9.3)
8.10.3 041112 {delegated,ddi}.c: restored CHARSET= (disabled in 8.10.0)
8.10.3 041112 resolv.c: fixed generating broken query on long (64<=) label
8.10.3 041111 *.c: replaced sscanf() with Xsscanf()
8.10.3 041111 *.c: replaced strncpy() with Xstrncpy()
8.10.3 041110 *.c: replaced sprintf() with Xsprintf()
8.10.3 041108 *.c: replaced strcpy() and strcat() with Xstrcpy() and Xstrcat()
8.10.3 041107 ck.c: introduced PVSTR/AVSTR pairing inconsistency checker
8.10.3 041106 ftp.c: implemented SYST command (for Safari)
8.10.3 041106 */*.c: strcpy(str,str+[0-9]*) -> ovstrcpy() for BC-Gcc
8.10.3 041104 src/*.c: marked writable string arguments with AVStr()
8.10.3 041103 {mimekit,rary,resolvy,filter,teleport,fsx}: marked with AVStr()
8.10.3 041101 */*.c: marked writable string parameters with PVStr()
8.9.7 041028 gendom.c: fixed (read-only) overrun on making generic-domain
8.10.3 041027 */*.h: marked writable (return) string in param. list with PVStr()
8.10.3 041022 */*.c: marked buffer on stack with CStr()

8.10.2 041021 mkmake,md5/Makefile,md5cb.c: modified to take CFLAGS
8.10.2 041021 String.c: fixed pointer array overrun (by NULL) in stoV()
8.10.2 041021 {mime,url,ftp}.c: ovstrcpy() for BC-Gcc
8.10.2 041021 {enews,nntp,Strftime,rfc822,http}.c: ovstrcpy() for BC-Gcc
8.10.2 041020 inets.c: replaced bcmp() with memcmp()
8.10.2 041020 rawcopy.c: automatic detection of BC-Gcc by BOUNDS_CHECKING_OFF
8.10.2 041020 rawcopy.c: bcopy() to memmove() for Bounds-Checking Gcc
8.10.2 041020 *: qualified with "const"
8.10.2 041018 include/mkdef: introduced automatic detection of typedefs

8.10.1 041012 vsocket.h: fixed for making on FreeBSD (socklen_t) <imao>
8.9.7 041012 smtp.c: fixed SEGV on fclose() on callback to bad-SMTP serv.(8.9.3)
8.10.1 041011 dns.h(resolv.c): fixed DNS packet interpretation (8.10.0)
8.10.1 041010 *: fixes for porting onto OS/2 <derek>
8.10.1 041008 svport.c: fixed free() possibly for non-allocated address
8.10.1 041008 *: qualified with "const"

8.10.0 041007 *: re-ported to Zaurus, SunOS5.5
8.10.0 041006 rary,include: ported to VC++
8.10.0 041005 *: back ported to C
8.10.0 041005 filter/*: ported to C++ (sslway,...)
8.10.0 041004 src/nntp*: ported to C++ (NNTP)
8.10.0 041003 src/*: ported to C++ (other protocols)
8.10.0 041002 src/http*: ported to C++ (HTTP)
8.10.0 040929 src/*: ported to C++ (common components)
8.10.0 040928 teleport/*,maker/*,fsx/any2fdif: ported to C++
8.10.0 040927 md5/*,resolvy/*: ported to C++
8.10.0 040926 rary/*: ported to C++
8.10.0 040925 mimekit/*: ported to C++

8.9.7 041012 smtp.c: fixed SEGV on fclose() on callback to bad-SMTP serv.(8.9.3)
8.9.7 041004 httphead.c: fixed undef return affecting Referer /-_- rewriting
8.9.7 041004 X.c: fixed broken value on relaying 4byte int in C-to-S
8.9.7 041001 lock.c: fixed timeout on locking for LOGFILE on non-local file-sys
8.9.7 040930 master.c: fixed applicable size of protocol list of CMAP
8.9.7 040925 mimeconv.c: fixed enMime/deMime HTMLCONV=
8.9.7 040922 http.c: fixed keep-alive on rejection by AUTHORIZER <yasu_>
8.9.7 040920 http.c: fixed TIMEOUT on the 1st response line (8.0.9)
8.9.7 040919 http.c: caching 404 code with HTTPCONF=cache:any
8.9.7 040919 any2fdif.c: enabled recursive retrieval of remote server by -r URL

8.9.6 040915 access.c: added AUTHORIZER=-never
8.9.6 040915 socks5.c: fixed SEGV on broken packet <iocc>
8.9.6 040915 textconv.c: fixed relaying binay data on FTP/HTTP gateway
8.9.6 040915 ftpgw.c: fixed to detect binary by zero value (.iso) <auxo>
8.9.6 040912 httpd.c: introduced MBOX viewer as MBOX?n=N
8.9.6 040910 delegated.c: added loading ${EXECDIR}/${EXECNAME}.conf by default
8.9.6 040910 delegated.c: enabeld DGROOT=${EXECDIR}/.. to ease portable config.
8.9.6 040910 commands.c,log.h: changed to suppress InitLog() for -Ffunc
8.9.6 040909 JIS.c: fixed SEGV on UTF8 conversion with -a (a- CHARSET) option
8.9.6 040909 any2fdif.c: become a part of DeleGate
8.9.6 040907 httpx.c: fixed SEGV by MOUNTed /-/builtin (pre17)<suzuki_h>
8.9.6 040906 httpd.c: enabled MOUNT for icons (/-/builtin/icons/*)
8.9.6 040903 {httpx,ssi}.c: fixed duplicated MOUNT for request in #include
8.9.6 040903 ssi.c: modified to put <PRE> tag for plain/text resp. from #include
8.9.6 040901 http.c: modified to set <META charset> to CCX as input-charset hint
8.9.6 040901 {ssi,JIS}.c: fixed CHARCODE conv. for SSI <!--#include data
8.9.6 040901 ssi.c: added conversion of data by <META HTTP-EQIV charset>
8.9.6 040901 ssi.c: introduced <!--#include ... localize> to let rel. URL asis
8.9.6 040829 {ssi,url,html}.c: enabled conv. of rel. URL in SHTML <!--#include
8.9.6 040828 httpd.c: added hidden redirection from ".html" to ".shtml"
8.9.6 040816 resolv.c: fixed to ignore input with QR flag set (resoponse)<roy>
8.9.6 040815 {httpd,cgi}.c: supported interpretting SSI(text/shtml) from CGI
8.9.6 040812 access.c: added "-none" to emulate no AUTHORIZER <starallo>
8.9.6 040807 telnet.c: enabled AUTHORIZER for bound proxy SERVER=telnet://host
8.9.6 040807 ystring.h,*.c: char *malloc() -> void *malloc() <eimizu>
8.9.6 040729 JIS.c: added two symbols for JIS2B7 sym. to ASCII
8.9.6 040723 mimehead.c: fixed empty line on folding (MimeKit1.8)<amagai-a>
8.9.6 040723 mime.c: fixed deMime for charset=ISO-2022-JP (8.9.5)
8.9.6 040723 mime.c: fixed linkage error (8.9.5)
8.9.6 040723 tcprelay.c: fixed not to be Sticky on stdio/stdin relay (8.9.3)
8.9.6 040716 delegated.c: revival of OVERRIDE (6.0.0)
8.9.6 040715 {service,ddi}.c: made obsolete codes safer
8.9.6 040703 sslway.c: coped with CRL (not confirmed)
8.9.6 040702 mount.c: fixed to restore MOUNTed URL on unmatch by condition
8.9.6 040702 httphead.c: fixed MOUNT for moved (8.9.6pre7)
8.9.6 040702 {http,httpd}.c: enabled "data:" scheme in the right hand of MOUNT
8.9.6 040702 http.c: fixed to use CONNECT "h:p" to match with AUTHORIZER ConnMap
8.9.6 040702 http.c: fix use AUTHORIZER in MOUNT in prior to global AUTHORIZER
8.9.6 040702 http.c: fixed to enable ConnMap for AUTHORIZER <starallo>
8.9.6 040702 ftp.c: fixed SEGV on exit of FTPCC which did SWSERV <Yamazaki>
8.9.6 040701 log.c: fixed "-va" option to work with non "-vs" mode
8.9.6 040701 Makefile: fixed SSL library detection on FreeBSD <oseki>
8.9.6 040630 httpx.c: fixed to pass ClientAuth to SSI #include <derorthaisjg>
8.9.6 040629 ftp.c: fixed SEGV on server EOF->FTPCC (after longjump,dup. fclose)
8.9.6 040626 {ftp,filter}.c: enabled FTOSV,FFROMSV for FTP/HTTP
8.9.6 040625 sslway.c: added I/O retrial on re-handshake <question><hohmann>
8.9.6 040617 httpd.c: fixed to see vhost on access to builtin data(avoid loop)
8.9.6 040615 telnet.c: introduced TELNETCONF=keepalive
8.9.6 040612 {http,url}.c: enabled MOUNT for XML (with URICONV=where:any)
8.9.6 040612 telnet.c: periodical generation of NOP packet on TIMEOUT=idle:0
8.9.6 040612 telnet.c: fixed SEGV on longjmp() during second Host: prompt
8.9.6 040612 cfi.c: fixed garbage added at the end of message (8.8.5)
8.9.6 040610 html.c: added "'" <-> "&apos;" conversion in HTML
8.9.6 040609 JIS.c: fixed "r-" or "a-" CHARSET option (8.9.5)

8.9.5 040608 rfc822.c: fixed mixing CRLF into LF when adding C-T-E
8.9.5 040607 httpd.c: fixed MOUNT for virtual host(8.9.3)<kyamaguc>
8.9.5 040525 JIS.c: modified EUC/SJIS distinction for kana-only EUC string
8.9.5 040519 http.c: fixed overflow by long request message
8.9.5 040518 forkspawn.c: fixed "MAX_DELEGATE" error on Win32 (8.9.4)
8.9.5 040518 JIS.c: -r option to convert CRLF to LF (CHARCODE=r-euc)
8.9.5 040518 {JIS,textconv}.c: -a option (-a-euc) for JIS2B7 sym. to ASCII

8.9.4 040514 ftp.c: reduced serv. sw. on non-CWD access to MOUNT on "ftp://*"
8.9.4 040512 http.c: reduced possible delay in buffering for Gunzip (8.1.0)
8.9.4 040512 http.c: fixed to remove incomplete cache left during Gunzip(8.1.0)
8.9.4 040512 http.c: changed to relay thru "*.gz" data without gunzip/gzip
8.9.4 040512 ftp.c: coped with MS-Ftp server (must close PASV after RETR error)
8.9.4 040511 ftp.c: fixed to inherit PASV from unbound to dup. PASV after bound
8.9.4 040511 nntpgw.c: fixed to disconnect NNTPSERVER on auth error. <jozatan>
8.9.4 040507 {delegated,shutter,cgi}.c: added setStopService on abort in child
8.9.4 040507 smtp.c: fixed for compilation with gcc -O3 (8.9.3)<tan>

8.9.3 040505 {CONF_GOT,README.LIB,README.PGP}: renamed for compiration on Zaurus
8.9.3 040504 sslway.c: fixed possible overflow in certificate (6.1.18) <je>
8.9.3 040421 resconf.c: fixed RES_CONF="file:/path/of/..." (6.1.0) <hca00331a>
8.9.3 040419 httphead.c: fixed Referer MOUNT to cope with vhost <suzuki_h>
8.9.3 040413 http.c: removed delay on repetitive chunkes resp. (8.7.7)<minoran>
8.9.3 040330 {access,ddi}.c: "[date+format]" in AUTHORIZER=-list{user:pass}
8.9.3 040329 mkmake.c: fixed detecting availability of libraries <imao>
8.9.3 040328 urlesc.c: fixed SEGV by overflow on long method (8.8.8)<mthata>
8.9.3 040326 cgi.c: fixed to return 404 for non-existent CGI file
8.9.3 040326 httpd.c: fixed to forbid access to off-limit files by escaped URL
8.9.3 040325 {delegated,log}.c: enabled aging "stdout.log" <smori>
8.9.3 040323 nbio.c: fixed breaking SSL negotiation(8.9.2)<imao>
8.9.3 040323 String.c: fixed SEGV in scan_ListL() for unbalanced as "{list,..."
8.9.3 040319 smtpgate.c: enalbed ACCEPT/To,From <hatate>
8.9.3 040318 {service,smtp}.c: introduced penalty delay for SMTP SPAMmer
8.9.3 040318 log.c: fixed pushing out delayed client process on Win32
8.9.3 040318 smtpgate.c: fixed to try secondary MX lists after failure <olaf>
8.9.3 040315 access.c: introduced AUTHORIZER="-list{user1:pass1,user2:pass2}"
8.9.3 040313 ftp.c: fixed FTP+SSLway (8.8.0)<lupin2000>
8.9.3 040313 smtpgate.c: changed to do BCC after unlocking counter
8.9.3 040313 smtpgate.c: fixed NNTP/SMTP not start POST for msg to be rejected
8.9.3 040311 smtp.c: introduced SMTPCONF=callback to decrease DDoS SPAM
8.9.3 040308 telnet.c: coped with telnet client of WinXP <mjrunge>
8.9.3 040306 {ftp,master}.c: enabled CMAP=filter:FXX:ftp-data//method
8.9.3 040306 udprelay.c: fixed port mapping for TCPrelay by udprelay <gongsu>
8.9.3 040306 delegated.c: changed tcprelay-DeleGate to work as a Sticky server

8.9.2 040226 {http,ddi}.c: enabled MOUNTing SWF by URICONV=where:any
8.9.2 040226 {filter,swft}.c: introduced SWF filter FTOCL=-swft
8.9.2 040226 {filter,cgi}.c: fixed duplicatedly inheriting CGI env.
8.9.2 040226 {filter,mount}.c: introduced "SCRIPT_NAME_BASE" CGI env.
8.9.2 040222 cgi.c: fixed not to make Requeset-Line as CGI env. like HTTP_GET...
8.9.2 040221 swft.c: introduced SWF scanner/translator
8.9.2 040220 maker/Makefile,maker.c: introduced lisubstx.a for SSLLIB
8.9.2 040220 maker.c: changed to show message from linker on config. error
8.9.2 040220 {http,httpd}.c: introduced HTTPCONF=tout-pack-intvl:T
8.9.2 040218 src/Makefile: excluded -lkssl from making delegated<tnakata>(8.6.7)
8.9.2 040216 {http,httpd}.c: introduced HTTPCONF=no-delay for TCP_NODELAY
8.9.2 040215 http.c: changed to flush() after chunk + HTTPCONF=no-flush-chunk
8.9.2 040215 {http,httpd}.c: introduced HTTPCONF=cache:cookie
8.9.2 040215 http.c: changed not to use chunked for cached binary (image) data
8.9.2 040214 cfi.c: enabled filtering POST body with CFI/CGI: <Ammar><Jansen>
8.9.2 040209 nntp.c: fixed SEGV on huge newsgroup LIST
8.9.2 040208 http.c: enabled FTOSV filter to detect end of request message
8.9.2 040208 url.c: fixed detecting URL in STYLE=" ... url('URL') ..."
8.9.2 040208 mount.c: implemented MOUNT="= *%pattern$"
8.9.2 040204 mount.c: fixed reverse mount of "p://s/u" by MOUNT="/v/* p://s/u/*" (8.6.0) ... which fixes newsgroup name URL in HREF in NNTP/HTTP page
8.9.2 040203 ftp.c: fixed to cope with '4xx' response <tashiro@furukawa>
8.9.2 040203 nbio.c: introduced timeout by interval between packets
8.9.2 040203 smtpgate.c: introduced "INHERIT:spooler" as a terminal spooler
8.9.2 040201 String.c: fixed SEGV on MOUNT="= *%S"

8.9.1 040202 nbio.c: fixed detection of non-halfdup relay on SSLtunnel(8.8.8)
8.9.1 040201 flter.c: fixed FSV=-tee-h not to change the boundary of packets
8.9.1 040131 http.c: Basic/Digest conv. be optional (HTTPCONF=bugs:do-authconv)
8.9.1 040131 http.c: fixed Basic to Digest auth. conv. (8.8.0)<nihon-yanagi>
8.9.1 040130 http.c: fixed delay on CONNECT in chained DeleGate(8.8.8)<hina>

8.9.0 041228 smtp.c: coped with non 5yz error code from SMTP server <O.Pueschel>
8.9.0 040127 http.c: fixed to filter the "Upgrade:" hop-by-hop filter
8.9.0 040125 command.c: introduced -Fverify to verify the RSA sign by DeleGate
8.9.0 040125 http.c: fixed empty resp. for internal page + FCL on Win32 (8.7.7)
8.9.0 040125 sslway.c: coped with "emailAddress" in X.509 certificate as "Email"
8.9.0 040124 httphead.c: fixed /-/icons/ with HTTP/1.1 (keep-alive not-chunked)
8.9.0 04012x conf.c: changed REMITTABLE from https/{443,563} to https/{80,443}

8.8.9 040117 sslway.c: coped with OpenSSL-0.9.7c problem on Win32
8.8.9 040116 admin.c: added /-/admin/account to manage passwords
8.8.9 040115 admin.c: restored AUTH=admin,user"@localhost" as the default(8.8.0)
8.8.9 040115 smtpgate.c: introduced "Errors-To: admin@dom" to notify rejection

8.8.8 040114 httphead.c: Digest/Basic gateway coped with RFC2617
8.8.8 040114 dgauth.c: DGAuth server coped with RFC2617
8.8.8 040114 http.c: added REMITTABLE="ssltunnel" to allow full-duplex CONNECT
8.8.8 040114 http.c: disabled non-HTTPS/full-duplex relay by REMITTABLE="https"
8.8.8 040114 {http,nbio}.c: added HTTPCONF="halfdup" to restrict CONNECT usage
8.8.8 040113 filters/Makefile: fixed to use specified LIBSSL (8.8.0)<imao>
8.8.8 040110 {httphead,dgauth}.c: supported RFC2617 Digest Auth. (for MSIE6)
8.8.8 040110 httphead.c: fixed resp. default "Allowed:" without HTTPCONF=methods
8.8.8 040110 http.c: fixed to escape URL in "405 Method Not Allowed"
8.8.8 040108 {http,relay}.c: applied HTTCONF=max-cka:10 to CONNECT method
8.8.8 040106 http.c: introduced detection & logging non-HTTPS server via CONNECT
8.8.8 040105 dgauth.c: fixed to inherit CRYPT value on "erestart"
8.8.8 040105 delegated.c: fixed to create "stdout.log" on "erestart"
8.8.8 040105 sox.c: fixed to finalize on SIGTERM and swift restart
8.8.8 040104 sox.c: fixed not to freeze by NODELAY/Linux (SOXCONF=nodelay:off)

8.8.7 040103 delegated.c: fixed DGAuth in background DeleGate (8.8.1)
8.8.7 040103 http.c: fixed AUTHORIZER MountOption as origin server (8.7.7)
8.8.7 040103 dgauth.c: fixed to enable AUTHORIZER=-dgauth as MountOption
8.8.7 040103 httpd.c: fixed AUTHORIZER="...@Realm" as MountOption
8.8.7 040103 access.c: fixed AUTHORIZER="-..." as MountOption (7.9.11)
8.8.7 040102 sox.c: fixed CRYPT=pass:... + preamble to work
8.8.7 040102 {dgpam,dgcpnod}.c: fixed to check the gid of the invoker

8.8.6 031231 sox.c: introduced 32bits randome preamble for Credhy
8.8.6 031231 credhy.c: introduced initialization by preamble of random value

8.8.5 031229 http.c: fixed not to try resolve "Cant-GetPeerName"
8.8.5 031229 httpx.c: URLget coped with redireciton by 301/302 (+=http://...)
8.8.5 031229 delegated.c: auto. downloading of mapping table for CHARCODE=utf8
8.8.5 031227 {cfi,smtpgate}.c: fixed truncate(off_t) for MacOSX
8.8.5 031227 credhy.c: changed the default secret rundom number to 64bits
8.8.5 031227 delegated.c: fixed restart by execvp (on SIGHUP,etc.) after CHROOT
8.8.5 031226 sox.c: introduced CRYPT=pass:password for SockMux
8.8.5 031224 {delegated,dgcpnod}.c: CHROOT create /dev/null automatically
8.8.5 031222 conf.c: changed LIBPATH to include ETCDIR (to search .cfi)
8.8.5 031222 delegated.c: CHROOT use the 1st BINSHELL("sh") in PATH than /bin/sh
8.8.5 031221 inets.c: coped with CHROOT with RESOLV=file:/path
8.8.5 031221 {delegated,enews}.c: coexistence of newsgroups with/without CHROOT
8.8.5 031221 sslway.c: randomized text address of sslway
8.8.5 031221 delegated.c: CHROOT automatic copying /etc/{resolv.conf,localtime}
8.8.5 031221 delegated.c: CHROOT changed to pass resolved gethostname()
8.8.5 031221 {script,conf}.c: changed DGPATH (for +=file.cfg) to include ETCDIR
8.8.5 031220 {url,html}.c: rewriting Content-Location
8.8.5 031217 sox.c: fixed not to do SEND data of a connection in CLOSE/CLOSED
8.8.5 031216 credhy.c: faster key calculation by cached power products
8.8.5 031216 httphead.c: allow '_' as a valid char. for HTTPCONF=methods:*

8.7.9 031229 http.c: fixed URLget for +=http://... and MOUNT="/-/builtin"(8.7.7)
8.7.9 031226 ftp.c: fixed FTP/HTTP to server which does not ask PASS
8.7.9 031219 inets.c: fixed -Ph1:pN,h2:pN (8.5.4) <Gesang>

8.8.4 031214 sox.c: introduced SOXCONF=dhkey:{0,1,2,no}
8.8.4 031213 sox.c: introduced negotiation of Credhy key-length (P value)
8.8.4 031213 sox.c: changed the public key-length to 1024bits by default
8.8.4 031213 credhy.c: fixed the power value of 32 bits
8.8.4 031213 credhy.c: faster key calculation
8.8.4 031211 sslway.c: modified to use randstack_call()

8.8.3 031206 mkmake.c: extended not to check substitution on every modification
8.8.3 031206 smtp.c: changed to refer -MX in any case (from notify_ADMIN())
8.8.3 031206 rfc822.c: fixed SEGV with "rewaddr" MountOption in NNTP (8.8.0)
8.8.3 031205 sox.c: fixed not to produce CLOSED packet when already in CLOSE
8.8.3 031205 vsaddr.c: fixed not to freeze at accept() in SocketPair()
8.8.3 031202 sox.c: fixed to ignore packets arrived during closing
8.8.3 031202 {cfi,filter}.c: %{env} subst. for HTTPCONF=add-head, Output-Header
8.8.3 031202 {filter,cgi}.c: inheriting CGI env. ver.s to FTO/FFROM filters

8.7.9 031208 delegated.c: fixed DGAuth on MacOSX (64bit lseek)
8.7.9 031208 file.c: fixed reusing TMPFILE for FTP/HTTP on MacOSX (64bit lseek)
8.7.9 031208 ftp.c: fix for compilation with SunOS4.1 CC (8.6.3)
8.7.9 031208 http.c: fix for compilation with SunOS4.1 CC (8.8.0)
8.7.9 031208 pam.c: fix for compilation with SunOS4.1 CC (8.6.3)
8.7.9 031207 pam.c: fixed CMAP=filter:FXX:httpam to work (8.6.8)
8.7.9 031207 admin.c: fixed SERVER=httpam to work (8.6.8)
8.7.9 031206 rfc822.c: fixed replacement of field value in multi-lines
8.7.9 031206 String.c: fixed SEGV on infinite loop in strsubst()for null pattern

8.8.2 031129 filter.c: inheriting CFI_TYPE env. var. to uni-directional filters
8.8.2 031129 cfi.c: fixed Filter: commands in CFI script (since 8.8.1)
8.8.2 031129 credhy.c: implemented faster (table driven) CRC8
8.8.2 031128 {sox,credhy}.c: fixed SockMux between different byte-order (8.8.1)

8.8.1 031127 dgauth.c: added encryption of DGAuth protocol with Credhy
8.8.1 031127 filter.c: buitlin encryption filter "-credhy" for FSV/FCL
8.8.1 031126 credhy.c: introduced encryption based on CRC and Diffie-Hellman
8.8.1 031123 sox.c: changed to encrypt SockMux protocol by default
8.8.1 031123 {sox,dh}.c: implemented Diffie-Hellman key agreement
8.8.1 031122 access.c: introduced MYAUTH=user:pass:"ssltunnel" for SSLTUNNEL
8.8.1 031121 {access,dgauth,http,httpd}.c: added AUTHORIZER=authServ@RealmValue
8.8.1 031121 ddi.c: fixed file-descriptor consumption on FSV + server KeepAlive
8.8.1 031121 filter.c: supported repetitive server connection with FSV
8.8.1 031120 sox.c: fixed restart with filter (FSV/FCL)
8.8.1 031120 sox.c: swift restart on broken connection without notified RESET
8.8.1 031120 windows.c: added error log on read() for reset connection
8.8.1 031120 sox.c: fixed infinite loop on connection reset (in POLL_ERROR)
8.8.1 031120 sox.c: fixed Forbidden with FCL without RELIABLE=.localnet (8.8.0)

8.7.8 031128 inets.:c fixed REUSEADDR for SRCIF + FTP PASV/PORT (8.2.1 for Win)
8.7.8 031122 master.c: fixed SSLTUNNEL + HTTP-DeleGate (8.4.0)<koenig>

8.8.0 031116 {http,filter}.c: enabled inheriting req. head. in env. to raw FTOCL
8.8.0 031116 hostlist.c: added -A/User-Agent as HostList + HOSTLIST=list/A:...
8.8.0 031114 httplog.c: added PROTOLOG=":%s %X" to log session id in cookie
8.8.0 031114 {http,httphead}.c: introduced HTTPCONF=session:cookie
8.8.0 031112 http.c: added Auth. conv. between Basic/client and  Digest/server
8.8.0 031109 httpd.c: introduced "realm=Realm" MountOption
8.8.0 031108 http.c: fixed to avoid shutdown() client's conn. with CFI (8.6.3)
8.8.0 031107 pop.c: added "noapop" MountOption to disable APOP to server <lsa>
8.8.0 031106 httplog.c: added HTTP PROTOLOG form. "%As" for Digest Opaque param.
8.8.0 031106 http.c: enabled Keep-Alive with proxy (& bugs:no-keepaliveproxy)
8.8.0 031106 access.c: enabled a list of multiple authServ in AUTHORIZER
8.8.0 031030 pop.c: implemented relay client APOP to serv. in USER+PASS or APOP
8.8.0 031030 http.c: implemented relaying client Digest-auth. to server's Basic
8.8.0 031024 conf.c: modified to allow RELAY=vhost by default for .localnet
8.8.0 031022 nntpgw.c: modified to put buttons (links) in 404-NotFound  resp.
8.8.0 031021 {nntp,rfc822}.c: added NNTP MountOption "rewaddr={From,Body}:%l@%r"
8.8.0 031017 {pop,access}.c: implemented APOP auth. with AUTHORIZER=-dgauth
